/*DavitMarg*/
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <random>
#include <cassert>
#define LL long long
#define mod 1000000007ll
#define all(v) v.begin(),v.end()
#define MP make_pair
#define PB push_back
using namespace std;

const int N=300005;

int t[4*N],d[4*N];

void build(int v,int l,int r)
{
    t[v]=0;
    d[v]=-1;
    if(l==r)
        return;
    int m=(l+r)/2;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
}

void push(int v,int l,int r,bool f=1)
{
    if(d[v]==-1)
        return;
    if(l!=r)
    {
        d[v*2]=d[v];
        d[v*2+1]=d[v];
        if(f)
        {
            int m=(l+r)/2;
            push(v*2,l,m,0);
            push(v*2+1,m+1,r,0);
        }
    }
    t[v]=(r-l+1)*d[v];
    d[v]=-1;
}

void upd(int v,int l,int r,int i,int j,int val)
{
    if(d[v]==val)
        return;
    push(v,l,r);
    if(i>j)
        return;
    if(l==i && r==j)
    {
        d[v]=val;
        push(v,l,r);
        return;
    }
    int m=(l+r)/2;
    upd(v*2,l,m,i,min(m,j),val);
    upd(v*2+1,m+1,r,max(m+1,i),j,val);
    t[v]=t[v*2]+t[v*2+1];
}


int get(int v,int l,int r,int i,int j)
{
    push(v,l,r);
    if(i>j)
        return 0;
    if(l==i && r==j)
        return t[v];
    int m=(l+r)/2;
    return
        get(v*2,l,m,i,min(m,j))+
        get(v*2+1,m+1,r,max(m+1,i),j);
}

int n,q,tin[N],tout[N],par[N];
vector<int> g[N],ord;

void dfs(int v)
{
    ord.PB(v);
    tin[v]=ord.size()-1;
    for(int i=0;i<g[v].size();i++)
    {
        int to=g[v][i];
        dfs(to);
    }
    tout[v]=ord.size()-1;
}

int main()
{
    cin>>n;
    for(int i=2;i<=n;i++)
    {
        int p;
        scanf("%d",&p);
        g[p].PB(i);
        par[i]=p;
    }
    cin>>q;
    dfs(1);
    build(1,0,n-1);
    while(q--)
    {
        int T,v;
        scanf("%d%d",&T,&v);
        if(T==1)
        {
            upd(1,0,n-1,tin[v],tin[v],1);
        }
        else if(T==2)
        {
            int last=-1;
            while(v)
            {
                if(get(1,0,n-1,tin[v],tin[v])==1)
                {
                    for(int i=0;i<g[v].size();i++)
                    {
                        int to=g[v][i];
                        if(to==last)
                            continue;
                        upd(1,0,n-1,tin[to],tin[to],1);
                    }
                    upd(1,0,n-1,tin[v],tin[v],0);
                }
                last=v;
                v=par[v];
            }
        }
        else if(T==3)
        {
            vector<int> x;
            upd(1,0,n-1,tin[v],tin[v],0);
            for(int i=0;i<g[v].size();i++)
            {
                int to=g[v][i];
                upd(1,0,n-1,tin[to],tin[to],0);
            }
        }
        else
        {
            //cout<<"!!!!";
            printf("%d\n",get(1,0,n-1,tin[v],tout[v]));
        }
    }
    return 0;
}



/*

5
1 1 3 3
10
1 1
1 2
1 3
1 4
1 5
3 1
4 1

*/
