#include<bits/stdc++.h>
#define endl '\n'
#define MAX 500024
using namespace std;

int n, m;
vector<int> adj[MAX];
short colours[MAX];
/// 0 - none; {1, 2, 3}

void printSolution()
{
    int answ=1;
    for(int i=1; i<=n; ++i)
        if(answ<colours[i]) answ=colours[i];

    cout<<answ<<endl;

    cout<<colours[1];
    for(int i=2; i<=n; ++i)
        cout<<" "<<colours[i];

    cout<<endl;
    exit(0);
}

void solve(int u)
{
    if(u==n+1)
    {
        printSolution();
    }

    bool one, two, three;
    one=two=three=false;

    for(int i=0; i<adj[u].size(); ++i)
    {
        int v=adj[u][i];
        if(colours[v]==1) one=true;
        else if(colours[v]==2) two=true;
        else if(colours[v]==3) three=true;
    }

    //cout<<u<<" "<<one<<" "<<two<<" "<<three<<endl;

    if(!one && !two && !three)
    {
        colours[u]=1;
        solve(u+1);
        colours[u]=0;

        colours[u]=2;
        solve(u+1);
        colours[u]=0;

        colours[u]=3;
        solve(u+1);
        colours[u]=0;
    }
    else if(one && !two && !three)
    {
        colours[u]=2;
        solve(u+1);
        colours[u]=0;

        colours[u]=3;
        solve(u+1);
        colours[u]=0;
    }
    else if(!one && two && !three)
    {
        colours[u]=1;
        solve(u+1);
        colours[u]=0;

        colours[u]=3;
        solve(u+1);
        colours[u]=0;
    }
    else if(!one && !two && three)
    {
        colours[u]=1;
        solve(u+1);
        colours[u]=0;

        colours[u]=2;
        solve(u+1);
        colours[u]=0;
    }
    else if(one && two && !three)
    {
        colours[u]=3;
        solve(u+1);
        colours[u]=0;
    }
    else if(one && three && !two)
    {
        colours[u]=2;
        solve(u+1);
        colours[u]=0;
    }
    else if(two && three && !one)
    {
        colours[u]=1;
        solve(u+1);
        colours[u]=0;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>m;

    int u, v;
    for(int i=0; i<m; ++i)
    {
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    colours[1]=1;
    solve(2);

    return 0;
}

/*

test:
7 11
1 2
2 3
3 4
4 5
5 6
6 7
7 1
2 7
2 6
3 6
4 6

6 5
1 2
2 3
1 4
3 4
6 5

*/

