#include<bits/stdc++.h>
#define endl '\n'
#define MAX 300024
using namespace std;

int n, q;
struct vr
{
    vector<int> kids;
    int parent;
    int inf=0; /// count of infected below
    bool state=0; /// 1 - infected
    int prevState=0;
    int level;
};

vr tree[MAX];

void infect(int x)
{
    tree[x].state=1;
    /*tree[x].inf++;

    while(x!=1)
    {
        x=tree[x].parent;
        tree[x].inf++;
    }*/
}

void heal(int x)
{
    tree[x].state=0;
    /*tree[x].inf--;

    while(x!=1)
    {
        x=tree[x].parent;
        tree[x].inf--;
    }*/
}

void printTree()
{
    for(int i=1; i<=n; ++i)
    {
        cout<<i<<": "<<tree[i].state<<" "<<tree[i].inf<<endl;
        //cout<<endl;
    }
    cout<<"----------------"<<endl;
}

int update(int idx)
{
    int r=0;
    if(!tree[idx].state && tree[idx].prevState) r--;
    if(tree[idx].state && !tree[idx].prevState) r++;

    //cout<<tree[idx].state<<" "<<tree[idx].prevState<<" "<<idx<<endl;
    for(int i=0; i<tree[idx].kids.size(); ++i)
        r+=update(tree[idx].kids[i]);

    tree[idx].inf=r;
    return r;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n;
    int p;
    for(int i=1; i<n; ++i)
    {
        int u=i+1;
        cin>>p;
        tree[u].parent=p;
        tree[p].kids.push_back(u);
        tree[u].level=1+tree[p].level;
    }

    /*for(int i=1; i<=n; ++i)
    {
        cout<<i<<" "<<tree[i].parent<<endl;
        for(int j=0; j<tree[i].kids.size(); ++j)
        {
            cout<<tree[i].kids[j]<<" ";
        }
        cout<<endl<<endl;
    }*/

    ///////////////////////////////

    cin>>q;

   // printTree();

    for(int i=0; i<q; ++i)
    {
        short qtype;
        int x;

        cin>>qtype>>x;
        //cout<<endl<<" "<<qtype<<" "<<x<<endl<<endl;

        if(qtype==1)
        {
            if(tree[x].state==0)
            {
                infect(x);
            }
        }
        else if(qtype==2)
        {
           // printTree();
            if(tree[x].state==1)
            {
                heal(x);
                for(int u=0; u<tree[x].kids.size(); ++u)
                {
                    int kid=tree[x].kids[u];
                    if(tree[kid].state==0) infect(kid);
                }
            }

            int prev=x;
            while(x!=1)
            {
                x=tree[x].parent;
                if(tree[x].state==0) { prev=x; continue; }
                heal(x);

                for(int u=0; u<tree[x].kids.size(); ++u)
                {
                    int kid=tree[x].kids[u];
                    if(kid==prev) continue;
                    //cout<<x<<"  "<<kid<<endl;
                    if(tree[kid].state==0) infect(kid);
                }
                prev=x;
            }
           // printTree();
        }
        else if(qtype==3)
        {
            //cout<<x<<" "<<tree[x].state<<endl;
            //cout<<tree[1].inf<<endl;
            if(tree[x].state==1) heal(x);
            //cout<<tree[1].inf<<endl;
            for(int u=0; u<tree[x].kids.size(); ++u)
            {
                int kid=tree[x].kids[u];
               // cout<<kid<<" "<<tree[kid].state<<endl;
                //cout<<tree[1].inf<<endl;
                if(tree[kid].state==1) heal(kid);
                //cout<<tree[1].inf<<endl;
            }
        }
        else // 4
        {
            //printTree();

            tree[1].inf=update(1);

            //printTree();
           // cout<<endl;
            cout<<tree[x].inf<<endl;//<<endl;
        }

        //printTree();
    }

    return 0;
}

/*

5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

11
1 1 3 3 5 5 5 7 8 8
12
1 5
1 1
1 2
1 8
1 10
4 1
4 7
2 10
1 10
3 7
4 2
4 3
*/
