#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>
using namespace std;

int parents[300001];
vector< vector<int> > children;
bool infected[300001];
int ans[300001];
int n, q1;

int main ()
{
    scanf("%d", &n);
    children.resize(n+1);
    parents[1] = 0;
    for (int i=2; i<=n; i++)
    {
        int a;
        scanf("%d", &a);
        parents[i] = a;
        children[a].push_back(i);
    }
    scanf("%d", &q1);
    for (int i=0; i<q1; i++)
    {
        int query, par;
        scanf("%d%d", &query, &par);
        if (query == 1)
        {
            if (!infected[par])
            {
                infected[par] = true;
                while (par > 0)
                {
                    ans[par]++;
                    par = parents[par];
                }
            }
        }
        else if (query == 3)
        {
            int remove=0;
            for (int j=0; j<children[par].size(); j++)
            {
                if (infected[children[par][j]])
                {
                    infected[children[par][j]] = false;
                    ans[children[par][j]]--;
                    remove++;
                }
            }
            if (infected[par])
            {
                infected[par] = false;
                remove++;
            }
            while (par > 0)
            {
                ans[par]-=remove;
                par = parents[par];
            }
        }
        else if (query == 2)
        {
//            int prev = par, cur = par;
//            while (cur != 0)
//            {
//                if (infected[cur] == true)
//                {
//                    infected[cur] = false;
//                    for (int j=0; j<children[cur].size(); j++)
//                    {
//                        if (children[cur][j] != prev) infected[children[cur][j]] = true;
//                    }
//                }
//                prev = cur;
//                cur = parents[cur];
//            }
            int remove = 0, prev = par, cur = par;
            while (cur != 0)
            {
                if (infected[cur])
                {
                    remove++;
                    infected[cur] = false;
                    for (int j=0; j<children[cur].size(); j++)
                    {
                        if (children[cur][j] != prev)
                        {
                            if (!infected[children[cur][j]])
                            {
                                infected[children[cur][j]] = true;
                                ans[children[cur][j]]++;
                                remove--;
                            }
                        }
                    }
                }
                ans[cur]-=remove;
                prev = cur;
                cur = parents[cur];
            }
        }
        else if (query == 4)
        {
//            int ret = 0;
//            queue<int> q;
//            q.push(par);
//            if (infected[par] == true) ret++;
//            while (!q.empty())
//            {
//                int top = q.front();
//                q.pop();
//                for (int j=0; j<children[top].size(); j++)
//                {
//                    ret+=infected[children[top][j]];
//                    q.push(children[top][j]);
//                }
//            }
//            cout<<ret<<endl;
            cout<<ans[par]<<endl;
        }
    }
}
/**
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
