#include<iostream>
#include<vector>
#include<cstdio>
#include<queue>
#include<set>
using namespace std;

int ans[500001], clrs = 2;
int n, m;
vector<vector<int> >checkedDrugi;
vector<vector<int> >edges;

struct Edge
{
    int index;
    bool operator< (Edge x) const
    {
        if (checkedDrugi[this->index].size() > checkedDrugi[x.index].size()) return true;
        else if (checkedDrugi[this->index].size() < checkedDrugi[x.index].size()) return false;
        return this->index < x.index;
    }
    Edge(int x) {this->index = x;}
};

int main ()
{
    scanf("%d%d", &n, &m);
    edges.resize(n+1);
    checkedDrugi.resize(n+1);
    for (int i=0; i<m; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    priority_queue<Edge> q;
    for (int i=1; i<=n; i++) q.push(Edge(i));
    while (!q.empty())
    {
        bool present[6];
        for (int i=1; i<=5; i++) present[i] = false;
        int top = q.top().index;
        q.pop();
//        for (int i=1; i<=n; i++) cout<<i<<":"<<ans[i]<<"; ";
//        cout<<endl;
        for (int i=0; i<checkedDrugi[top].size(); i++)
        {
            present[ans[checkedDrugi[top][i]]] = true;
        }
        for (int i=1; i<=5; i++)
        {
            if (present[i] == false)
            {
                ans[top] = i;
                clrs = max(clrs, i);
                break;
            }
        }
        for (int i=0; i<edges[top].size(); i++)
        {
            checkedDrugi[edges[top][i]].push_back(top);
        }
    }
    cout<<clrs<<endl;
    for (int i=1; i<=n; i++) cout<<ans[i]<<" ";
    cout<<endl;
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
