#include<iostream>
#include<vector>
#include<stack>
using namespace std;
const int maxn = 500100;

int par[maxn];
bool inf[maxn];
vector<int> ch[maxn];
int ans[maxn];
int n;

void type1(int i)
{
    if(inf[i])  return;
    inf[i] = true;
    while(i != -1)
    {
        ans[i] ++;
        i = par[i];
    }
}

void type2(int i)
{
    int last = i;
    int change = 0;
    while(i != -1)
    {
        if(inf[i])
        {
            change --;
            for(int j = 0; j < ch[i].size(); j ++)
            {
                if(ch[i][j] != last && !inf[ch[i][j]])
                {
                    change ++;
                    inf[ch[i][j]] = true;
                    ans[ch[i][j]] ++;
                }
            }
            inf[i] = false;
        }
        ans[i] += change;
        last = i;
        i = par[i];
    }
}
void type3(int i)
{
    int change;
    for(int j = 0; j < ch[i].size(); j ++)
    {
        if(inf[ch[i][j]])
        {
            inf[ch[i][j]] = false;
            ans[ch[i][j]] --;
            change --;
        }
    }
    if(inf[i])
    {
        inf[i] = false;
        change --;
    }
    ans[i] += change;

}

void type4(int i)
{
    cout << ans[i] << "\n";
}

void print()
{
    for(int i = 0; i < n; i ++)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    par[0] = -1;
    for(int i = 1; i < n; i ++)
    {
        cin >> par[i];
        par[i] --;
        ch[par[i]].push_back(i);
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++)
    {
        int t, ind;
        cin >> t >> ind;
        ind--;
        if(t == 1)  type1(ind);
        if(t == 2)  type2(ind);
        if(t == 3)  type3(ind);
        if(t == 4)  type4(ind);
        //print();
    }
}
/**
5
1 1 3 3
6
1 3
4 3
1 3
4 3
1 5
4 1
*/
