#include<vector>
#include<stdio.h>
using namespace std;

const int maxn = 600000;
int n, m;

vector<int> e[maxn];

int col[maxn];

bool poss[maxn][4];
bool in_q1[maxn];
bool in_q2[maxn];

int ans = 2;

int st1[maxn], st2[maxn];
int s1, s2;

int bfs2(int st)
{
    s1 = 0;
    s2 = 0;
    st1[s1++] = st;
    in_q1[st] = true;
    while(s1 != 0 || s2 != 0)
    {
        int curr;
        if(s2 != 0)
        {
            curr = st2[--s2];
        } else {
            curr = st1[--s1];
        }


        if(col[curr] != 0)  continue;

        for(int i = 1; i <= 3; i ++)
        {
            if(!poss[curr][i])
            {
                col[curr] = i;
                ans = max(ans, i);
                break;
            }
        }

        for(int i = 0; i < e[curr].size(); i ++)
        {
            int j = e[curr][i];
            if(col[j] == 0)
            {
                poss[j][col[curr]] = true;
                int cnt = poss[j][1] + poss[j][2] + poss[j][3];
                if(cnt == 2 && !in_q2[j])
                {
                    in_q2[j] = true;
                    st2[s2++] = j;
                }
                if(cnt == 1 && !in_q1[j])
                {
                    in_q1[j] = true;
                    st1[s1++] = j;
                }
            }
        }
    }
}


int main()
{
    scanf("%i%i", &n, &m);
    int a, b;
    for(int i = 0; i < n; i ++)
    {
        e[i].reserve(100);
    }
    for(int i = 0; i < m; i ++)
    {
        scanf("%i%i", &a, &b);
        a--;b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }

    for(int i = 0; i < n; i ++)
    {
        if(col[i] == 0)
        {
            bfs2(i);
        }
    }
    printf("%i\n", ans);
    for(int i = 0; i < n; i ++)
    {
        printf("%i ", col[i]);
    }
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
/**
3 3
1 2
2 3
1 3
*/
/**
6 7
1 2
2 3
3 4
4 5
5 6
6 1
2 5
*/
/**
5 7
1 2
2 3
3 4
4 5
5 1
2 5
3 5
*/
/**
5 7
1 2
1 5
4 5
1 3
1 4
2 3
3 4
*/
