#include<iostream>
#include<vector>
#include<queue>
#include<stack>
using namespace std;

const int maxn = 1001000;
int n, m;

vector<int> e[maxn];

int col[maxn];

int bfs(int st)
{
    stack<int> q;
    q.push(st);
    col[st] = 1;
    while(!q.empty())
    {
        int curr = q.top();
        q.pop();
        for(int i = 0; i < e[curr].size(); i ++)
        {
            int j = e[curr][i];
            if(col[j] == 0)
            {
                col[j] = 3 - col[curr];
                q.push(j);
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        a--;b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }
    for(int i = 0; i < n; i ++)
    {
        if(col[i] == 0)
        {
            bfs(i);
        }
    }
    int ans = 2;
    for(int i = 0; i < n; i ++)
    {
        int num[4] = {0,0,0,0};
        for(int j = 0; j < e[i].size(); j ++)
        {
            num[col[e[i][j]]] ++;
        }
        if(num[col[i]] > 0)
        {
            col[i] = 3;
            ans = 3;
        }
    }
    for(int i = 0; i < n; i ++)
    {
        int num[4] = {0,0,0,0};
        for(int j = 0; j < e[i].size(); j ++)
        {
            while(col[i] == col[e[i][j]])
            {

            }
        }
    }
    cout << ans << "\n";
    for(int i = 0; i < n; i ++)
    {
        cout << col[i] << " ";
    }
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
/**
3 3
1 2
2 3
1 3
*/
/**
5 6
1 2
2 3
3 4
4 5
5 1
2 4
*/
