#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
using namespace std;
int n, q;
vector <int> adj [300005];
int par [300005], pos [300005], L [300005], R [300005], R1 [300005];
vector <int> s;
int dfs (int a){
	R [a] = pos [a];
	if (adj [a].size ()) L [a] = s.size () + 1;
	else L [a] = pos [a];
	for (int i : adj [a]){
		s.push_back (i);
		pos [i] = s.size ();
	}
	R1 [a] = s.size ();
	for (int i : adj [a]){
		R [a] = max (R [a], dfs (i));
	}
	return R [a];
}
int t [1200005];
int lazy [1200005];
void updlazy (int l, int r, int pos){
	if (lazy [pos] == 0) return;
	else if (lazy [pos] == 1) t [pos] = r - l + 1;
	else t [pos] = 0;
	if (l < r){
		lazy [pos << 1] = lazy [(pos << 1) + 1] = lazy [pos];
	}
	lazy [pos] = 0;
}
void upd1 (int l, int r, int pos, int x){
	if (l == r){
		lazy [pos] = 0;
		t [pos] = 1;
		return;
	}
	updlazy (l, r, pos);
	int mid = (l + r) >> 1;
	if (x <= mid) upd1(l, mid, pos << 1, x);
	else upd1(mid + 1, r, (pos << 1) + 1, x);
	t [pos] = t [pos << 1] + t [(pos << 1) + 1];
}
void upd2 (int l, int r, int pos, int ql, int qr, int val){
	if (ql <= l && r <= qr){
		lazy [pos] = val;
		updlazy (l, r, pos);
		return;
	}
	if (ql > r || qr < l){
		updlazy (l, r, pos);
		return;
	}
	updlazy (l, r, pos);
	int mid = (l + r) >> 1;
	upd2 (l, mid, pos << 1, ql, qr, val);
	upd2 (mid + 1, r, (pos << 1) + 1, ql, qr, val);
	t [pos] = t [pos << 1] + t [(pos << 1) + 1];
}
int query (int l, int r, int pos, int ql, int qr){
	updlazy (l, r, pos);
	if (ql <= l && r <= qr) return t [pos];
	if (ql > r || qr < l) return 0;
	int mid = (l + r) >> 1;
	return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, (pos << 1) + 1, ql, qr);
}
void ultrasound (int x, int y){
	if (x != 0 && L [x] != pos [x] && query (1, n, 1, pos [x], pos [x])){
		upd2 (1, n, 1, L [x], R1 [x], 1);
	}
	if (y != 0) upd2 (1, n, 1, pos [y], pos [y], -1);
	if (x != 0) ultrasound (par [x], x);
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n;
	for (int i = 2; i <= n; i ++){
		cin >> par [i];
		adj [par [i]].push_back (i);
	}
	s.push_back (1);
	pos [1] = 1;
	dfs (1);
/*	for (int i = 0; i < n; i ++) cout << s [i] << ' ';
	cout << '\n';
	for (int i = 1; i <= n; i ++) cout << pos [i] << ' ';
	cout << '\n';
	for (int i = 1; i <= n; i ++) cout << L [i] << ' ';
	cout << '\n';
	for (int i = 1; i <= n; i ++) cout << R1 [i] << ' ';
	cout << '\n';
	for (int i = 1; i <= n; i ++) cout << R [i] << ' ';
	cout << '\n';*/
	cin >> q;
	for (int i = 0; i < q; i ++){
		int type, x;
		cin >> type >> x;
		if (type == 1){
			upd2 (1, n, 1, pos [x], pos [x], 1);
		}
		else if (type == 2){
			ultrasound (x, 0);
		}
		else if (type == 3){
			upd2 (1, n, 1, pos [x], pos [x], -1);
			if (L [x] != pos [x]) upd2 (1, n, 1, L [x], R1 [x], -1);
		}
		else cout << (L [x] == pos [x] ? 0 : query (1, n, 1, L [x], R [x])) + query (1, n, 1, pos [x], pos [x]) << '\n';
	}

}
