#include <bits/stdc++.h>
using namespace std;
int n, q;
vector <int> adj [300005];
int par [300005], pos [300005], R [300005];
vector <int> s;
int dfs (int a){
	s.push_back (a);
	pos [a] = s.size ();
	R [a] = pos [a];
	for (int i : adj [a]){
		R [a] = dfs (i);
	}
	return R [a];
}
int t [1200005];
bool lazy [1200005];
void updlazy (int l, int r, int pos){
	if (!lazy [pos]) return;
	t [pos] = 0;
	lazy [pos] = 0;
	if (l < r){
		lazy [pos << 1] = 1;
		lazy [(pos << 1) + 1] = 1;
	}
}
void upd1 (int l, int r, int pos, int x){
	if (l == r){
		lazy [pos] = 0;
		t [pos] = 1;
		return;
	}
	updlazy (l, r, pos);
	int mid = (l + r) >> 1;
	if (x <= mid) upd1(l, mid, pos << 1, x);
	else upd1(mid + 1, r, (pos << 1) + 1, x);
	t [pos] = t [pos << 1] + t [(pos << 1) + 1];
}
void upd2 (int l, int r, int pos, int ql, int qr){
	if (ql <= l && r <= qr){
		lazy [pos] = 1;
		updlazy (l, r, pos);
		return;
	}
	if (ql > r || qr < l) return;
	updlazy (l, r, pos);
	int mid = (l + r) >> 1;
	upd2 (l, mid, pos << 1, ql, qr);
	upd2 (mid + 1, r, (pos << 1) + 1, ql, qr);
	t [pos] = t [pos << 1] + t [(pos << 1) + 1];
}
int query (int l, int r, int pos, int ql, int qr){
	updlazy (l, r, pos);
	if (ql <= l && r <= qr) return t [pos];
	if (ql > r || qr < l) return 0;
	int mid = (l + r) >> 1;
	return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, (pos << 1) + 1, ql, qr);
}
void ultrasound (int x, int y){
	if (query (1, n, 1, pos [x], pos [x])){
	for (int i : adj [x]){
		if (i != y) upd1 (1, n, 1, pos [i]);
	}
	}
	upd2 (1, n, 1, pos [x], pos [x]);
	if (x != 1) ultrasound (par [x], x);
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n;
	for (int i = 2; i <= n; i ++){
		cin >> par [i];
		adj [par [i]].push_back (i);
	}
	dfs (1);
	cin >> q;
	for (int i = 0; i < q; i ++){
		int type, x;
		cin >> type >> x;
		if (type == 1){
			upd1 (1, n, 1, pos [x]);
		}
		else if (type == 2){
			ultrasound (x, 0);
		}
		else if (type == 3){
			upd2 (1, n, 1, pos [x], pos [x]);
			for (int y : adj [x]) upd2 (1, n, 1, pos [y], pos [y]);
		}
		else cout << query (1, n, 1, pos [x], R [x]) << '\n';
	}

}
