#include "Sgame.h"
#include<bits/stdc++.h>

using namespace std;

const int nmax=2e6+42;

string inp;

int order[nmax][21];

struct info
{
    int group_1,group_2;
    int id;
};
bool eq(info l,info r)
{
    if(l.group_1!=r.group_1)return 0;
    if(l.group_2!=r.group_2)return 0;
    return 1;
}
info now[nmax];

bool cmp(info a,info b)
{
    if(a.group_1!=b.group_1)return a.group_1<b.group_1;
    if(a.group_2!=b.group_2)return a.group_2<b.group_2;
    return a.id<b.id;
}

int actual[nmax];

int n;

int arr[nmax];

int common(int l,int r)
{
    int ret=0;
    for(int sz=20;sz>=0;sz--)
    {
        //cout<<l<<" "<<r<<" "<<sz<<" "<<order[l][sz]<<" "<<order[r][sz]<<endl;
        if((l+(1<<sz))<=n&&(r+(1<<sz))<=n&&order[l][sz]==order[r][sz])
        {
            ret=ret+(1<<sz);
            l=l+(1<<sz);
            r=r+(1<<sz);
        }
    }

    return ret;
}

pair<int/*mini*/,int/*where*/> take(pair<int/*mini*/,int/*where*/>a,pair<int/*mini*/,int/*where*/>b)
{
    if(a.first<b.first)return a;
    return b;
}
pair<int/*mini*/,int/*where*/> tree[4*nmax];
void seg_tree(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]={arr[l],l};
        return;
    }

    int av=(l+r)/2;
    seg_tree(node*2,l,av);
    seg_tree(node*2+1,av+1,r);

    tree[node]=take(tree[node*2],tree[node*2+1]);
}

pair<int/*mini*/,int/*where*/> query_max(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)return tree[node];
    int av=(l+r)/2;

    pair<int/*mini*/,int/*where*/> ret={n+1,0};

    if(lq<=av)ret=take(ret,query_max(node*2,l,av,lq,min(av,rq)));
    if(av<rq)ret=take(ret,query_max(node*2+1,av+1,r,max(av+1,lq),rq));
    return ret;
}
int to_max[nmax];




int max_tree[nmax*4];

void build_max_tree(int node,int l,int r)
{
    if(l==r)
    {
        max_tree[node]=to_max[l];
        return;
    }

    int av=(l+r)/2;
    build_max_tree(node*2,l,av);
    build_max_tree(node*2+1,av+1,r);

    max_tree[node]=max(max_tree[node*2],max_tree[node*2+1]);
}








void go(int l,int r)
{
    if(l>r)return;

    pair<int,int> w=query_max(1,1,n-1,l,r);

    int av=w.second;

    int val=w.first;

    //cout<<"go "<<l<<" "<<r<<" "<<av<<" "<<val<<endl;

    to_max[val]=max(to_max[val],r-l+2);

    go(l,av-1);
    go(av+1,r);
}
void suffix()
{
    n=inp.size();
    for(int i=0;i<n;i++)
        order[i][0]=inp[i]-'a'+1;

    //for(int i=0;i<n;i++)cout<<order[i][0]<<" ";cout<<endl;

    int sz;
    for(sz=1;(1<<(sz-1))<=n;sz++)
    {
        for(int i=0;i<n;i++)
        {
            now[i].id=i;
            now[i].group_1=order[i][sz-1];

            if((1<<(sz-1))+i<n)now[i].group_2=order[i+(1<<(sz-1))][sz-1];
            else now[i].group_2=-1;

            //cout<<i<<" -> "<<now[i].group_1<<" "<<now[i].group_2<<endl;
        }

        sort(now,now+n,cmp);

        int cur=1;

        for(int j=0;j<n;j++)
        {
            order[now[j].id][sz]=cur;
            if(eq(now[j],now[j+1])==0)cur++;
        }
        //for(int i=0;i<n;i++)cout<<order[i][sz]<<" ";cout<<endl;

    }
    sz--;

    for(int i=0;i<n;i++)
        actual[order[i][sz]]=i;

    //for(int i=1;i<=n;i++)cout<<actual[i]<<" ";cout<<endl;

    for(int i=1;i<n;i++)
        arr[i]=common(actual[i],actual[i+1]);

    if(n>=2)
    {
        seg_tree(1,1,n-1);

        to_max[n]=1;
        go(1,n-1);

        build_max_tree(1,1,n-1);
    }
   // for(int i=1;i<n;i++)cout<<arr[i]<<" ";cout<<endl;
    //cout<<common(3,6)<<endl;


}

void start(char in[])
{
    int i=0;
    while('a'<=in[i]&&in[i]<='z')
    {
        inp.push_back(in[i]);
        i++;
    }

    //reverse(inp.begin(),inp.end());

    suffix();
}



int query_to_max(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)return max_tree[node];
    int av=(l+r)/2;

    int ret=0;

    if(lq<=av)ret=max(ret,query_to_max(node*2,l,av,lq,min(av,rq)));
    if(av<rq)ret=max(ret,query_to_max(node*2+1,av+1,r,max(av+1,lq),rq));
    return ret;
}

int round(int m,int k)
{
    int ret=query_to_max(1,1,n,m,k);

    if(ret==0&&k==n)ret=1;
    return ret;
}
/*
char c[200];
int main()
{
    string ttt="abcabcabcdedea";
    for(int i=0;i<ttt.size();i++)
    {
        c[i]=ttt[i];
    }

    start(c);

    cout<<round(2,3)<<endl;


    cout<<round(1,2)<<endl;
    cout<<round(2,3)<<endl;
    cout<<round(2,2)<<endl;

    cout<<round(1,14)<<endl;
    cout<<round(2,14)<<endl;
    cout<<round(3,14)<<endl;
    cout<<round(4,14)<<endl;
    cout<<round(5,14)<<endl;
    cout<<round(6,14)<<endl;
    cout<<round(7,14)<<endl;


    return 0;
}
*/


