#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42;

int n,m;

pair<int,int> edges[nmax*2];
int id;

int where_to_begin[nmax];

vector<int> current;

bool been[nmax];

void dfs(int node)
{
    if(been[node])return;
    been[node]=1;
    current.push_back(node);

    for(int p=where_to_begin[node];edges[p].first==node;p++)
        dfs(edges[p].second);
}

int test[nmax],colour[nmax];

bool bipar;

void test_dfs(int node,int c)
{
    if(colour[node]&&colour[node]!=c)bipar=0;

    if(bipar==0)return;

    if(colour[node])return;

    colour[node]=c;

    for(int p=where_to_begin[node];edges[p].first==node;p++)
        test_dfs(edges[p].second,3-c);
}

bool can(int node,int c)
{
    for(int p=where_to_begin[node];edges[p].first==node;p++)
        if(colour[edges[p].second]==c)return 0;
    return 1;
}
queue< pair<int/*min degree*/,int/*node*/> > pq,idle;

vector<int> order_to_make;

bool taken[nmax];

int deg[nmax];

void go(int node)
{
    current={};
    dfs(node);

    bipar=1;

    test_dfs(node,1);

    if(bipar)return;

    order_to_make={};

    for(auto k:current)
        {
            colour[k]=0;
        }
    pq=idle;
    for(auto k:current)
        if(deg[k]<=2)pq.push({deg[k],k});

    while(pq.size())
    {
        pair<int/*min degree*/,int/*node*/> now=pq.front();
        pq.pop();

        //cout<<now.first<<" "<<now.second<<endl;

        int node=now.second;

        if(taken[node])continue;

        taken[node]=1;

        //assert(now.first>=-2);

        order_to_make.push_back(node);

        for(int p=where_to_begin[node];edges[p].first==node;p++)
        {
            int k=edges[p].second;
            deg[k]--;
            if(taken[k]==0&&deg[k]<=2)pq.push({deg[k],k});
        }
    }

    reverse(order_to_make.begin(),order_to_make.end());

    //for(auto k:order_to_make)cout<<k<<" ";cout<<endl;

    for(auto k:order_to_make)
    {
        //for(int p=1;p<=n;p++)cout<<colour[p]<<" ";cout<<endl;

            for(int j=1;j<=3;j++)
            if(can(k,j))
            {
                colour[k]=j;
                break;
            }
    }
}

void add_edge(int u,int v)
{
    id++;
    edges[id]={u,v};
    id++;
    edges[id]={v,u};
}
int main()
{
    scanf("%i%i",&n,&m);

    int u,v;
    for(int i=1;i<=m;i++)
    {
        scanf("%i%i",&u,&v);
        add_edge(u,v);
        deg[u]++;
        deg[v]++;
    }

    sort(edges+1,edges+1+id);

    for(int i=id;i>=1;i--)
    {
        where_to_begin[edges[i].first]=i;
    }

    //for(int i=1;i<=n;i++)cout<<where_to_begin[i]<<" ";cout<<endl;

    for(int i=1;i<=n;i++)
    {
        if(been[i]==0)
        {
            go(i);
        }
    }


    int mx=0;
    for(int i=1;i<=n;i++)
        mx=max(mx,colour[i]);

    assert(mx<=3);

    printf("%i\n",mx);
    for(int i=1;i<=n;i++)printf("%i ",colour[i]);
    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

4 5
1 2
2 3
3 4
4 1
2 4

5 7
1 3
1 4
1 2
2 3
3 4
4 5
5 1
*/
