#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int n,m;
vector<int> adj[nmax];

void test_2()
{
    if(n%2)return;

    for(int i=1;i<=n;i++)
        for(auto k:adj[i])
        if(i%2==k%2)return;

    printf("2\n");
    for(int i=1;i<=n;i++)
        printf("%i ",1+i%2);
    exit(0);
}

int colour[nmax];

bool can(int node,int c)
{
    for(auto k:adj[node])
        if(colour[k]==c)return 0;
    return 1;
}
void solve(int l,int r)
{
    /*
    cout<<"solve "<<l<<" "<<r<<endl;
    for(int i=1;i<=n;i++)cout<<colour[i]<<" ";cout<<endl;
    */
    if(r-l<=1)return;

    int prev=l;

    for(auto k:adj[l])
        if(l<k&&k<r&&colour[k]==0)
        {
            for(int j=1;j<=3;j++)
                if(can(k,j))
                {
                    colour[k]=j;
                    break;
                }
            solve(prev,k);
            prev=k;
        }
    if(prev!=l)solve(prev,r);
    else
    {
        //there are no edges in [l,r]
        for(int j=1;j<=3;j++)
            if(can(l+1,j))
            {
                colour[l+1]=j;
                break;
            }
        solve(l+1,r);
    }
}
int main()
{
    scanf("%i%i",&n,&m);

    int u,v;
    for(int i=1;i<=m;i++)
    {
        scanf("%i%i",&u,&v);
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<n;i++)
    {
        adj[i].push_back(i+1);
        adj[i+1].push_back(i);
    }

    adj[1].push_back(n);
    adj[n].push_back(1);

    for(int i=1;i<=n;i++)
        sort(adj[i].begin(),adj[i].end());

    test_2();

    colour[1]=1;

    solve(1,n);

    for(int j=1;j<=3;j++)
        if(can(n,j))
        {
            colour[n]=j;
            break;
        }

    printf("3\n");
    for(int i=1;i<=n;i++)printf("%i ",colour[i]);

    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

5 2
1 3
1 4
*/
