#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int n,m;

pair<int,int> edges_bad[4*nmax];

int where_to_begin[nmax];

int deg[nmax];

int bad_id=0;
void add_edge(int u,int v)
{
    bad_id++;
    edges_bad[bad_id]={u,v};

    bad_id++;
    edges_bad[bad_id]={v,u};
}

pair<int,int> edges[4*nmax];
int id=0;

bool cmp(pair<int,int> a,pair<int,int> b)
{
    if(a.first!=b.first)return a.first<b.first;
    return a.second<b.second;
}

void compress()
{
    sort(edges_bad+1,edges_bad+bad_id,cmp);
    for(int i=1;i<=bad_id;i++)
        if(edges[id]!=edges_bad[i])
        {
            id++;
            edges[id]=edges_bad[i];
        }

    for(int i=1;i<=id;i++)
    {
        deg[edges[i].first]++;
    }
}

void test_2()
{
    for(int i=1;i<=id;i++)
        if(edges[i].first%2==edges[i].second%2)return;

    printf("2\n");
    for(int i=1;i<=n;i++)
        printf("%i ",1+i%2);
    exit(0);
}

int colour[nmax];

bool can(int node,int c)
{
    for(int id=where_to_begin[node];edges[id].first==node;id++)
        if(colour[edges[id].second]==c)return 0;
    return 1;
}

int md(int fake)
{
    while(fake>n)fake=fake-n;

    return fake;
}
int which=-1;
int where(int fake)
{
    fake=fake+n-which;
    fake=md(fake);
    return fake;
}

bool cmp_2(pair<int,int> a,pair<int,int> b)
{
    if(a.first!=b.first)return a.first<b.first;
    return where(a.second)<where(b.second);
}

int inv[nmax];
void solve(int l,int r)
{
    /*
    cout<<"solve "<<l<<" "<<r<<endl;
    for(int i=1;i<=n;i++)cout<<colour[i]<<" ";cout<<endl;
    */
    if(r-l<=1)return;

    int actual_node_l=inv[l];

    //cout<<"actual_node_l "<<actual_node_l<<" -> "<<inv[l]<<endl;

    int prev=l;

    for(int j=where_to_begin[actual_node_l];edges[j].first==actual_node_l;j++)
    {

        //cout<<"edge "<<edges[j].first<<" "<<edges[j].second<<endl;

        if(where(edges[j].second)!=n&&l<where(edges[j].second)&&where(edges[j].second)<r&&colour[edges[j].second]==0)
        {
            //cout<<"colouring "<<edges[j].second<<endl;
            for(int c=1;c<=3;c++)
                if(can(edges[j].second,c))
                {
                    //cout<<edges[j].second<<" was coloured"<<endl;

                    colour[edges[j].second]=c;
                    break;
                }
            solve(prev,where(edges[j].second));
            prev=where(edges[j].second);
        }
    }
    if(prev!=l)solve(prev,r);
    else
    {
        //there are no edges in [l,r]
        for(int j=1;j<=3;j++)
            if(can(l+1,j))
            {
                colour[l+1]=j;
                break;
            }
        solve(l+1,r);
    }
}

int main()
{
    scanf("%i%i",&n,&m);

    int u,v;
    for(int i=1;i<=m;i++)
    {
        scanf("%i%i",&u,&v);
        add_edge(u,v);
    }

    for(int i=1;i<n;i++)
    {
        add_edge(i,i+1);
    }
    add_edge(n,1);

    compress();

    test_2();

    for(int i=1;i<=n;i++)
        if(deg[i]<3)
        {
            which=i;
            break;
        }
    //cout<<"which= "<<which<<endl;

    assert(which!=-1);

    sort(edges+1,edges+id+1,cmp_2);
/*
    for(int i=1;i<=id;i++)
    {
        cout<<edges[i].first<<" "<<edges[i].second<<endl;
    }
*/

    for(int i=id;i>=1;i--)
        where_to_begin[edges[i].first]=i;

    //for(int i=1;i<=n;i++)cout<<where_to_begin[i]<<" ";cout<<endl;

    colour[md(which+1)]=1;

    for(int i=1;i<=n;i++)
        inv[where(i)]=i;

    solve(1,n);

    for(int j=1;j<=3;j++)
        if(can(which,j))
        {
            colour[which]=j;
            break;
        }

    for(int i=1;i<=id;i++)
        assert(colour[edges[i].first]!=colour[edges[i].second]);

    for(int i=1;i<=n;i++)
        assert(colour[i]);

    printf("3\n");
    for(int i=1;i<=n;i++)printf("%i ",colour[i]);

    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

5 2
1 3
1 4

4 1
2 4
*/
