#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 5e5 + 5;

int n, m;
vector <int> nb[N];
int col[N], max_col;

void DFS(int v)
{
    set <int> s;
    s.insert(1); s.insert(2); s.insert(3); s.insert(4);

    for(int u: nb[v])
    {
        if(s.find(col[u]) != s.end())
            s.erase(col[u]);
    }

    col[v] = *s.begin();
    max_col = max(max_col, col[v]);
    for(int u: nb[v])
        if(!col[u])
            DFS(u);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int u, v;

    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v;
        nb[u].pb(v);
        nb[v].pb(u);
    }

    for(int i = 1; i <= n; i++)
        if(!col[i]) DFS(i);

    cout << max_col << endl;
    for(int i = 1; i <= n; i++)
        cout << col[i] << " ";
    cout << endl;

    return 0;
}

/*

6 5
1 2
2 3
1 4
3 4
6 5

*/

