#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 3e5 + 5;

int n, Q, par[N];
vector <int> nb[N];

int from[N], to[N], timer;
void DFS(int v)
{
    from[v] = to[v] = ++timer;
    for(int u: nb[v])
    {
        DFS(u);
        to[v] = max(to[v], to[u]);
    }
}

int fen[N];
void upd(int idx, int x)
{
    for(; idx <= n; idx += (idx & (-idx)))
        fen[idx] += x;
}

int query(int idx)
{
    int res = 0;
    for(; idx > 0; idx -= (idx & (-idx)))
        res += fen[idx];
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int type, v;

    cin >> n;
    for(int i = 2; i <= n; i++)
    {
        cin >> par[i];
        nb[par[i]].pb(i);
    }

    DFS(1);

    cin >> Q;
    while(Q--)
    {
        cin >> type;
        if(type == 1)
        {
            cin >> v;
            upd(from[v], 1);
        }
        if(type == 4)
            cout << query(to[v]) - query(from[v] - 1) << endl;
    }

    return 0;
}
