#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;
const long long mod = 1e9 + 7;
const long long base = 31;
const int maxn = 10000;

map <pair <int, int>, int> mp;
string s;

int tr[maxn * 4];
void update(int v, int l, int r, int pos, int val)
{
    if (l == r)
    {
        tr[v] = max(tr[v], val);

        return;
    }

    int mid = (l + r) / 2;

    if (pos <= mid)
    update(v * 2, l, mid, pos, val);

    else
        update(v * 2 + 1, mid + 1, r, pos, val);
}

int get(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
        return tr[v];

    int mid = (l + r) / 2;

    return max(get(v * 2, l, mid, ll, rr), get(v * 2 + 1, mid + 1, r, ll, rr));
}

int sz;
void start(char w[])
{
    for (int i = 0; w[i] != '\0'; i++)
    s.push_back(w[i]);

    sz = s.size();
    for (int i = 0; i < sz; i++)
    {
        long long curr_hsh = 0;
        for (int j = i; j < sz; j++)
        {
            curr_hsh = (curr_hsh * base + s[j] - 'a' + 1) % mod;
            mp[{j - i + 1, curr_hsh}]++;
        }
    }

    for (auto i: mp)
        update(1, 1, sz, i.first.first, i.second);
}

int round(int m, int k)
{
    return get(1, 1, sz, m, k);
}
