#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5 + 3;

int n, m;
vector <int> adj[maxn];
void read()
{
    cin >> n >> m;

    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }
}

int color[maxn];
bool banned[maxn][4];
void bann(int ver)
{
    for (auto i: adj[ver])
        banned[i][color[ver]] = true;
}

void solve()
{
    for (int i = 1; i <= n; i++)
        sort (adj[i].begin(), adj[i].end());

    cout << 3 << endl;

    for (int i = 1; i <= n; i++)
    {
        if (!color[i])
        {
            for (int j = 1; j <= 3; j++)
                if (!banned[i][j])
            {
                color[i] = j;
                break;
            }
        }

        vector <int> good;
        int idx = -1;
        int allowed;

        for (auto j: adj[i])
            if (!color[j])
        {
            banned[j][color[i]] = true;

            int cnt = 0;
            for (int k = 1; k <= 3; k++)
                if (!banned[j][k])
                cnt++;

            if (cnt == 1)
            {
                idx = j;
                for (int k = 1; k <= 3; k++)
                    if (!banned[j][k])
                    allowed = k;
            }

            good.push_back(j);
        }

        int color1, color2;
            if (color[i] == 1)
                color1 = 2, color2 = 3;

            else
                if (color[i] == 2)
                color1 = 1, color2 = 3;

            else
                color1 = 1, color2 = 2;

        if (idx == -1)
        {
            for (int j = 0; j < good.size(); j++)
            {
                if (j % 2 == 0)
                    color[good[j]] = color1;

                else
                    color[good[j]] = color2;

                    bann(good[j]);
            }
        }

        else
        {
            int idx1;
            for (int j = 0; j < good.size(); j++)
                if (good[j] == idx)
            {
                idx1 = j;
                break;
            }

            for (int j = 0; j < good.size(); j++)
            {
                if (abs(idx1 - j) % 2 == 0)
                    color[good[j]] = allowed;

                else
                {
                    if (color1 != allowed)
                        color[good[j]] = color1;

                    else
                        color[good[j]] = color2;
                }

                bann(good[j]);
            }
        }
    }

    for (int i = 1; i <= n; i++)
        cout << color[i] << " ";

    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
