#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 500000;
int n, m;
vector<int> con[MAXN+10];
int colors[MAXN+10];
int numcl = 1; //number of colors

int used[MAXN+10];

void input()
{
    int temp1, temp2;
    cin>>n>>m;
    for (int i=0; i<m; i++)
    {
        cin>>temp1>>temp2;
        temp1--;--temp2;
        con[temp1].push_back(temp2);
        con[temp2].push_back(temp1);
    }
}

void output()
{
    cout<<numcl<<endl;
    for (int i=0; i<n; i++)
    {
        cout<<colors[i]<<' ';
    }
    cout<<'\n';
}

void dfs(int curr)
{
    used[curr] = 1;
    for (int i=0; i<con[curr].size(); i++)
    {
        if (colors[i]==colors[con[curr][i]]) colors[con[curr][i]]++;
        if (!used[con[curr][i]])
        {
            dfs(con[curr][i]);
        }
    }
}

void solve()
{
    dfs(1);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

/*
6 5
1 2
2 3
1 4
3 4
6 5
*/

