#include <iostream>
#include <cstdio>
#include <vector>
#include <bitset>

using namespace std;

int n,m;
vector<int>gr[50000000];
int color[50000000];
bitset<50000000> used;
void init()
{
    scanf("%d %d",&n,&m);
    int a,b;
    for(int i=0;i<m;i++)
    {
        scanf("%d %d",&a,&b);
        gr[a-1].push_back(b-1);
        gr[b-1].push_back(a-1);
    }
}

void dfs(int node,int prev)
{
    used[node]=1;
    if(prev!=-1)
    {
        if(color[prev]==1)color[node]=2;
        else color[node]=1;
    }
    else
    {
        color[node]=1;
    }
    for(int i=0;i<gr[node].size();i++)
    {
        if(!used[gr[node][i]])
        {
            dfs(gr[node][i],node);
        }
    }
}
int main()
{
    init();
    dfs(0,-1);

    for(int i=0;i<n;i++)
    {
        if(!used[i])dfs(i,-1);
        printf("%d ",color[i]);
    }
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
