#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 3 + 5;

int n;
vector <int> graph[MAXN];
int par[MAXN];

void read_input()
{
    scanf("%d", &n);

    int p;
    for(int i = 0; i < n - 1; i++)
    {
        scanf("%d", &p);
        par[i + 2] = p;
        graph[p].push_back(i + 2);
    }
}

int br = 1;
int tree[2 * MAXN];
int pos[2][MAXN];

void dfs(int v, int p)
{
    pos[0][v] = br++;

    for(auto x : graph[v])
    {
        if(x != p)
        {
            dfs(x, v);
        }
    }

    pos[1][v] = br++;
}

void update(int ind, int val)
{
    for(int i = ind; i < br; i += (i & -i))
    {
        //printf("%d %d\n", i, val);
        tree[i] += val;
    }
}

int query(int ind)
{
    int ans = 0;
    for(int i = ind; i > 0; i -= (i & -i))
    {
        ans += tree[i];
    }
    //printf("%d\n", ans);
    return ans;
}

int query(int l, int r)
{
    return query(r) - query(l - 1);
}

int col[MAXN];

int main()
{
    read_input();
    dfs(1, 1);

    int q;
    scanf("%d", &q);

    int t, v;
    for(int i = 0; i < q; i++)
    {
        scanf("%d %d", &t, &v);
        if(t == 1)
        {
            if(col[v] != 1)
            {
                col[v] = 1;
                update(pos[0][v], 1);
            }
        }
        else if(t == 4)
        {
            printf("%d\n", query(pos[0][v], pos[1][v]));
        }
        else if(t == 3)
        {
            if(col[v] == 1)
            {
                update(pos[0][v], -1);
                col[v] = 0;
            }
            for(auto x : graph[v])
            {
                if(col[x] == 1)
                {
                    update(pos[0][x], -1);
                    col[x] = 0;
                }
            }
        }
        else
        {
            while(v != 0)
            {
                if(col[v] == 1)
                {
                    col[v] = 0;
                    update(pos[0][v], -1);
                }
                for(auto x : graph[v])
                {
                    if(col[x] == 0 && par[x] != v)
                    {
                        update(pos[0][x], 1);
                        col[x] = 1;
                    }
                }

                v = par[v];
            }
        }
    }

    return 0;
}

/*
5
1 1 3 3
*/
