#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 5 + 5;

int n, m;
vector <int> graph[MAXN];

void read_input()
{
    scanf("%d %d", &n, &m);

    int v, w;
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d", &v, &w);

        graph[v].push_back(w);
        graph[w].push_back(v);
    }
}

int col[MAXN];
int par[MAXN];

void dfs(int v, int p)
{
    if(col[v] == 2) return;

    if(col[v] == 1)
    {
        int temp = p;
        vector <int> vr;
        vr.push_back(v);
        while(temp != v)
        {
            vr.push_back(temp);
            temp = par[temp];
        }
        /*for(auto x : vr)
        {
            printf("%d ", x);
        }
        printf("\n");*/
        return;
    }
    par[v] = p;
    col[v] = 1;

    for(auto x : graph[v])
    {
        if(x == p) continue;
        dfs(x, v);
    }

    col[v] = 2;
}

int main()
{
    read_input();

    for(int i = 1; i <= n; i++)
    {
        if(col[i] != 2)
        {
            dfs(i, i);
        }
    }

    return 0;
}

/*
6 5
1 2
2 3
1 4
3 4
6 5
*/

/*
6 7
1 2
2 3
1 4
3 4
6 5
6 4
4 5
*/
