#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e3;
vector<int>graph[MAXN];
vector<pair<int,int> >edge;
///bitset<MAXN>b[MAXN];
bool path[MAXN][MAXN],used[MAXN];
int n,m,color[MAXN];
bool bfs(int v,int col,int mcol)
{
    used[v]=1;
    color[v]=col;
    queue<int>q;
    q.push(v);
    queue<int>C;
    for(int i=2;i<=mcol;i++)C.push(i);
    while(!q.empty())
    {
        int p=q.front();
       // cout<<p<<endl;
        q.pop();
        int d=color[p];
        C.push(d);
        for(int i=0;i<graph[p].size();i++)
        {
            int nb=graph[p][i];
            if(used[nb]==0)
            {
                if(C.empty())return false;
                int cc=C.front();
                used[nb]=1;
                color[nb]=cc;
                q.push(nb);
            }
        }
        C.pop();
    }
    return true;
}
bool check(int x)
{
    memset(used,0,sizeof(used));
    memset(color,0,sizeof(color));
    for(int i=1;i<=n;i++)if(!used[i])if(bfs(i,1,x)==0)return false;
    for(auto i:edge)
    {
        if(color[i.first]==color[i.second])return false;
    }
    return true;
}
int binary()
{
    int l=0,r=n+1,m,ans;
    while(l<=r)
    {
        m=(l+r)>>1;
       // cout<<m<<endl;
        if(check(m)==1)
        {
            ans=m;
            r=m-1;
        }
        else l=m+1;
    }
    return ans;
}
int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int u,v;
        cin>>u>>v;
        if(path[u][v]==path[v][u]&&path[u][v]==0)
        {
            graph[u].push_back(v);
            graph[v].push_back(u);
            edge.push_back({u,v});
        }
        path[u][v]=1;
        path[v][u]=1;
    }
    cout<<binary()<<endl;
    //for(int i=1;i<=n;i++)if(!used[i])bfs(i,1,2);
    for(int i=1;i<=n;i++)cout<<color[i]<<" ";
}
