#include<iostream>
#include<algorithm>
#include<vector>
#include<queue>
#include<cstring>
#define maxn int(5*1e5+5)
using namespace std;

int n;
vector<int>v[maxn];
bool used[maxn];
int ans[maxn],ma;

void bfs(int t)
{
    queue<pair<int,int> >q;
    q.push({t,1});
    ans[t]=1;
    used[t]=true;


    while(!q.empty())
    {
        pair <int,int> p=q.front();
        q.pop();
        used[p.first]=true;

        if(ans[p.first]>p.second)
            continue;

        int j,sz=v[p.first].size();
        for(j=0;j<sz;j++)
        {
            t=v[p.first][j];
            used[t]=true;
            if(p.second==ans[t])
            {
                //cout<<p.first<<" "<<p.second<<" "<<t<<" "<<ans[t]<<endl;;
                ans[t]++;
                //cout<<t<<" ";
                q.push({t,ans[t]});
            }
        }
    }
}

void precomp()
{
    int i;
    for(i=1;i<=n;i++)
        if(!used[i])
            bfs(i);
}

int main()
{
    int i,m,x,y;
    cin>>n>>m;

    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for(i=1;i<=n;i++)
        ans[i]=1;
    //memset(ans,1,sizeof(ans));
    ma=1;
    precomp();

    ma=0;
    for(i=1;i<=n;i++)
        ma=max(ma,ans[i]);

        cout<<ma<<endl;
    for(i=1;i<=n;i++)
        cout<<ans[i]<<" ";
    cout<<endl;
    return 0;
}
/*

6 10
1 2
2 3
1 4
3 4
6 5
1 3
1 6
2 4
5 4
5 1
*/
