#include<iostream>
#include<vector>
#include<queue>
#include<set>
using namespace std;

const int MAX_N = 5 * 1e5 + 5;
vector<int>susedi[MAX_N];
queue <int> q;
int ocv[MAX_N];
bool used[MAX_N];
set<int> pos;

int bfs(int vruh){
	int otg = 1;
	used[vruh] = true;
	q.push(vruh);
	ocv[vruh] = 1;
	while(!q.empty()){
		vruh = q.front();
		q.pop();
		for(int i=0;i<susedi[vruh].size();i++){
			if(!used[susedi[vruh][i]]){
				used[susedi[vruh][i]]=true;
				q.push(susedi[vruh][i]);
			}else{
				if(ocv[susedi[vruh][i]]!=0){
					pos.insert(ocv[susedi[vruh][i]]);
				}
			}
		}
		int last = 0;
		for(set<int>::iterator it = pos.begin();it!=pos.end();it++){
			if((*it)>last+1){
				ocv[vruh] = last+1;
				break;
			}
			last = (*it);
		}
		if(ocv[vruh]==0){
			ocv[vruh] = last+1;
		}
		otg = max(otg,ocv[vruh]);
		pos.clear();
	}
	return otg;
}


int main(){
	cin.tie(0);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<m;i++){
		int a,b;
		cin>>a>>b;
		a--;b--;
		susedi[a].push_back(b);
		susedi[b].push_back(a);
	}
	
	/*
	for(int x=0;x<=n;x++){
		cout<<x<<": ";
		for(int i=0;i<susedi[x].size();i++){
			cout<<susedi[x][i]<<"\n";
		}
	}	
	*/
	int otg = -1;
	//cout<<"maikati"<<flush;
	for(int i=0;i<n;i++){
		if(!used[i]) {
			 otg = max(otg, bfs(i));
		}
	}
	cout<<otg<<"\n";
	for(int i=0;i<n;i++){
		cout<<ocv[i]<<" ";
	}
	cout<<"\n";
}
