#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define NMax 300000

int n, p[NMax + 2], illchild[NMax + 2];
vector<int> nb[NMax + 2];
bool ill[NMax + 2];

void dfs_2(int v, int prev)
{
    if(ill[v] == 1)
    {
        ill[v] = 0;
        for(int i=0; i<nb[v].size(); i++)
            if(nb[v][i] != prev)
                ill[nb[v][i]] = 1;
    }

    if(v != 1) dfs_2(p[v], v);
}

int dfs_4(int v)
{
    int cnt = 0;
    if(ill[v] == 1) cnt = 1;
    if(nb[v].size() == 0) return cnt;

    for(int i=0; i<nb[v].size(); i++)
        cnt+= dfs_4(nb[v][i]);

    return cnt;
}

int dfs_1(int v)
{
    illchild[v] ++;
    if(v != 1) dfs_1(p[v]);
}

int main()
{
    scanf("%d", &n);

    for(int i = 0; i < n-1; i++)
    {
        int par;
        scanf("%d", &par);
        nb[par].push_back(i + 2);
        p[i + 2] = par;
    }

    int q;
    scanf("%d", &q);

    for(int x = 0; x < q; x++)
    {
        int type, nodde;
        scanf("%d%d", &type, &nodde);

        if(type == 1 && ill[nodde] == 0) ill[nodde] = 1, dfs_1(nodde);
        else if(type == 2) dfs_2(nodde, -1);
        else if(type == 3)
        {
            ill[nodde] = 0;
            for(int i = 0; i < nb[nodde].size(); i++)
                ill[nb[nodde][i]] = 0;
        }
        else if(type == 4) printf("%d\n", illchild[nodde]);
    }

    return 0;
}
