#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define NMax 500000

bool used[NMax+2];
int n, m;
int from, to;
vector<int> nb[NMax+2];
int color[NMax+2];

void solve(int v, int col)
{
    color[v] = col;
    for(int i=0; i<nb[v].size(); i++)
    {
        if(used[nb[v][i]]) continue;
        used[nb[v][i]] = 1;
        solve(nb[v][i], (col+1)%2);
    }
}

int main()
{
    scanf("%d%d", &n, &m);

    for(int i=0; i<m; i++)
    {
        scanf("%d%d", &from, &to);
        nb[from].push_back(to);
        nb[to].push_back(from);
    }

    for(int i=1; i<=n; i++)
        if(used[i] == 0)
            solve(i, 0);
    printf("2\n");
    for(int i=1; i<=n; i++)
        printf("%d ", color[i]+1);
    printf("\n");

    return 0;
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
