#include <bits/stdc++.h>
using namespace std;
const int MAXN = 3e5 + 1;
int n,q,inf[MAXN],cnti[MAXN],par[MAXN],ult[MAXN],m,used[MAXN],nump[MAXN];
vector<int> graph[MAXN];
vector<int> path[MAXN];
int sz[MAXN];
struct node{
    int cnti,lazy;
    node()
    {
        cnti = 0;
        lazy = 0;
    }
};
vector<node> tree[MAXN];
stack<int> st;
void find_paths(int s)
{
    used[s] = 1;
    path[m].push_back(s);
    nump[s] = m;
    if(graph[s].size() == 0)
    {
        m++;
        return;
    }
    for(int i = 0; i < graph[s].size(); i++)
    {
        if(!used[graph[s][i]])
        {
            find_paths(graph[s][i]);
        }
    }
}
int find_ind(int x)
{
    int le = 0, ri = path[nump[x]].size() - 1,mid;
    while(le <= ri)
    {
        mid = (le + ri) >> 1;
        if(path[nump[x]][mid] == x) return mid;
        else if(path[nump[x]][mid] > x) ri = mid - 1;
        else le = mid + 1;
    }
}
void printTree(node* tmp,int le,int ri)
{

}
void update_lazy(int numt,int nd,int le,int ri)
{
    tree[numt][nd].cnti += tree[numt][nd].lazy;
    if(le != ri)
    {
        tree[numt][2*nd].lazy += tree[numt][nd].lazy;
        tree[numt][2*nd+1].lazy += tree[numt][nd].lazy;
    }
    tree[numt][nd].lazy = 0;
}
void update_int(int numt,int nd,int le,int ri,int p,int q,int val)
{
    ///cout <<numt << " " << nd << " " << le << " " << ri << " " << p << " " << q << " " << val << endl;
    update_lazy(numt,nd,le,ri);
    if(q < le || p > ri)return;
    if(p <= le && ri <= q)
    {
        tree[numt][nd].cnti += val;
        if(le != ri)
        {
            tree[numt][2*nd].lazy += val;
            tree[numt][2*nd + 1].lazy += val;
        }
        return;
    }
    int mid = (le + ri) >> 1;
    update_int(numt,2*nd,le,mid,p,q,val);
    update_int(numt,2*nd+1,mid+1,ri,p,q,val);
    tree[numt][nd].cnti += tree[numt][2*nd].cnti + tree[numt][2*nd+1].cnti;
}
int query(int numt,int nd,int le,int ri,int x)
{
    update_lazy(numt,nd,le,ri);
    if(x < le || x > ri)return 0;
    if(le == ri)
    {
        return tree[numt][nd].cnti;
    }
    int mid = (le + ri) >> 1;
    return query(numt,2*nd,le,mid,x) + query(numt,2*nd+1,mid+1,ri,x);
}
int main()
{
    ///freopen("input.txt","r",stdin);
    ///freopen("output.txt","w",stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j,p,tp,x;
    cin >> n;
    for(i = 2; i <= n; i++)
    {
        cin >> par[i];
        graph[par[i]].push_back(i);
    }

    find_paths(1);
    for(i = 0; i < m; i++)
    {
        tree[i].resize(2 * path[i].size() + 4);
        sz[i] = path[i].size();
    }
    cin >> q;
    for(i = 1; i <= q; i++)
    {
        cin >> tp >> x;
        if(tp == 1)
        {
            if(inf[x] == 1)continue;
            int f = x;
            while(f)
            {
                ///cout << f << endl;
                int ind = find_ind(f);
                ///cout << ind << endl;
                update_int(nump[f],1,0,sz[i] - 1,0,ind,1);
                ///printTree(roots[nump[f]],0,path[nump[f]].size() - 1);
                f = par[path[nump[f]][0]];
            }
            ///cout << endl;
            inf[x] = 1;

        }
        else if(tp == 2)
        {
            int f = x,prev = x;
            int cntc = 0, cntni = 0;
            while(f)
            {
                if(inf[f] == 1)
                {
                    inf[f] = 0;
                    cntc++;
                    for(j = 0; j < graph[f].size(); j++)
                    {
                        if(graph[f][j] != prev && inf[graph[f][j]] == 0)
                        {
                            inf[graph[f][j]] = 1;
                            cnti[graph[f][j]]++;
                            cntni++;
                        }
                    }
                }
                cnti[f] = cnti[f] - cntc + cntni;
                prev = f;
                f = par[f];
            }
        }
        else if(tp == 3)
        {
            if(inf[x] == 1)
            {
                inf[x] = 0;
                cnti[x]--;
            }
            for(j = 0; j < graph[x].size(); j++)
            {
                if(inf[graph[x][j]] == 1)
                {
                    inf[graph[x][j]] = 0;
                    cnti[graph[x][j]]--;
                    cnti[x]--;
                }
            }
        }
        else if(tp == 4)
        {
            ///cout << cnti[x] << endl;
            int ind = find_ind(x);
            cout << query(nump[x],1,0,sz[i]-1,ind) << endl;;
        }
        /***for(j = 1; j <= n; j++)
        {
            cout << inf[j] << " ";
        }
        cout << endl;
        for(j = 1; j <= n; j++)
        {
            cout << cnti[j] << " ";
        }
        cout << endl;
        cout << "-----------" << endl;*/
    }
}

