#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxN=300005;
int subtree[maxN], par[maxN], n, q;
bitset<maxN> isInf, upd_self, upd_ch, upd_gen;
vector<int> children[maxN];
void update (int ind)
{
    if(ind==-1)return;
    if(upd_ch[ind])return;
    upd_ch[ind]=true;
    update(par[ind]);
}
void infest(int ind)
{
    if(isInf[ind])return;
    isInf[ind]=true;
    upd_self[ind] = !upd_self[ind];
    update(par[ind]);
}
void clean(int ind)
{
    if(isInf[ind])
    {
        upd_self[ind] = !upd_self[ind];
        isInf[ind] = false;
    }
    for(int i=0; i<children[ind].size(); i++)
    {
        if(isInf[children[ind][i]])
        {
            isInf[children[ind][i]] = false;
            upd_self[children[ind][i]] = !upd_self[children[ind][i]];
            if(!upd_ch[ind])upd_ch[ind]=true;
        }
    }
    update(par[ind]);
}
int push_lazy(int ind)
{
    if(upd_self == false && upd_ch == false)return 0;
    int add=0;
    if(upd_self[ind])
    {
        if(isInf[ind])++add;
        else --add;
        upd_self[ind]=false;
    }
    if(upd_ch[ind])
    {
        for(int i=0; i<children[ind].size(); i++)
        {
            add+=push_lazy(children[ind][i]);
        }
        upd_ch[ind]=false;
    }
    bool fl=false;
    for(int i=0; i<children[ind].size(); i++)
    {
        if(upd_gen[children[ind][i]])
        {
            fl=true;
            upd_gen[children[ind][i]] = false;
        }
    }
    if(fl)
    {
        int sub = subtree[ind];
        subtree[ind]=0;
        for(int i=0; i<children[ind].size(); i++)
        {
            subtree[ind]+=subtree[children[ind][i]];
        }
        if(isInf[ind]) ++subtree[ind];
        add = subtree[ind]-sub;
    }
    else subtree[ind]+=add;
    //cout<<"lazy "<<ind<<" "<<add<<"\n";
    return add;
}
void print(int ind)
{
    if(push_lazy(ind))upd_gen[ind]=true;
    cout<<subtree[ind]<<"\n";
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    par[1]=-1;

    cin>>n;
    int x, type;
    for(int i=2; i<=n; i++)
    {
        cin>>x;
        par[i]=x;
        children[x].push_back(i);
    }
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>type>>x;
        if(type ==1)infest(x);
        else if(type==3)clean(x);
        else if(type==4)print(x);
    }
    return 0;
}
/*
5
1 1 3 3
8
1 3
1 5
4 1
4 5
3 3
4 3
4 1
*/
