#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxN=1000;
int n, m;
int color[maxN], maxc = 0;
bool col[maxN];
vector <int> adj[maxN];
queue <int> q;
void bfs(int ind)
{
    if(color[ind])return;
    q.push(ind);
    while(!q.empty())
    {
        memset(col, 0, sizeof(col));
        int curr = q.front();
        q.pop();
        for(int i=0; i<adj[curr].size(); i++)
        {
            if(col[color[adj[curr][i]]] == false)col[color[adj[curr][i]]] = true;
        }
        for(int i=1; i<=maxc; i++)
        {
            if(col[i]==false)
            {
                color[curr] = i;
                break;
            }
        }
        if(!color[curr])
        {
            ++maxc;
            color[curr]=maxc;
        }
        for(int i=0; i<adj[curr].size(); i++)
        {
            if(!color[adj[curr][i]])q.push(adj[curr][i]);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    int a, b;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    for(int i=1; i<=n; i++)
    {
        if(color[i]||adj[i].size()%2==0)continue;
        bfs(i);
    }
    for(int i=1; i<=n; i++)
    {
        if(color[i])continue;
        bfs(i);
    }
    cout<<maxc<<"\n";
    cout<<color[1];
    for(int i=2; i<=n; i++)cout<<" "<<color[i];
    cout<<"\n";
    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
