#include <bits/stdc++.h>
using namespace std;

struct Node
{
    int val;
    int rats_count;
    vector <int> children;
    int parent;
    bool has_rats;
    Node (int _val)
    {
        rats_count = 0;
        val = _val;
        has_rats = false;
    }
};

vector <Node *> Nodes;
int br = 1;

void add_node(int _parent, int val)
{
    Node *tmp = new Node(val);
    tmp->parent = _parent - 1;
    Nodes.push_back(tmp);
    Nodes[_parent - 1]->children.push_back(br);
    br ++;
}

void print_rooms(Node *st)
{
    cout<<st->val<<":"<<st->rats_count<<" ";
    for (int i = 0; i != st->children.size(); i ++)
    {
        print_rooms(Nodes[st->children[i]]);
    }
}

stack <int> path;

void infestate_UP_update_rats(int start)  ///updates the number of rats
{
    Nodes[start - 1]->rats_count ++;
    if (start != 1)
    {
        infestate_UP_update_rats(Nodes[start - 1]->parent + 1);
    }
}

void infestate(int room)       ///     1 INFESTATE
{
    if (!Nodes[room - 1]->has_rats)
    {
        Nodes[room - 1]->has_rats = true;
        infestate_UP_update_rats(room);
    }
}

int co;

    int counter = 0;
void soundUtill(int start)                  ///FILLS STACK WITH THE WAY UP
{
    co ++;
    path.push(Nodes[start - 1]->val);
    if (Nodes[start - 1]->has_rats)
    {
        counter ++;
    }
    if (start != 1)
    {
        soundUtill(Nodes[start - 1]->parent + 1);
    }
}

void soundPrint()
{
    stack <int> tmp;
 /*   do
    {
        if (Nodes[path.top() - 1]->has_rats)
        {
            counter ++;
        }
        tmp.push(path.top());
        path.pop();
    }
    while(!path.empty());
    cout<<counter<<"aaaaaaaa";
    do
    {
        path.push(tmp.top());
        tmp.pop();
    }
    while(!tmp.empty());*/

    int curr;
    int next;
    do
    {
        ///cout<<"("<<counter<<") ";
        curr = path.top();
        path.pop();
        if (!path.empty())
        {
            next = path.top();
        }

        Nodes[curr - 1]->rats_count -= counter;

        if (Nodes[curr - 1]->has_rats)
        {
            int _size = Nodes[curr - 1]->children.size();
            for (int i = 0; i != _size; i ++)
            {
                if (Nodes[curr - 1]->children[i] + 1 != next)
                {
                    //cout<<Nodes[curr - 1]->children[i] + 1<<" ";
                    infestate(Nodes[Nodes[curr - 1]->children[i]]->val);
                }
            }
        }
        if (Nodes[curr - 1]->has_rats)
        {
            Nodes[curr - 1]->has_rats = false;
            counter --;
        }
    }
    while(!path.empty());
    //cout<<endl;
}

void sound(int start)           ///    2 SOUND
{
    co = 0;
    counter = 0;
    soundUtill(start);
    soundPrint();
}

void task_four(int room)
{
    cout<<Nodes[room - 1]->rats_count<<endl;

}

void go_up(int start, int val)
{
    Nodes[start - 1]->rats_count -= val;
    if (start != 1)
    {
        go_up(Nodes[start - 1]->parent + 1, val);
    }
}

void exterm(int room)
{
    int to_go = 0;
    if (Nodes[room - 1]->has_rats)
    {
       // cout<<room<<" ";
        Nodes[room - 1]->has_rats = false;
       // Nodes[room - 1]->rats_count --;
        to_go ++;
    }
    /*
    5
    1 1 3 3
    8
    1 3
    2 5
    4 1
    1 1
    2 1
    4 3
    3 1
    4 3
    */
    int _size = Nodes[room - 1]->children.size();
    for (int i = 0; i != _size; i ++)
    {
        if (Nodes[Nodes[room - 1]->children[i]]->has_rats)
        {
           // cout<<Nodes[Nodes[room - 1]->children[i]]->val<<" ";
            Nodes[Nodes[room - 1]->children[i]]->has_rats = false;
            Nodes[Nodes[room - 1]->children[i]]->rats_count --;
            to_go ++;
        }
    }
   // Nodes[room - 1]->rats_count -= (to_go - 1);
   go_up(room, to_go);
}

void get_parent(int chil)
{
    cout<<Nodes[chil - 1]->parent + 1<<endl;
}

void build(int n)
{
    int a;
    Node *entrance = new Node(1);
    Nodes.push_back(entrance);
    for (int j = 0; j != n - 1; j ++)
    {
        cin>>a;
        add_node(a, j + 2);
    }
}

void tasks(int q)
{
    int a, b;
    for (int i = 0; i != q; i ++)
    {
        cin>>a;
        cin>>b;
        if (a == 1)
        {
            infestate(b);
        }
        else if (a == 2)
        {
            sound(b);
        }
        else if (a == 3)
        {
            exterm(b);
        }
        else
        {
            task_four(b);
        }
    }
}

int main()
{
    int n, q;
    cin>>n;
    build(n);
    cin>>q;
    tasks(q);

    return 0;
}
