#include <bits/stdc++.h>
using namespace std;

const int N=(3e5)+5;

vector <int> g[N];
int father[N],infected[N];
int ans[N];

void Crawl(int v)
{
 int i,x,cnt;

 cnt=0;
 x=v;
  while(v!=0)
  {
    if(infected[v])
    {
     for(i=0;i<g[v].size();i++)
     {
       if(!infected[g[v][i]])
       {
        infected[g[v][i]]=1;
        ans[g[v][i]]++;
        cnt++;
       }
     }
    }

   ans[v]+=cnt;
   v=father[v];
  }

 cnt=0;
  while(x!=0)
  {
    if(infected[x])
    {
     cnt++;
     infected[x]=0;
    }

   ans[x]-=cnt;
   x=father[x];
  }
}

int num[N],mx[N];
int tree[N];
int ind;

void DFS(int v)
{
 int i;

 num[v]=++ind;
 mx[v]=num[v];

  for(i=0;i<g[v].size();i++)
  {
   DFS(g[v][i]);
   mx[v]=max(mx[v],mx[g[v][i]]);
  }
}

int n;

void Update(int v,int delta)
{
 while(v<=n)
 {
  tree[v]+=delta;
  v+=(v&(-v));
 }
}

int Query(int v)
{
 int sum=0;

  while(v>=1)
  {
   sum+=tree[v];
   v-=(v&(-v));
  }

 return sum;
}

int QueryNode(int x)
{
 return Query(mx[x])-Query(num[x]-1);
}

int t[N],ver[N];

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int q,i,u,type,x,cnt,z;
bool fl=false;

cin>>n;

 for(i=1;i<n;i++)
 {
  cin>>father[i+1];
  g[father[i+1]].push_back(i+1);
 }

cin>>q;

 for(i=1;i<=q;i++)
 {
  cin>>t[i]>>ver[i];

   if(t[i]==2)
    fl=true;
 }

 if(fl)
 {
  z=0;
  while(q--)
  {
   z++;
   type=t[z];
   x=ver[z];

    if(type==1)
    {
     if(!infected[x])
     {
      infected[x]=1;

       while(x!=0)
       {
        ans[x]++;
        x=father[x];
       }
     }
    }

    if(type==2)
     Crawl(x);

    if(type==3)
    {
     cnt=0;
      for(i=0;i<g[x].size();i++)
      {
       if(infected[g[x][i]])
       {
        infected[g[x][i]]=0;
        ans[g[x][i]]--;
        cnt++;
       }
      }

      if(infected[x])
      {
       infected[x]=0;
       cnt++;
      }

      while(x!=0)
      {
       ans[x]-=cnt;
       x=father[x];
      }
    }

    if(type==4)
    {
     cout<<ans[x]<<"\n";
    }
  }

  return 0;
 }

DFS(1);

z=0;
 while(q--)
 {
  z++;
  type=t[z];
  x=ver[z];

   if(type==1)
   {
     if(!infected[x])
     {
      Update(num[x],1);
      infected[x]=1;
     }
   }

   if(type==3)
   {
     if(infected[x])
     {
      Update(num[x],-1);
      infected[x]=0;
     }

     for(i=0;i<g[x].size();i++)
     {
       if(infected[g[x][i]])
       {
        Update(num[g[x][i]],-1);
        infected[g[x][i]]=0;
       }
     }
   }

   if(type==4)
   {
    int answer=QueryNode(x);
    cout<<answer<<"\n";
   }
 }

return 0;
}
