#include <bits/stdc++.h>
using namespace std;

const int N=(5e5)+5;

vector <int> g[N];
vector <int> comps[N];
int compcnt;
bool used[N];

void DFS(int v)
{
 int i;

 used[v]=true;
 comps[compcnt].push_back(v);

  for(i=0;i<g[v].size();i++)
  {
   if(!used[g[v][i]])
    DFS(g[v][i]);
  }
}

queue <int> q;
int color[N],vis[N],anscolor[N];
int iter;
bool usedcolor[N];

/*int BFS(int comp,int v)
{
 int current,x,i,j,mn;

  for(i=0;i<comps[comp].size();i++)
   color[comps[comp][i]]=0;

 q.push(v);
 color[v]=1;
 vis[v]=iter;
 current=1;
  while(!q.empty())
  {
   v=q.front();
   q.pop();

    for(i=0;i<g[v].size();i++)
     if(vis[g[v][i]]!=iter)
     {
      x=g[v][i];
      q.push(x);
      vis[x]=iter;

       for(j=1;j<=1000;j++)
        notused[j]=true;

       for(j=0;j<g[x].size();j++)
        notused[color[g[x][j]]]=false;

       for(j=1;j<=1000;j++)
       {
        if(notused[j])
        {
         mn=j;
         break;
        }
       }

      color[x]=mn;
      current=max(current,mn);
     }
  }

 return current;
}*/

int Solve(int v)
{
 int i,j,ver;

 vis[v]=iter;

  for(i=0;i<g[v].size();i++)
  {
   ver=g[v][i];
    if(vis[ver]==iter)
     continue;

    for(j=1;j<=1000;j++)
     usedcolor[j]=false;

    for(j=0;j<g[ver].size();j++)
     usedcolor[color[g[ver][j]]]=true;

    for(j=1;j<=1000;j++)
    {
     if(!usedcolor[j])
     {
      color[ver]=j;
      break;
     }
    }

    Solve(ver);
  }
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,m,i,j,u,v,ans,z,starting,colours,mn;

cin>>n>>m;

 for(i=1;i<=m;i++)
 {
  cin>>u>>v;
  g[u].push_back(v);
  g[v].push_back(u);
 }

 for(i=1;i<=n;i++)
 {
   if(!used[i])
   {
    compcnt++;
    DFS(i);
   }
 }

ans=0;
 for(z=1;z<=compcnt;z++)
 {
  starting=comps[z][0];
  iter++;
  color[starting]=1;
  Solve(starting);
 }

ans=0;
 for(i=1;i<=n;i++)
  ans=max(ans,color[i]);

cout<<ans<<"\n";

 for(i=1;i<=n;i++)
  cout<<color[i]<<" ";

cout<<"\n";

return 0;
}
