#include <bits/stdc++.h>
using namespace std;

const int N=(5e5)+5;

vector <int> g[N];
vector <int> comps[N];
int compcnt;
bool used[N];

void DFS(int v)
{
 int i;

 used[v]=true;
 comps[compcnt].push_back(v);

  for(i=0;i<g[v].size();i++)
  {
   if(!used[g[v][i]])
    DFS(g[v][i]);
  }
}

queue <int> q;
int color[N],vis[N];
int iter;
bool notused[N];

int BFS(int v)
{
 int current,x,i,j,mn;

 q.push(v);
 color[v]=1;
 vis[v]=iter;
 current=1;
  while(!q.empty())
  {
   v=q.front();
   q.pop();

    for(i=0;i<g[v].size();i++)
     if(vis[g[v][i]]!=iter)
     {
      x=g[v][i];
      q.push(x);
      vis[x]=iter;

       for(j=1;j<=20;j++)
        notused[j]=true;

       for(j=0;j<g[x].size();j++)
        notused[color[g[x][j]]]=false;

       for(j=1;j<=20;j++)
       {
        if(notused[j])
        {
         mn=j;
         break;
        }
       }

      color[x]=mn;
      current=max(current,mn);
     }
  }

 return current;
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,m,i,u,v,ans,z,starting,colours;

cin>>n>>m;

 for(i=1;i<=m;i++)
 {
  cin>>u>>v;
  g[u].push_back(v);
  g[v].push_back(u);
 }

 for(i=1;i<=n;i++)
 {
   if(!used[i])
   {
    compcnt++;
    DFS(i);
   }
 }

ans=0;
 for(z=1;z<=compcnt;z++)
 {
  starting=comps[z][0];
  iter++;
  colours=BFS(starting);
  ans=max(ans,colours);
 }

cout<<ans<<"\n";

 for(i=1;i<=n;i++)
  cout<<color[i]<<" ";

cout<<"\n";

return 0;
}
