#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

const int N = 5e5;

int color[1 + N];
int viz[1 + N];
vector <int> gr[1 + N];

void dfs (int node, int c) {
    viz[node] = 1;
    color[node] = c + 1;
    for (auto vec : gr[node])
        if (viz[vec] == 0) {
            dfs (vec, !c);
        }
}

void dfs_2 (int node, int f) {
    viz[node] = 2;
    if (color[node] == color[f])
        color[node] = 3;
    for (auto vec : gr[node])
        if (viz[vec] == 1) {
            dfs_2 (vec, node);
        }
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].pb (y);
        gr[y].pb (x);
    }

    for (int i = 1; i <= n; i++)
        if (viz[i] == 0)
            dfs (i, 0);

    for (int i = 1; i <= n; i++) {
        bool ok = true;
        for (auto vec : gr[i])
            if (color[vec] == color[i]) {
                ok = false;
                break;
            }
        if (!ok)
            color[i] = 3;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans = max (ans, color[i]);

    cout << ans << "\n";
    for (int i = 1; i <= n; i++) {
        cout << color[i] << " ";
    }
    return 0;
}
