#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 500000;

vector<int> graph[1+MAX_N];
int color[1+MAX_N];
bool bipartit = true;

void bipart(int nod, int col = 1) {
	color[nod] = col;
	for(auto it: graph[nod])
		if(color[it] == 0)
			bipart(it, 3 - col);
		else if(color[nod] == color[it]) {
			color[nod] = 3;
			bipartit = false;
		}
}

int main() {
	int N, M;
	scanf("%d%d", &N, &M);
	for(int i = 0; i < M; ++i) {
		int a, b;
		scanf("%d%d", &a, &b);
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	for(int i = 1; i <= N; ++i)
		sort(graph[i].begin(), graph[i].end());
	
	for(int i = 1; i <= N; ++i)
		if(color[i] == 0)
			bipart(i);
	
	if(bipartit)
		printf("2\n");
	else
		printf("3\n");
	for(int i = 1; i <= N; ++i)
		printf("%d ", color[i]);

	return 0;
}

