#include <bits/stdc++.h>

using namespace std;

const int MAXN = (int) 5e5;

vector <int> g[MAXN + 1];
int deg[MAXN + 1], col[MAXN + 1];
bool vis[MAXN + 1];


bool bkt(int nod, int num) {
    if(vis[nod]) {
        return 1;
    }
    vis[nod] = 1;
    vector <int> son;
    set <int> vals;
    for(auto it : g[nod]) {
        if(vis[it]) {
            vals.insert(col[it]);
        }
        else {
            son.push_back(it);
        }
    }
    sort(son.begin(), son.end(), [&](const int &x, const int &y) {
                return deg[x] > deg[y];
         });
    bool ans = 0;
    for(int j = 1; j <= num && ans == 0; j++) {
        if(vals.find(j) == vals.end()) {
            col[nod] = j;
            int cur = 1;
            for(auto it : son) {
                cur &= bkt(it, num);
            }
            ans |= cur;
        }
    }
    vis[nod] = 0;
    return ans;
}

inline bool check(int num, int n) {
    bool ans = 1;
    for(int i = 1; i <= n && ans; i++) {
        if(vis[i] == 0) {
            ans &= bkt(i, num);
        }
    }
    return ans;
}

int main() {
#ifdef HOME
    ifstream cin("A.in");
    ofstream cout("A.out");
#endif // HOME
    int i, n, m;
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n >> m;

    for(i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
        deg[x]++, deg[y]++;
    }

    int res = 0;
    for(int step = 1 << 10; step; step >>= 1) {
        if(res + step <= n && check(res + step, n) == 0) {
            res += step;
        }
    }

    check(res + 1, n);
    int ans = 0;
    for(i = 1; i <= n; i++) {
        ans = max(ans, col[i]);
    }
    cout << ans << "\n";
    for(i = 1; i <= n; i++) {
        cout << col[i] << " ";
    }

    return 0;
}
