#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;

const int MAXN = (int) 1e5;

char str[MAXN + 1];
int n = 0;

struct Data {
    int val1, val2, pos;
    bool operator <(const Data &other) const {
        if(val1 == other.val1) return val2 < other.val2;
        return val1 < other.val1;
    }
};

int P[MAXN + 1][20];
int best[MAXN + 1];

inline int get_lcp(int x, int y) {
    int len = 0;
    for(int bit = 19; bit >= 0; bit--) {
        if(max(x, y) + (1 << bit) <= n + 1 && P[x][bit] == P[y][bit]) {
            x += (1 << bit), y += (1 << bit);
            len += (1 << bit);
        }
    }
    return len;
}

inline void suffix() {
    vector <int> fr(26);
    int i;
    for(i = 1; i <= n; i++) {
        fr[str[i] - 'a']++;
    }
    for(i = 1; i < 26; i++) {
        fr[i] += fr[i - 1];
    }
    for(i = 1; i <= n; i++) {
        P[i][0] = fr[str[i] - 'a'];
    }
    vector <Data> ord(n);
    int bit = 1;
    while((1 << bit) <= n) {
        for(i = 1; i <= n; i++) {
            if(i + (1 << (bit - 1)) <= n) {
                ord[i - 1] = {P[i][bit - 1], P[i + (1 << (bit - 1))][bit - 1], i};
            }
            else {
                ord[i - 1] = {P[i][bit - 1], 0, i};
            }
        }
        sort(ord.begin(), ord.end());
        int val = 0;
        for(i = 0; i < n; i++) {
            if(i == 0 || (i > 0 && (ord[i].val1 != ord[i - 1].val1 || ord[i].val2 != ord[i - 1].val2))) {
                val++;
            }
            P[ord[i].pos][bit] = val;
        }
        bit++;
    }

    bit--;

    vector <int> ids(n);
    iota(ids.begin(), ids.end(), 1);
    sort(ids.begin(), ids.end(), [&](const int &x, const int &y) {
                if(P[x][bit] == P[y][bit]) return x < y;
                return P[x][bit] < P[y][bit];
         });

    vector <int> h(n);
    for(i = 0; i + 1 < n; i++) {
        h[i + 1] = get_lcp(ids[i], ids[i + 1]);
        //cerr << ids[i] << " " << ids[i + 1] << " " << h[i + 1] << "\n";
    }

    vector <int> l(n, 1), r(n, n - 1);
    stack <int> stk;
    for(i = 1; i < n; i++) {
        while(stk.size() && h[stk.top()] > h[i]) {
            r[stk.top()] = i - 1;
            stk.pop();
        }
        stk.push(i);
    }
    while(stk.size()) {
        stk.pop();
    }
    for(i = n - 1; i >= 1; i--) {
        while(stk.size() && h[stk.top()] > h[i]) {
            l[stk.top()] = i + 1;
            stk.pop();
        }
        stk.push(i);
    }

    for(i = 1; i <= n; i++) {
        best[i] = 1;
    }
    for(i = 1; i < n; i++) {
        best[h[i]] = max(best[h[i]], r[i] - l[i] + 2);
    }
    for(i = n - 1; i >= 1; i--) {
        best[i] = max(best[i], best[i + 1]);
    }
}

void start(char *w) {
    while(w[n] != '\0') {
        str[n + 1] = w[n];
        n++;
    }
    str[0] = 'a' - 1;

    suffix();
}

int round(int m, int k) {
    return best[m];
}
