#include<iostream>
#include<cstring>
#include<algorithm>
#include "Sgame.h"
#define DIM 500005
using namespace std;
static int n;
static int a[21][DIM], pr[DIM], c[DIM], st[DIM], dr[DIM], aint[4 * DIM], val[DIM], fst[DIM], fdr[DIM];
struct str{
    int x, y, ind;
};
static str w[DIM];
static int cmp(str a, str b){
    if(a.x == b.x){
        return a.y < b.y;
    }
    return a.x < b.x;
}
static int prefix(int i, int j){
    int ii, sol = 0;
    for(ii = 18; ii >= 0; ii--){
        if(max(i, j) + (1 << ii) <= n && a[ii][i] == a[ii][j]){
            sol += (1 << ii);
            i += (1 << ii);
            j += (1 << ii);
        }
    }
    return sol;
}
void build(int nod, int st, int dr){
    if(st == dr){
        aint[nod] = val[st];
    }
    else{
        int mid = (st + dr) / 2;
        build(2 * nod, st, mid);
        build(2 * nod + 1, mid + 1, dr);
        aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
    }
}
int query(int nod, int st, int dr, int p, int u){
    if(p <= st && dr <= u){
        return aint[nod];
    }
    else{
        int mid = (st + dr) / 2, x = 0, y = 0;
        if(p <= mid){
            x = query(2 * nod, st, mid, p, u);
        }
        if(u > mid){
            y = query(2 * nod + 1, mid + 1, dr, p, u);
        }
        return max(x, y);
    }
}
void start(char c[]){
    int i, ii, nr, t, u;
    n = strlen(c);
    for(i = 0; i < n; i++){
        a[0][i] = c[i];
    }
    for(ii = 1; (1 << (ii - 1) ) < n; ii++){
        for(i = 0; i < n; i++){
            w[i].ind = i;
            w[i].x = a[ii - 1][i];
            if(i + (1 << (ii - 1) ) < n){
                w[i].y = a[ii - 1][ i + (1 << (ii - 1) ) ];
            }
            else{
                w[i].y = -1;
            }
        }
        sort(w, w + n, cmp);
        a[ii][ w[0].ind ] = 0;
        for(i = 1; i < n; i++){
            if(w[i].x == w[i - 1].x && w[i].y == w[i - 1].y){
                a[ii][ w[i].ind ] = a[ii][ w[i - 1].ind ];
            }
            else{
                a[ii][ w[i].ind ] = i;
            }
        }
    }
    for(i = 0; i < n - 1; i++){
        pr[i] = prefix(w[i].ind, w[i + 1].ind);
    }

    u = 1;
    c[0] = -1;
    c[1] = 0;
    for(i = 1; i < n; i++){
        while(u > 0 && pr[ c[u] ] >= pr[i]){
            u--;
        }
        st[i] = c[u] + 1;
        c[++u] = i;
    }
    u = 0;
    c[0] = n - 1;
    for(i = n - 2; i >= 0; i--){
        while(u > 0 && pr[ c[u] ] >= pr[i]){
            u--;
        }
        dr[i] = c[u] - 1;
        c[++u] = i;
    }
   /* fdr[n - 1] = n - 1;
    for(i = n - 2; i >= 0; i--){
        if(w[i].ind == 0 || w[i + 1].ind == 0){
            fdr[i] = i;
        }
        else{
            if(c[ w[i].ind - 1] == c[ w[i - 1].ind - 1]){
                fdr[i] = fdr[i + 1];
            }
            else{
                fdr[i] = i;
            }
        }
    }*/
    /*for(i = 1; i < n; i++){

    }*/
    for(i = 1; i <= n; i++){
        val[i] = 1;
    }
    for(i = 0; i < n - 1; i++){
        val[ pr[i] ] = max(val[ pr[i] ], dr[i] - st[i] + 2);
    }
    build(1, 1, n);
}
int round(int p, int u){
    return query(1, 1, n, p, u);
}
