#include<iostream>
#include<cstring>
#include<algorithm>
#include "Sgame.h"
#define DIM 500005
using namespace std;
static int n;
static int a[21][DIM], pr[DIM], c[DIM], st[DIM], dr[DIM], aint[4 * DIM], val[DIM], fst[DIM], fdr[DIM];
static int sol[1005][1005];
struct str{
    int x, y, ind;
};
static str w[DIM];
static int cmp(str a, str b){
    if(a.x == b.x){
        return a.y < b.y;
    }
    return a.x < b.x;
}
static int prefix(int i, int j){
    int ii, sol = 0;
    for(ii = 18; ii >= 0; ii--){
        if(max(i, j) + (1 << ii) <= n && a[ii][i] == a[ii][j]){
            sol += (1 << ii);
            i += (1 << ii);
            j += (1 << ii);
        }
    }
    return sol;
}
void build(int nod, int st, int dr){
    if(st == dr){
        aint[nod] = val[st];
    }
    else{
        int mid = (st + dr) / 2;
        build(2 * nod, st, mid);
        build(2 * nod + 1, mid + 1, dr);
        aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
    }
}
int query(int nod, int st, int dr, int p, int u){
    if(p <= st && dr <= u){
        return aint[nod];
    }
    else{
        int mid = (st + dr) / 2, x = 0, y = 0;
        if(p <= mid){
            x = query(2 * nod, st, mid, p, u);
        }
        if(u > mid){
            y = query(2 * nod + 1, mid + 1, dr, p, u);
        }
        return max(x, y);
    }
}
void start(char c[]){
    int i, ii, nr, t, u, j;
    n = strlen(c);
    for(i = 0; i < n; i++){
        for(j = 0; j < n; j++){
            if(i == j){
                continue;
            }
            for(ii = 0; j + ii < n && i + ii < n; ii++){
                if(c[ii + j] != c[ii + i]){
                    break;
                }
            }
            sol[i][ii]++;
        }
        for(j = 1; j <= n; j++){
            val[j] = max(val[j], sol[i][j] + 1);
        }
    }
}
int round(int p, int u){
    int maxim = 0;
    for(int i = p; i <= u; i++){
        maxim = max(maxim, val[i]);
    }
    return maxim;
}
