#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#define DIM 500010
using namespace std;

//ifstream fin ("date.in");
//ofstream fout ("date.out");
vector <int> L[DIM];
deque <int> c;
int viz[DIM],cul[DIM];
int n,m,x,y,i;
void dfs (int nod, int tata){
    viz[nod] = 1;
    /// vreau sa gasesc o culoare valida cu care sa il colorez pe nod
    c.clear();
    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (cul[vecin])
            c.push_back(cul[vecin]);
    }
    sort (c.begin(),c.end());
    if (c.empty()){ /// n am niciun vecin colorat
        cul[nod] = 1;
    } else {
        int color = 1;
        if (c.size() == 1){ /// am un singur vecin deci pun 1 sau 2
            if (c.front() == 1)
                cul[nod] = 2;
            else cul[nod] = 1;
        } else {
            if (c.front() != 1) /// daca cea mai mica culoare e dif de 1 pun 1
                cul[nod] = 1;
            else {
                for (int i=0;i<c.size()-1;i++){
                    if (c[i]+1 < c[i+1]){
                        cul[nod] = c[i]+1;
                        break;
                    }
                }
                if (!cul[nod])
                    cul[nod] = c.back()+1;
            }
        }
    }

    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (!viz[vecin])
            dfs (vecin,0);
    }
}
int verif (int val){
    int i;
    for (i=1;i<=n;i++)
        viz[i] = cul[i] = 0;
    for (i=1;i<=n;i++)
        if (!viz[i])
            dfs (i,0);
    for (i=1;i<=n;i++)
        if (cul[i] > val)
            return 0;
    return 1;
}
int main (){
    /// NU UITA DE FISIERE
    cin>>n>>m;
    for (i=1;i<=m;i++){
        cin>>x>>y;
        L[x].push_back(y);
        L[y].push_back(x);
    }

    int st = 1, dr = n, sol = 0;
    while (st <= dr){
        int mid = (st+dr)>>1;
        if (verif(mid)){
            sol = mid;
            dr = mid-1;
        } else st = mid+1;
    }
    verif (sol);
    cout<<sol<<"\n";
    for (i=1;i<=n;i++)
        cout<<cul[i]<<" ";




    return 0;
}
