#include <iostream>
#include <vector>
#include <random>
#include <bitset>
#include <algorithm>
#include <queue>
using namespace std;
queue<int> q;

vector<int> v[500005],cuplaj[500005];
bitset<500005> fol,fol2;
int n,m,cul[500005],cul2[500005];
bool cul_c[500005],folosit[500005];
int vect[500005],cnt=0,cpl[500005];
bool mysort(int a,int b){
    return cuplaj[a].size()>cuplaj[b].size();
}

void dfs_2(int nod,int culo){
    cul[nod]=culo;
    for(int i=0;i<v[nod].size();i++){
        if(fol[v[nod][i]]==false){
            fol[v[nod][i]]=true;
            dfs_2(v[nod][i],1-culo);
        }
    }
}
void dfs_cuplaj(int nod,int culo){
    cul_c[nod]=culo;
    for(int i=0;i<cuplaj[nod].size();i++){
        if(folosit[cuplaj[nod][i]]==false){
            folosit[cuplaj[nod][i]]=true;
            cul_c[cuplaj[nod][i]]=1-culo;
            dfs_cuplaj(cuplaj[nod][i],1-culo);
        }
    }
}
void fa_cuplaj(){
    mt19937 gen(155);
    for(int i=1;i<=cnt;i++){
        if(cpl[vect[i]]!=0){
            folosit[i]=true;
            dfs_cuplaj(i,gen()%2+1);
            for(int j=0;j<cuplaj[i].size();j++){
                cpl[cuplaj[i][j]]--;
            }
        }

    }
}
int verif_cul(int nod){
    int a1=0,a2=0,a3=0;
    for(int i=0;i<v[nod].size();i++){
        if(fol2[v[nod][i]]==true){
            if(cul2[v[nod][i]]==1){
                a1=1;
            }
            if(cul2[v[nod][i]]==2){
                a2=1;
            }
            if(cul2[v[nod][i]]==3){
                a3=1;
            }
        }
    }
    string str;
    if(a1==0)
        return 1;
    if(a2==0)
        return 2;
    return 3;
}
void dfs_3(int nod,int culo){
    cul2[nod]=culo;
    for(int i=0;i<v[nod].size();i++){
        if(fol2[v[nod][i]]==false){
            fol2[v[nod][i]]=true;
            int ok=verif_cul(v[nod][i]);
                dfs_3(v[nod][i],ok);

        }
    }
}
bool verif_2()
{
    for(int i=1;i<=n;i++){
        if(fol[i]==false){
            fol[i]=1;
            cul[i]=1;
            dfs_2(i,1);
        }
    }
    for(int i=1;i<=n;i++){
        for(int j=0;j<v[i].size();j++){
            if(cul[i]==cul[v[i][j]]){
                return false;
            }
        }
    }
    return true;
}
void bfs_3(int nod,int culo){
    q.push(nod);
    while(q.empty()==false){
        nod=q.front();
        q.pop();
        //cul2[nod]=culo;
        for(int i=0;i<v[nod].size();i++){
            if(fol2[v[nod][i]]==false){
                fol2[v[nod][i]]=true;
                int x=verif_cul(v[nod][i]);
                cul2[v[nod][i]]=x;
                q.push(v[nod][i]);
            }
        }
    }
}
bool verif_3(){
    for(int i=1;i<=n;i++){
        if(fol2[i]==false){
            fol2[i]=true;
            cul2[i]=1;
            bfs_3(i,1);
        }
    }
    for(int i=1;i<=n;i++){
        for(int j=0;j<v[i].size();j++){
            if(cul2[i]==cul2[v[i][j]]){
                return false;
            }
        }
    }
    return true;
}
bool f[105][105];
int main()
{
    mt19937 gen(155);
    cin>>n>>m;
    for(int i=1;i<=m;i++){
        int a,b;
        cin>>a>>b;

        v[a].push_back(b);
        v[b].push_back(a);
    }
    bool ok=false;
    ok=verif_2();
    if(ok==true){
        cout<<2<<"\n";
        for(int i=1;i<=n;i++){
            cout<<cul[i]+1<<" ";
        }
    }
    else{

        bool ok1=verif_3();
        cout<<3<<"\n";
        for(int i=1;i<=n;i++){
            cout<<cul2[i]<<" ";
        }
        ///solutiea este 3

    }
    return 0;
}
///solutiile pot fi doar 2 sau 3
/**
6 5
1 2
2 3
1 4
3 4
6 5

5 5
1 2
2 3
3 4
4 5
5 1


5 7
3 4
1 5
2 3
1 4
4 5
1 2
3 1

6 9
1 2
1 3
3 5
2 4
3 4
4 6
5 6
3 2
5 1

*/
