#include <cstdio>
#include <vector>
#include <algorithm>
#include <ctime>
#include <random>

#pragma GCC optimizer("O3");

using namespace std;

vector<int>G[500005];
int ans[500005];
int d[500005];
int st[500005];
int dr[500005];

int k;

struct stare{
  int rep, l, r;
}stk[500005];

/*void solve(int rep, int l, int r) {
  if (l > r)
    return ;
  vector<int>v;
  for (auto it:G[rep])
    if (ans[it])
      v.push_back(ans[it]);
  sort(v.begin(), v.end());
  int x = 1;
  for (auto it:v)
    if (it == x)
      x++;
    else
      break;
  ans[rep] = x;
  d[ans[rep]]++;
  if (d[ans[rep]] == 1)
    k++;
  if (l == r)
    return ;
  while (st[rep] <= dr[rep] && G[rep][st[rep]] < l)
    st[rep]++;
  while (dr[rep] >= st[rep] && G[rep][dr[rep]] > r)
    dr[rep]--;
  if (st[rep] > dr[rep]) {
    //int r1 = l + rand() % (rep - l);
    //int r2 = rep + 1 + rand() % (r - rep);
    solve(l, l, rep - 1);
    solve(rep + 1, rep + 1, r);
  } else {
    int w1 = G[rep][dr[rep]];
    int w2 = G[rep][st[rep]];
    if (w1 < rep)
      w1 = rep + 1;
    if (w2 > rep)
      w2 = rep - 1;
    solve(w1, rep + 1, r);
    solve(w2, l, rep - 1);
  }
}*/

int xx[500005];

int main() {
  srand(time(0));
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  int x = rand() % n;
  for (int i = 1; i <= m; ++i) {
    int u, v;
    scanf("%d%d", &u, &v);
    u += x;
    v += x;
    if (u > n)
      u -= n;
    if (v > n)
      v -= n;
    G[u].push_back(v);
    G[v].push_back(u);
  }
  for (int i = 1; i <= n; ++i) {
    sort(G[i].begin(), G[i].end());
    st[i] = 0;
    dr[i] = G[i].size() - 1;
  }

  int top = 1;
  stk[1] = {1, 1, n};
  while (top) {
    stare aux = stk[top--];
    int l = aux.l, r = aux.r, rep = aux.rep;
    if (l > r)
      continue;
    vector<int>v;
    int sz = G[rep].size();
    int x = 1;
    for (int i = 0; i < sz; ++i) {
      xx[ans[G[rep][i]]] = 1;
    }
    while (xx[x])
      x++;
    for (int i = 0; i < sz; ++i)
      xx[ans[G[rep][i]]] = 0;
    ans[rep] = x;
    d[ans[rep]]++;
    if (d[ans[rep]] == 1)
      k++;
    while (st[rep] <= dr[rep] && G[rep][st[rep]] < l)
      st[rep]++;
    while (dr[rep] >= st[rep] && G[rep][dr[rep]] > r)
      dr[rep]--;
    if (st[rep] > dr[rep]) {
      stk[++top] = {rep + 1, rep + 1, r};
      stk[++top] = {l, l, rep - 1};
    } else {
      int w1 = G[rep][dr[rep]];
      int w2 = G[rep][st[rep]];
      if (w1 < rep)
        w1 = rep + 1;
      if (w2 > rep)
        w2 = rep - 1;
      stk[++top] = {w2, l, rep - 1};
      stk[++top] = {w1, rep + 1, r};
    }
  }

  printf("%d\n", k);
  for (int i = x + 1; i <= n; ++i)
    printf("%d ", ans[i]);
  for (int i = 1; i <= x; ++i)
    printf("%d ", ans[i]);

  return 0;
}
