#include <cstdio>
#include <algorithm>

using namespace std;

int ans[500005];
int d[500005];
int st[500005];
int ss[500005];
int dr[500005];
int dd[500005];

int k;

struct stare{
  int rep, l, r;
}stk[500005];

struct Edge {
  int u, v;
  bool operator < (const Edge& other) const {
    if (u == other.u)
      return v < other.v;
    return u < other.u;
  }
}e[1000005];

int xx[500005];

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= m; ++i) {
    int u, v;
    scanf("%d%d", &u, &v);
    e[2 * i] = {u, v};
    e[2 * i - 1] = {v, u};
  }

  sort(e + 1, e + 2 * m + 1);

  for (int i = 1; i <= 2 * m; ++i) {
    if (e[i - 1].u == e[i].u)
      dr[e[i].u]++;
    else {
      st[e[i].u] = dr[e[i].u] = 1 + dr[e[i - 1].u];
    }
  }

  for (int i = 1; i <= n; ++i)
    ss[i] = st[i], dd[i] = dr[i];

  int top = 1;
  stk[1] = {1, 1, n};
  while (top) {
    stare aux = stk[top--];
    int l = aux.l, r = aux.r, rep = aux.rep;
    if (l > r)
      continue;
    int x = 1;
    for (int i = ss[rep]; i <= dd[rep]; ++i) {
      xx[ans[e[i].v]] = 1;
      while (xx[x])
        x++;
    }
    for (int i = ss[rep]; i <= dd[rep]; ++i)
      xx[ans[e[i].v]] = 0;
    ans[rep] = x;
    d[ans[rep]]++;
    if (d[ans[rep]] == 1)
      k++;
    while (st[rep] <= dr[rep] && e[st[rep]].v < l)
      st[rep]++;
    while (dr[rep] >= st[rep] && e[dr[rep]].v > r)
      dr[rep]--;
    if (st[rep] > dr[rep]) {
      stk[++top] = {rep + 1, rep + 1, r};
      stk[++top] = {l, l, rep - 1};
    } else {
      int w1 = e[dr[rep]].v;
      int w2 = e[st[rep]].v;
      if (w1 < rep)
        w1 = rep + 1;
      if (w2 > rep)
        w2 = rep - 1;
      stk[++top] = {w2, l, rep - 1};
      stk[++top] = {w1, rep + 1, r};
    }
  }

  printf("%d\n", k);
  for (int i = 1; i <= n; ++i)
    printf("%d ", ans[i]);

  return 0;
}
