#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;

const int NMAX = 1e2 + 5;

int N, Max;
int Cnt[NMAX][NMAX];

char W[NMAX];

map < string, int > mp;

vector < pair < int, int > > V;

void Precalculation ()
{
    N = (int)strlen(W + 1);

    for(int i = 1; i <= N; ++i)
    {
        string s;

        for(int j = i; j <= N; ++j)
        {
            s.push_back(W[j]);

            ++mp[s];
        }
    }

    for(int i = 1; i <= N; ++i)
    {
        string s;

        for(int j = i; j <= N; ++j)
        {
            s.push_back(W[j]);

            Cnt[i][j] = mp[s];
        }
    }

    return;
}

void start (char w[])
{
    strcpy(W + 1, w);

    Precalculation();

    return;
}

void Find (int m, int k)
{
    Max = 0;

    for(int i = m; i < k; ++i)
    {
        for(int j = 1; j <= N - i + 1; ++j)
        {
            int Left = j, Right = j + i - 1;

            if(Cnt[Left][Right] > Max)
            {
                Max = Cnt[Left][Right];

                V.clear();

                V.push_back({Left, Right});
            }
            else if(Cnt[Left][Right] == Max)
                V.push_back({Left, Right});
        }
    }

    return;
}

int Calc (int Left, int Right)
{
    return (Right - Left + 1);
}

int round (int m, int k)
{
    Find(m, k);

    for(auto it : V)
    {
        bool Ok = 1;

        int Left = it.first, Right = it.second;

        for(int pr = 0; Right + pr <= N; ++pr)
            for(int pl = 0; Left - pl >= 1; --pl)
                if(Calc(Left - pl, Right + pr) > k && (pl + pr))
                    if(Cnt[Left - pl][Right + pr] >= Max)
                    {
                        Ok = 0;

                        pr = 2e9;
                        pl = 2e9;
                    }

        if(Ok)
            return Max;
    }

    return 0;
}
