#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M;

int Colour[NMAX], Ap[NMAX], ans;

int Probleme[NMAX];

vector < int > G[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void Solve ()
{
    for(int i = 1; i <= N; ++i)
        Colour[i] = 1;

    bool done = 1;

    while(done)
    {
        done = 0;

        for(int i = 1; i <= N; ++i)
            Probleme[i] = 0;

        for(int i = 1; i <= N; ++i)
            for(auto it : G[i])
            {
                if(Colour[i] == Colour[it])
                    ++Probleme[i], ++Probleme[it], done = 1;
            }

        int Max = 0, pos = 0;

        for(int i = 1; i <= N; ++i)
            if(Probleme[i] > Max)
            {
                Max = Probleme[i];

                pos = i;
            }

        ++Colour[pos];
    }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    cout << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
