#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M;

int Colour[NMAX], Ap[NMAX], ans, Grad[NMAX], d[NMAX];

int Probleme[NMAX];

bool Sel[NMAX];

vector < int > G[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void DFS (int Node, int Dist)
{
    Sel[Node] = 1;
    d[Node] = Dist;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it, Dist + 1);

    return;
}

static inline void Solve ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            DFS(i, 1);

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        Grad[i] = (int)G[i].size();

    for(int i = 1; i <= N; ++i)
        ans = max(ans, Grad[i]);

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << d[i] << ' ';

    cout << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
