//#include <bits/stdc++.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cstring>

#define MAX_N 500000

#define LOCAL 1

using namespace std;

#ifdef LOCAL
ifstream cin("input.txt");
ofstream cout("output.txt");
#endif //LOCAL


vector <int> g[MAX_N + 1];

void add(int a, int b)
{
    g[a].push_back(b);
}

int n, m;

int rez;
int cul[MAX_N + 1];


int rezG;
int culG[MAX_N + 1];

int cr;
int tmp[MAX_N + 1];

void bagaMex(int i)
{
    sort(tmp + 1, tmp + cr + 1);
/*
    cout << i << " ARE \n";
     for(int i = 1; i <= cr; i ++)
        cout << tmp[i] << " ";
     cout << "\n";*/

    int h = 1;
    for(int j = 1; h <= cr && j <= rezG + 1; j ++)
    {
        if(tmp[h] != j)
        {
            culG[i] = j;
            rezG = max(rezG, j);
            return;
        }

        else
            while(h <= cr && tmp[h] == j)
                h ++;
    }

    if(h > cr)
    {
        culG[i] = tmp[cr] + 1;
        rezG = max(rezG, culG[i]);
    }
}

void readFile()
{
    cin >> n >> m;

    for(int i = 1; i <= m; i ++)
    {
        int a, b;
        cin >> a >> b;
        add(a, b);
        add(b, a);
    }
}

void bagaGreedy()
{
    rezG = 1;
    culG[1] = 1;
    for(int i = 2; i <= n; i ++)
    {
        cr = 0;
        for(auto u : g[i])
            if(u < i)
                tmp[++ cr] = culG[u];

        //cout << "GATA " << i << "\n";

        if(cr == 0)
        {
            culG[i] = 1;
        }

        else
        {
            bagaMex(i);
            //cout << " AM BAGAT " << culG[i] << "\n";
        }
    }
}

int stk[MAX_N + 1];

void verif(int c)
{
    if(c < rez)
    {
        rez = c;
        for(int i = 1; i <= n; i ++)
            cul[i] = stk[i];
    }
}

void bkt(int k, int cul)
{/*
    cout << " INTRAM " << k << " " << cul << "\n";
    for(int i = 1; i <= n; i ++)
        cout << stk[i] << " ";
    cout << "\n\n";*/

    if(cul >= rez)
        return;

    if(k == n + 1)
    {
        verif(cul);

        return;
    }

    if(cul >= rez)
        return;

    if(cul >= rez)
        return;
    int ap[1009];
    memset(ap, 0, sizeof(ap));

    if(cul >= rez)
        return;
    for(auto u : g[k])
    {
        if(u < k)
            ap[stk[u]] = 1;
    }

    if(cul >= rez)
        return;
    for(int i = 1; i <= cul; i ++)
    {
        if(ap[i] == 0)
        {
    if(cul >= rez)
        return;

            //cout << "PUNEM " << i << " PE " << k << "\n";
            stk[k] = i;
            bkt(k + 1, cul);
    if(cul >= rez)
        return;
        }
    }

    stk[k] = cul + 1;
    bkt(k + 1, cul + 1);
}

void bagaBack()
{
    rez = n + 10;
    bkt(1, 1);
}

void solve()
{
   // bagaBack();

    //cout << " GREEDY\n";
    bagaGreedy();
    //cout << "GAGA\n";
}

void printFile()
{/*
    cout << rez << "\n";

    for(int i = 1; i <= n; i ++)
        cout << cul[i] << " ";

    cout << "\n";*/
    cout << rezG << "\n";
    for(int i = 1; i <= n; i ++)
        cout << culG[i] << " ";
    cout << "\n";
}

int main()
{
    readFile();

    solve();

    printFile();

    return 0;
}
