#include <bits/stdc++.h>
//#include <fstream>
#include <vector>
#include <algorithm>
#include <cstring>

#define MAX_N 300000

//#define LOCAL 1

using namespace std;

typedef unsigned long long ulint;

#ifdef LOCAL
ifstream cin("inf.in");
ofstream cout("inf.out");
#endif //LOCAL

vector <int> g[MAX_N + 1];

int tata[MAX_N + 1];
int viz[MAX_N + 1];
int v[MAX_N + 1];

int n, q;

void add(int a, int b)
{
    g[a].push_back(b);
}

void readFile()
{
    cin >> n;
    for(int i = 2; i <= n; i ++)
    {
        int a;
        cin >> a;
        ///add(i, a);
        add(a, i);
        tata[i] = a;
    }
}

int K;

int e[MAX_N + 1];
int poz[MAX_N + 1];
int dr[MAX_N + 1];

int arb[(MAX_N << 2) + 1];

int REZ;

void upd(int poz, int st, int dr, int a, int val)
{
    if(st == dr)
    {
        arb[poz] = val;

        return;
    }

    int mid = (st + dr) >> 1;
    if(a <= mid)
        upd(poz << 1, st, mid, a, val);

    if(a > mid)
        upd((poz << 1) + 1, mid + 1, dr, a, val);

    arb[poz] = 0;
    if(st <= mid)
        arb[poz] += arb[poz << 1];

    if(mid + 1 <= dr)
        arb[poz] += arb[(poz << 1) + 1];
}

void getRez(int poz, int st, int dr, int a, int b)
{
    if(st == a && dr == b)
    {
        REZ += arb[poz];

        return;
    }

    int mid = (st + dr) >> 1;
    if(b <= mid)
        getRez(poz << 1, st, mid, a, b);

    if(a > mid)
        getRez((poz << 1) + 1, mid + 1, dr, a, b);

    if(a <= mid && b > mid)
    {
        getRez(poz << 1, st, mid, a, mid);
        getRez((poz << 1) + 1, mid + 1, dr, mid + 1, b);
    }
}

void euclid(int a)
{
    viz[a] = -1;

    ++ K;
    poz[a] = K;
    dr[a] = K;
    e[K] = a;

    for(auto u : g[a])
    {
        if(u != tata[a])
        {
            euclid(u);
            dr[a] = max(dr[a], dr[u]);
        }
    }
}

void preCalc()
{
    euclid(1);
}

void dfs(int a)
{
    //cout << "VIZITAM " << a << " " << v[a] << "\n";

    viz[a] = q;
    REZ += (v[a] == 1);
    for(auto u : g[a])
    {
     //   cout << "ARE VECIN " << u << " " << tata[a] << " " << viz[u] << "\n";
        if(u != tata[a] && viz[u] != q)
        {
            dfs(u);
        }
    }
}

void ansQues()
{
    cin >> q;
    while(q > 0)
    {

        int tip, nod;
        cin >> tip >> nod;

        if(tip == 1)
        {
            v[nod] = 1;
            upd(1, 1, n, poz[nod], 1);
        }

        else
            if(tip == 2)
            {
                for(int x = nod; x != 0; x = tata[x])
                {
                    if(v[x] == 1)
                    for(auto u: g[x])
                    {
                        if(u != tata[x])
                        {
                            v[u] = 1;
                            upd(1, 1, n, poz[u], 1);
                        }
                    }
                }

                for(int x = nod; x != 0; x = tata[x])
                {
                    v[x] = 0;
                    upd(1, 1, n, poz[x], 0);
                }
            }

        else
            if(tip == 3)
            {
                v[nod] = 0;
                upd(1, 1, n, poz[nod], 0);
                for(auto u : g[nod])
                {
                    if(u != tata[nod])
                    {
                        v[u] = 0;
                        upd(1, 1, n, poz[u], 0);
                    }
                }
            }

        else
            if(tip == 4)
            {
                REZ = 0;
                getRez(1, 1, n, poz[nod], dr[nod]);
                cout << REZ << "\n";
                /*REZ = 0;
                dfs(nod);
                cout << REZ << "\n";*/
            }
/*
        cout << "------\n";
        dfs(1);
        cout << "------\n";*/

        q --;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    readFile();

    preCalc();

    ansQues();

    return 0;
}
