#include "Sgame.h"
#include <bits/stdc++.h>
using namespace std;

const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P = 31;

int n;
int P2[500005], P1[500005];
int H1[500005], H2[500005];
int pow1[500005], pow2[500005];
int pref1[500005], pref2[500005];
int suf1[500005], suf2[500005];

inline int lgput(int x, int p, int MOD){
    int aux = x, ans = 1;

    for(int i = 1; i <= p ; i = i << 1){
        if(i & p) ans = (1LL * ans * aux) % MOD;
        aux = (1LL * aux * aux) % MOD;
    }
    return ans;
}

void start(char s[]){
    n = strlen(s);

    pow1[0] = pow2[0] = 1;
    for(int i = 1; i <= n ; ++i){
        pow1[i] = (1LL * pow1[i - 1] * P) % MOD1;
        pow2[i] = (1LL * pow2[i - 1] * P) % MOD2;
    }

    for(int i = 1; i <= n ; ++i){
        P1[i] = (1LL * P1[i - 1] + 1LL * (s[i - 1] - 'a' + 1) * pow1[i - 1]) % MOD1;
        P2[i] = (1LL * P2[i - 1] + 1LL * (s[i - 1] - 'a' + 1) * pow2[i - 1]) % MOD2;
    }
}

int round(int m, int k){
    map <pair <int, int>, int> f;
    map <pair <int, int>, int> f1, f2;
    map <pair <int, int>, bool> ok;

    memset(H1, 0, sizeof(H1));
    memset(H2, 0, sizeof(H2));
    for(int i = 1; i + m - 1 <= n ; ++i){
        H1[i] = ((P1[i + m - 1] - P1[i - 1] + MOD1) % MOD1 * 1LL * lgput(pow1[i - 1], MOD1 - 2, MOD1)) % MOD1;
        H2[i] = ((P2[i + m - 1] - P2[i - 1] + MOD2) % MOD2 * 1LL * lgput(pow2[i - 1], MOD2 - 2, MOD2)) % MOD2;

        ++f[{H1[i], H2[i]}];
    }

    int Max = 0;
    for(int i = 1; i + m - 1 <= n ; ++i) Max = max(Max, f[{H1[i], H2[i]}]);


    return Max;
}











