#include <bits/stdc++.h>
using namespace std;

int n;
int NR = 0;
int l[300005], r[300005], TT[300005];
vector <int> v[300005];

void dfs(int nod = 1){
    l[nod] = ++NR;
    r[nod] = NR;
    for(auto it : v[nod]){
        dfs(it);
        r[nod] = max(r[nod], r[it]);
    }
}

int Arb[2000005], Lazy[2000005];

void propag(int nod){
    if(Lazy[nod] == -1){
        Lazy[nod * 2] = Lazy[nod * 2 + 1] = -1;
        Arb[nod * 2] = Arb[nod * 2 + 1] = 0;
        Lazy[nod] = 0;
        return ;
    }

    Arb[nod * 2] += Lazy[nod];
    Lazy[nod * 2] += Lazy[nod];
    Arb[nod * 2 + 1] += Lazy[nod];
    Lazy[nod * 2 + 1] += Lazy[nod];
    Lazy[nod] = 0;
    return ;
}

void update(int x, int y, int v, int st = 1, int dr = n, int nod = 1){
    if(x <= st && dr <= y){
        if(v == -1){
            Lazy[nod] = -1;
            Arb[nod] = 0;
            return ;
        }

        Lazy[nod] += v;
        Arb[nod] += v;
        return ;
    }

    propag(nod);
    int mij = (st + dr) / 2;
    if(x <= mij) update(x, y, v, st, mij, nod * 2);
    if(mij + 1 <= y) update(x, y, v, mij + 1, dr, nod * 2 + 1);

    Arb[nod] = Arb[nod * 2] + Arb[nod * 2 + 1];
}

int query(int x, int y, int st = 1, int dr = n, int nod = 1){
    if(x <= st && dr <= y) return Arb[nod];

    propag(nod);

    int mij = (st + dr) / 2, a1 = 0, a2 = 0;
    if(x <= mij) a1 = query(x, y, st, mij, nod * 2);
    if(mij + 1 <= y) a2 = query(x, y, mij + 1, dr, nod * 2 + 1);

    Arb[nod] = Arb[nod * 2] + Arb[nod * 2 + 1];
    return a1 + a2;
}

int main(){
//    freopen("1.in", "r", stdin);

    scanf("%d", &n);
    int x;
    for(int i = 2; i <= n ; ++i){
        scanf("%d", &x);
        TT[i] = x;
        v[x].push_back(i);
    }

    dfs();

    int q, tip;
    scanf("%d", &q);

    while(q--){
        scanf("%d%d", &tip, &x);
        if(tip == 1){
            ///to do update val[x] = 1
            if(query(l[x], l[x]) == 0)update(l[x], l[x], 1);
        }
        else if(tip == 2){
            ///to do update ultrasunete x - radacina
            int Last = 0;
            while(x != 0){
                if(query(l[x], l[x]) == 1){
                    for(auto it : v[x]){
                        if(it != Last && query(l[it], l[it]) == 0) update(l[it], l[it], 1);
                    }
                    update(l[x], l[x], -1);
                }
                Last = x;
                x = TT[x];
            }
        }
        else if(tip == 3){
            ///to do update tot subarborele lui x = 0
            for(auto it : v[x])
                update(l[it], l[it], -1);
        }
        else{
            ///to do query subarbore lui x
            printf("%d\n", query(l[x], r[x]));
        }
    }


    return 0;
}















