#include <bits/stdc++.h>

using namespace std;

vector < vector <int> > g;
vector <bool> s;
vector <int> path;
deque <int> p;
int ans = 0;

void dfs(int v, int f, int from = -1) {
    //cout << v << ' ' << f << ' ' << from << endl;
    if (v == f) {
        for (int i = 0; i < (int)p.size(); i++)
            path.push_back(p[i]);
        return ;
    }
    for (int to : g[v]) {
        if (to == from) continue;
        p.push_back(to);
        dfs(to, f, v);
        p.pop_back();
    }
}

void dfs1(int v, int from) {
    if (s[v]) ans++;
    for (int to : g[v]) {
        if (to == from) continue;
        dfs1(to, v);
    }
}

main() {
    //freopen("inputc.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    s.resize(n);
    g.resize(n);
    vector <int> pr(n - 1);
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        pr[i - 1] = a - 1;
        g[a - 1].push_back(i);
        g[i].push_back(a - 1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, x;
        cin >> t >> x;
        //cout << i << endl;
        if (t == 1) {
            s[x - 1] = 1;
        }
        if (t == 2) {
            path.clear();
            path.push_back(0);
            dfs(0, x - 1);
            //cout << i << endl;
            for (int j = 0; j < (int)path.size(); j++) {
                int v = path[j];
                //cout << v << ' ';
                if (s[v]) {
                    for (int to : g[v]) {
                        if (j == 0) {
                            s[to] = 1;
                        } else {
                            if (to != path[j - 1]) s[to] = 1;
                        }
                    }
                    s[v] = 0;
                }
            }
            //cout << '\n';
            //cout << i << endl;
        }
        if (t == 3) {
            s[x - 1] = 0;
            for (int to : g[x - 1]) {
                s[to] = 0;
            }
        }
        if (t == 4) {
            ans = 0;
            if (x == 1) dfs1(x - 1, -1);
            else dfs1(x - 1, pr[x - 2]);
            cout << ans << '\n';
        }
        /*cout << i << " <\n";
        for (int j : s) {
            cout << j << ' ';
        }
        cout << '\n';*/
    }
}
