#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define endl '\n'
#define x first
#define y second
#define double long double

int n, m;
vector<vector<int> > g;
vector<int> clr;
bool ok = false;

void dfs(int v, int c){
	if(clr[v] != 0){
		if(clr[v] == c) return ;
		else ok = true;
	}
	clr[v] = c;
	for(int to: g[v]){
		dfs(to, 3 - c);
		if(ok) break;
	}
}

bool paint(int v, int c){
	clr[v] = c;
	for(int to: g[v]){
		if(clr[to] == clr[v]) return false;
		if(clr[to] == 0){
			bool fok = true;
			for(int k = 1; k <= 3; k++) if(k != c){
				if(paint(to, k)){
					fok = false;
					break;
				}
			}
			if(fok) return false;
		}
	}
	return true;
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin >> n >> m;
	g.resize(n);
	clr.resize(n, 0);
	for(int i = 0; i < m; i++){
		int u, v;
		cin >> u >> v;
		u--, v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for(int i = 0; i < n; i++){
		if(clr[i] == 0) dfs(i, 1);
	}
	if(!ok){
		cout << 2 << endl;
		for(int i = 0; i < n; i++){
			cout << clr[i] << ' ';
		}
		return 0;
	} else{
		clr.assign(n, 0);
		for(int i = 0; i < n; i++)
			if(clr[i] == 0)
				if(!paint(i, 1)) assert(0);
		cout << 3 << endl;
		for(int i = 0; i < n; i++) cout << clr[i] << ' ';
	}
}