#include <bits/stdc++.h>
#include "Sgame.h"

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<int> p_f(string s) {
    int n = size(s);
    vector<int> p(n);
    p[0] = 0;
    for(int i = 1; i < n; i++) {
        int j = p[i - 1];
        while(j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if(s[i] == s[j]) {
            j++;
        }
        p[i] = j;
    }
    return p;
}

string s;
string t;
vector<int> p;

void start(char w[]) {
    s = "";
    for(int i = 0; w[i] != 0; i++) {
        s += w[i];
    }
}

int round(int m, int k) {
    int mx = 0;
    for(; m <= k; m++) {
        mx = 0;
        for(int i = 0; i + m - 1 < size(s); i++) {
            t = s.substr(i, m);
            t += "#";
            t += s;
            p = p_f(t);
            int ans = 0;
            int l = -1;
            bool ok = true;
            for(int j : p) {
                if(j == m) {
                    if(l != -1 && j + m - l > k) {
                        ok = false;
                        break;
                    }
                    ans++;
                    l = j;
                }
            }
            if(ok == false) {
                continue;
            }
            mx = max(mx, ans);
        }
        if(mx != 0) {
            return mx;
        }
    }
    return mx;
}

void solve() {
    string s;
    cin >> s;
    int q;
    cin >> q;
    string t;
    vector<int> p;
    while(q--) {
        int m, k;
        cin >> m >> k;
        int mx = 0;
        for(int i = 0; i + m - 1 < size(s); i++) {
            t = s.substr(i, m);
            t += "#";
            t += s;
            p = p_f(t);
            int ans = 0;
            for(int j : p) {
                if(j == m) {
                    ans++;
                }
            }
            mx = max(mx, ans);
        }
        cout << mx << "\n";
    }
}

