#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <bits/stdc++.h>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define normsize(v) int(v.size())
#define pb push_back
using namespace std;
//#pragma GCC target("avx")
#pragma GCC optimize("no-stack-protector", "unroll-loops", "fast-math", "O3")
struct segment_tree {
    vector < int > t;
    int siz;
    void build(int siz1) {
        t.resize(4 * siz1);
        siz = siz1;
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        ll ans = 0;
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return ;
        }
        int m = (l + r) / 2;
        if (val <= m) upd(v * 2 + 1, l, m, pos, val);
        else upd(v * 2 + 2, m + 1, r, pos, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};
int n;
vector < int > g[500001];
bitset < 500001 > isUsed;
char col[500001];
void buba(int v) {
    isUsed[v] = true;
    forj(g[v].size()) {
        if (isUsed[g[v][j]]) continue;
        col[g[v][j]] = 3 - col[v];
        buba(g[v][j]);
    }
}
vector < int > all0;
vector < int > all1;
vector < int > all2; /// te, y kogo 2 pocrashennix soseda
vector < char > knt;
bitset < 3 > iskek[500001];
//vector < vector < char > > iskek(maxkek, vector < char > (3, 0));

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    int x, y;

    fori(m) {
        scanf("%d %d", x, y);
        //cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    fori(n) {
        if (!isUsed[i]) {
            col[i] = 1;
            buba(i);
        }
    }
    bool ok = true;
    fori(n) {
        forj(g[i].size()) {
            if (col[i] == col[g[i][j]]) {
                ok = false;
                break;
            }
        }
        if (!ok) break;
    }
    if (ok) {
        cout << 2 << "\n";
        fori(n) cout << col[i] << " ";
        return 0;
    }
    cout << 3 << "\n";

    fori(n) col[i] = 0;
    fori(n) all0.pb(i);
    knt.resize(n);
    fori(n) knt[i] = 0;
    fori(n) isUsed[i] = 0;
    int v;
    while(true) {
        v = -1;
        if (all2.size() != 0) {
            v = all2.back();
            all2.pop_back();
            if (isUsed[v] || knt[v] != 2) continue;
        } else if (all1.size() != 0) {
            v = all1.back();
            all1.pop_back();
            if (isUsed[v] || knt[v] != 1) continue;
        } else if (all0.size() != 0) {
            v = all0.back();
            all0.pop_back();
            if (isUsed[v] || knt[v] != 0) continue;
        } else break;
        isUsed[v] = true;
        if (iskek[v][0] == 0) {
            col[v] = 1;
            for (int j = 0; j < g[v].size(); j++) {
                if (isUsed[g[v][j]]) continue;
                if (iskek[g[v][j]][0] == 0) {
                    if (knt[g[v][j]] == 1 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all2.pb(g[v][j]);
                    } else if (knt[g[v][j]] == 0 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all1.pb(g[v][j]);
                    }
                }
                iskek[g[v][j]][0] = 1;
            }
        } else if (iskek[v][1] == 0) {
            col[v] = 2;
            for (int j = 0; j < g[v].size(); j++) {
                if (isUsed[g[v][j]]) continue;
                if (iskek[g[v][j]][1] == 0) {
                    if (knt[g[v][j]] == 1 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all2.pb(g[v][j]);
                    } else if (knt[g[v][j]] == 0 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all1.pb(g[v][j]);
                    }
                }
                iskek[g[v][j]][1] = 1;
            }
        } else if (iskek[v][2] == 0) {
            col[v] = 3;
            for (int j = 0; j < g[v].size(); j++) {
                if (isUsed[g[v][j]]) continue;
                if (iskek[g[v][j]][2] == 0) {
                    if (knt[g[v][j]] == 1 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all2.pb(g[v][j]);
                    } else if (knt[g[v][j]] == 0 && isUsed[g[v][j]] == false) {
                        knt[g[v][j]]++;
                        all1.pb(g[v][j]);
                    }
                }
                iskek[g[v][j]][2] = 1;
            }
        }
    }
    fori(n) cout << int(col[i]) << " ";
    return 0;
}

/**
6 9
1 2
2 3
3 4
4 5
5 6
6 1
6 2
2 5
5 3
**/




