#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string.h>
#include <math.h>
#include <algorithm>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define normsize(v) int(v.size())
#define pb push_back
using namespace std;
#pragma GCC target("avx")
#pragma GCC optimize("no-stack-protector", "unroll-loops", "fast-math", "O3")
struct segment_tree {
    vector < int > t;
    int siz;
    void build(int siz1) {
        t.resize(4 * siz1);
        siz = siz1;
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        ll ans = 0;
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return ;
        }
        int m = (l + r) / 2;
        if (val <= m) upd(v * 2 + 1, l, m, pos, val);
        else upd(v * 2 + 2, m + 1, r, pos, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};
vector < int > keks;
int n;
vector < vector < int > > g;
void pere(int ind) {
    if (ind == n) {
        bool ok = true;
        fori(n) {
            for (int j = 0; j < g[i].size(); j++) {
                int to = g[i][j];
                if (keks[i] == keks[to]) {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
        }
        if (ok) {
            fori(n) cout << keks[i] + 1 << " ";
            exit(0);
        }
        return ;
    }
    for (int i = 0; i < 3; i++) {
        keks[ind] = i;
        pere(ind + 1);
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    keks.resize(n);
    fori(m) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    vector < int > col;
    col.resize(n);
    for (int msk = 0; msk < (1<<n); msk++) {

        for (int i = 0; i < n; i++) {
            if (((msk>>i)&1)) col[i] = 1;
            else col[i] = 0;
        }
        bool ok = true;
        fori(n) {
            for (int j = 0; j < g[i].size(); j++) {
                int to = g[i][j];
                if (col[i] == col[to]) {
                    ok = false;
                    break;
                }
            }
            if (ok == false) break;
        }
        if (!ok) continue;
        cout << 2 << "\n";
        fori(n) cout << col[i] + 1 << " ";
        return 0;
    }
    cout << 3 << "\n";
    pere(0);
}






