#ifndef ON_PC
#include "Sgame.h"
#endif

#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define pb push_back
#define vc vector
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

using ortree = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 5e3;
const int INF = 1e9;
const int MOD = 1e9+9;
const int P = 101;

int p[MAXN];
int ans[MAXN];
gp_hash_table<int, int> cleks[MAXN];
string s;

int mul(int a, int b){
	if ((ll)a * b >= MOD){
		return ((ll)a * b) % MOD;
	}
	return a * b;
}

int sum(int a, int b){
	if (a + b >= MOD){
		return a + b - MOD;
	}
	return a + b;
}
//-fsanitize=address,bounds,undefined -D_GLIBCXX_DEBUG

void start(char w[]){
	int lasts = 0;
	p[0] = 1;
	while('a' <= w[lasts] && w[lasts] <= 'z'){
		p[lasts + 1] = mul(p[lasts], P);
		s.pb(w[lasts]);
		lasts++;
	}
	for (int i = 0; i < lasts; i++){
		int mem = 0;
		for (int j = i; j < lasts; j++){
			mem = sum(mem, mul(p[j - i], s[j]));
			cleks[j - i + 1][mem]++;
		}
	}
	for (int i = 0; i <= lasts; i++){
		ans[i] = 0;
		for (auto &x : cleks[i]){
			for (char j = 'a'; j <= 'z'; j++){
				int b = sum(mul(x.fs, P), j);
				if (cleks[i + 1].find(b) != cleks[i + 1].end()){
					if (cleks[i + 1][b] >= x.sc){
						x.sc = 0;
						break;
					}
				}
				b = sum(mul(j, p[i]), x.fs);
				if (cleks[i + 1].find(b) != cleks[i + 1].end()){
					if (cleks[i + 1][b] >= x.sc){
						x.sc = 0;
						break;
					}
				}
			}
			ans[i] = max(ans[i], x.sc);
		}
	}
}

int round(int m, int k){
	int anss = 0;
	for (int d = m; d <= k; d++){
		anss = max(anss, ans[d]);
	}
	if (k > len(s)){
		exit(1);
	}
	return anss;
}

#ifdef ON_PC
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string s;
	cin >> s;
	char w[len(s) + 1];
	for (int i = 0; i < len(s); i++){
		w[i] = s[i];
	}
	w[len(s)] = ' ';
	start(w);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++){
		int a, b;
		cin >> a >> b;
		cout << round(a, b) << '\n';
	}
}
#endif