#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 3e5 + 15;
int f[N];

inline void inc(int x, int y) {
  for(; x < N; x |= (x + 1))
    f[x] += y;
}

inline int get(int x) {
  int re = 0;
  for(; x >= 0; x = (x & (x + 1)) - 1)
    re += f[x];
  return re;
}

inline int get(int x, int y) {
  return get(y) - get(x - 1);
}

int p[N], tin[N], tout[N];
vector<int> g[N];
int t;

void dfs(int v) {
  tin[v] = t++;
  for(int to : g[v])
    dfs(to);
  tout[v] = t;
}

int st[N];
inline void put(int x) {
  if (!st[x]) {
    st[x] = 1;
    inc(tin[x], 1);
  }
}

inline void cl(int x) {
  if (st[x]) {
    st[x] = 0;
    inc(tin[x], -1);
  }
}

void run() {
  int n;
  cin >> n;
  for(int i = 1; i < n; i++) {
    cin >> p[i];
    p[i]--;
    g[p[i]].push_back(i);
  }
  dfs(0);
  int q;
  cin >> q;
  while(q--) {
    int t;
    cin >> t;
    if (t == 1) {
      int x;
      cin >> x;
      --x;
      put(x);
    } else if (t == 4) {
      int x;
      cin >> x;
      --x;
      cout << get(tin[x], tout[x]);
      cout << endl;
    } else if (t == 2) {
      int x;
      cin >> x;
      --x;
      int la = -1;
      while (1) {
        if (st[x])
          for(int to : g[x]) {
            if (to != la) put(to);
          }
        cl(x);
        if (!x) break;
        la = x;
        x = p[x];
      }
    } else if (t == 3) {
      int x;
      cin >> x;
      --x;
      cl(x);
      for(int to : g[x]) {
        cl(to);
      }
    }
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  run();

}
