//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 5e5 + 1;
vector<int> g[N];
int used[N];
int clr[N];
int fl = 1;

void dfs(int v, int c) {
  used[v] = 1;
  clr[v] = c;
  for(int to : g[v]) {
    if (!used[to]) dfs(to, c ^1);
    else if (clr[to] == clr[v]) fl = 0;
  }
}

void run() {
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    g[a].push_back(b);
    g[b].push_back(a);
  }
  for(int i = 0; i < n; i++) {
    if (!used[i]) {
      dfs(i, 0);
    }
  }
  cout << 2 << '\n';
  for(int i = 0; i < n; i++)
    cout << clr[i] + 1 << ' ';
}

signed main()
{
  ios_base::sync_with_stdio(0);
  cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  run();

}
