//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 5e5 + 1;
vector<int> g[N];
int used[N];
int clr[N];
int fl = 1;

void dfs(int v, int c) {
  used[v] = 1;
  clr[v] = c;
  for(int to : g[v]) {
    if (!used[to]) dfs(to, c ^1);
    else if (clr[to] == clr[v]) fl = 0;
  }
}

int cn[3][N];
pair<int, int> e[N];

inline void check(int x) {
  int res = cn[0][x] + cn[1][x] + cn[2][x];
  if (res == 1) {
    for(int i = 0; i < 3; i++) {
      if (cn[i][x]) {
        clr[x] = i;
      }
    }
  }
}

inline void upd(int x) {
  for(int to : g[x]) {
    cn[clr[x]][to] = 0;
    check(to);
  }
}

void run() {
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    e[i] = {a, b};
    g[a].push_back(b);
    g[b].push_back(a);
  }
  for(int i = 0; i < n; i++) {
    if (!used[i]) {
      dfs(i, 0);
    }
  }
  if (fl) {
    cout << 2 << '\n';
    for(int i = 0; i < n; i++)
      cout << clr[i] + 1 << ' ';
    return;
  }
  fill(clr, clr + N, -1);
  for(int i = 0; i < 3; i++)
    fill(cn[i], cn[i] + N, 1);
  shuffle(e, e + m, gen);
  for(int i = 0; i < m; i++) {
    if (clr[e[i].x] != -1 && clr[e[i].y] == -1) continue;
    if (clr[e[i].x] != -1) swap(e[i].x, e[i].y);
    if (clr[e[i].y] != -1) {
      for(int j = 0; j < 3; j++) {
        if (cn[j][e[i].x] && clr[e[i].y] != j) {
          clr[e[i].x] = j;
          upd(e[i].x);
        }
      }
      continue;
    }
    for(int j = 0; j < 3; j++) {
      for(int k = 0; k < 3; k++) {
        if (cn[j][e[i].x] && cn[k][e[i].y] && j != k) {
          clr[e[i].x] = j;
          clr[e[i].y] = k;
          upd(e[i].x);
          upd(e[i].y);
        }
      }
    }
  }
  for(int i = 0; i < n; i++) {
    if (clr[i] == -1) {
      for(int j = 0; j < 3; j++) {
        if (cn[j][i]) {
          clr[i] = j;
          upd(i);
        }
      }
    }
  }
  cout << 3 << '\n';
  for(int i = 0; i < 3; i++) {
    cout << clr[i] + 1 << ' ';
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  run();

}
