//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 5e5 + 1;
vector<int> g[N];
int used[N];
int clr[N];
int fl = 1;

void dfs(int v, int c) {
  used[v] = 1;
  clr[v] = c;
  for(int to : g[v]) {
    if (!used[to]) dfs(to, c ^1);
    else if (clr[to] == clr[v]) fl = 0;
  }
}

int cn[3][N];
pair<int, int> e[N];

inline void check(int x) {
  int res = cn[0][x] + cn[1][x] + cn[2][x];
  if (res == 1) {
    for(int i = 0; i < 3; i++) {
      if (cn[i][x]) {
        clr[x] = i;
      }
    }
  }
}

inline void upd(int x) {
  for(int to : g[x]) {
    cn[clr[x]][to] = 0;
    check(to);
  }
}

void run() {
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    e[i] = {a, b};
    g[a].push_back(b);
    g[b].push_back(a);
  }
  for(int i = 0; i < n; i++) {
    if (!used[i]) {
      dfs(i, 0);
    }
  }
  if (fl) {
    cout << 2 << '\n';
    for(int i = 0; i < n; i++)
      cout << clr[i] + 1 << ' ';
    return;
  }
  while (1) {
    for(int i = 0; i < n; i++) {
      clr[i] = gen() % 3;
    }
    fl = 1;
    for(int j = 0; j < n && fl; j++) {
      for(int to : g[j]) {
        if (clr[to] == clr[j]) {
          fl = 0;
        }
      }
    }
    if (fl){
      cout << 3 << '\n';
      for(int j = 0; j < n; j++) {
        cout << clr[j] + 1 << ' ';
      }
      return;
    }
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  run();

}
