#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double

ll INF = (ll) 1e20;
ll iINF = (int) 1e20;
ll mod = 1e9 + 7;

void second(ll v, vector <vector <ll> > &nodes, vector <ll> &pr, vector <bool> &inf, ll nxt) {
    if(v == -1)
        return;
    if(inf[v])
    for(int i = 0; i < nodes[v].size(); ++i) {
        if(nxt != nodes[v][i] && nodes[v][i] != pr[v]) {
            inf[nodes[v][i]] = true;
        }
    }
    inf[v] = false;
    second(pr[v], nodes, pr, inf, v);
}

ll getsum(ll v, vector <vector <ll> > &nodes, vector <bool> &inf, vector <ll> &pr) {
    ll sum = inf[v];
    for(int i = 0; i < nodes[v].size(); ++i) {
        if(nodes[v][i] != pr[v]) {
            sum += getsum(nodes[v][i], nodes, inf, pr);
        }
    }
    return sum;
}

signed main() {
    ll n;
    cin >> n;
    vector <vector <ll> > nodes(n);
    vector <ll> pr(n, -1);
    for(int i = 1; i < n; ++i) {
        ll p;
        cin >> p;
        pr[i] = p - 1;
        nodes[i].push_back(p - 1);
        nodes[p - 1].push_back(i);
    }
    ll q;
    cin >> q;
    vector <bool> inf(n, false);
    for(int i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        if(t == 1) {
            ll v;
            cin >> v;
            inf[v - 1] = true;
        }
        else if(t == 3) {
            ll v;
            cin >> v;
            --v;
            inf[v] = false;
            for(int j = 0; j < nodes[v].size(); ++j) {
                if(nodes[v][j] != pr[v])
                    inf[nodes[v][j]] = false;
            }
        }
        else if(t == 2) {
            ll v;
            cin >> v;
            second(v - 1, nodes, pr, inf, -1);
        }
        else {
            ll v;
            cin >> v;
            cout << getsum(v - 1, nodes, inf, pr) << endl;
        }
    }
}
/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
