#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 3e5 + 7;
const int K = 20;

vector <int> g[N];
int st[N][K];
int par[N];
int fenw[N], two_fenw[N];
int tin[N], tout[N];

int tt = 0;

void dfs(int v) {
	st[v][0] = par[v];
	if (par[v] == -1) st[v][0] = 0;
	for (int i = 1; i < K; i++) {
		st[v][i] = st[st[v][i - 1]][i - 1];
	}
	tin[v] = tt++;
	for (int to : g[v]) {
		dfs(to);
	}
	tout[v] = tt;
}

bool check_par(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void two_inc(int x, int y) {
	for (; x < N; x = (x | (x + 1))) {
		two_fenw[x] += y;
	}
}

int two_get(int x) {
	int ans = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1) {
		ans += two_fenw[x];
	}
	return ans;
}

void inc(int x, int y) {
	for (; x < N; x = (x | (x + 1))) {
		fenw[x] += y;
	}
}

int get(int x) {
	int ans = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1) {
		ans += fenw[x];
	}
	return ans;
}

bool bad[N];

void mark(int v) {
	if (!bad[v]) {
		bad[v] = true;
		inc(tin[v], 1);
		two_inc(tin[v], 1);
		two_inc(tout[v], -1);
	}
}

void del_mark(int v) {
	if (bad[v]) {
		bad[v] = false;
		inc(tin[v], -1);
		two_inc(tin[v], -1);
		two_inc(tout[v], 1);
	}
}

int get_sum(int v) {
	return two_get(tin[v]);
}

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	par[0] = -1;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(i);
		par[i] = p;
	}
	dfs(0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			x--;
			mark(x);
		} else if (t == 2) {
			int x;
			cin >> x;
			x--;
			int v = x;
			vector <int> pth;
			while (get_sum(x)) {
				v = x;
				for (int i = K - 1; i >= 0; i--) {
					if (get_sum(st[v][i])) {
						v = st[v][i];
					}
				}
				del_mark(v);
				pth.push_back(v);
			}
			v = x;
			for (int x : pth) {
				for (auto c : g[x]) {
					if (!check_par(c, v)) {
						mark(c);
					}
				}
			}
		} else if (t == 3) {
			int x;
			cin >> x;
			x--;
			for (auto c : g[x]) {
				del_mark(c);
			}
			del_mark(x);
		} else {
			int v;
			cin >> v;
			v--;
			cout << get(tout[v] - 1) - get(tin[v] - 1) << endl;
		}
	}
}
