#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 3e5 + 7;
const int K = 20;

int t[4 * N];
int d[4 * N];

void upd(int v, int l, int r, int x) {
	t[v] = x * (r - l);
	d[v] = x;
}

void push(int v, int l, int r) {
	if (d[v] != -1) {
		int m = (l + r) / 2;
		upd(v * 2 + 1, l, m, d[v]);
		upd(v * 2 + 2, m, r, d[v]);
		d[v] = -1;
	}
}

int get(int v, int l, int r, int tl, int tr) {
	if (tl >= r || tr <= l || l >= r) {
		return 0;
	}
	if (tl >= l && tr <= r) {
		return t[v];
	} else {
		int tm = (tl + tr) / 2;
		push(v, tl, tr);
		return get(v * 2 + 1, l, r, tl, tm) + get(v * 2 + 2, l, r, tm, tr);
	}
}

void upd(int v, int l, int r, int tl, int tr, int x) {
	if (tl >= r || tr <= l || l >= r) {
		return;
	}
	if (tl >= l && tr <= r) {
		upd(v, tl, tr, x);
	} else {
		int tm = (tl + tr) / 2;
		push(v, tl, tr);
		upd(v * 2 + 1, l, r, tl, tm, x);
		upd(v * 2 + 2, l, r, tm, tr, x);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}
}

vector <int> g[N];
int st[N][K];
int par[N];
int two_fenw[N];

int tt = 0;

vector <int> ord;

int ind[N], l[N], r[N];
int chl[N], chr[N];
int tin[N], tout[N];

void dfs(int v) {
	st[v][0] = par[v];
	if (par[v] == -1) st[v][0] = 0;
	for (int i = 1; i < K; i++) {
		st[v][i] = st[st[v][i - 1]][i - 1];
	}
	tin[v] = tt++;
	chl[v] = ord.size();
	for (int to : g[v]) {
		ind[to] = ord.size();
		ord.push_back(to);
	}
	chr[v] = ord.size();
	for (int to : g[v]) {
		l[to] = ord.size();
		dfs(to);
		r[to] = ord.size();
	}
	tout[v] = tt++;
}

bool park(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int n;

bool marked(int i) {
	return get(0, ind[i], ind[i] + 1, 0, n);
}

void two_inc(int x, int y) {
	for (; x < N; x = (x | (x + 1))) {
		two_fenw[x] += y;
	}
}

int two_get(int x) {
	int ans = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1) {
		ans += two_fenw[x];
	}
	return ans;
}

void mark(int v) {
	upd(0, ind[v], ind[v] + 1, 0, n, 1);
	two_inc(ind[v], 1);
	two_inc(ind[v] + 1, -1);
	two_inc(l[v], 1);
	two_inc(r[v], -1);
}

void dec_vis(int v) {
	two_inc(ind[v], -1);
	two_inc(ind[v] + 1, 1);
	two_inc(l[v], -1);
	two_inc(r[v], 1);
}

/*
void del_mark(int v) {
	if (bad[v]) {
		if (par[v] != -1) {
		bad[v] = false;
		inc(tin[v], -1);
		two_inc(tin[v], -1);
		two_inc(tout[v], 1);
	}
}
*/

int get_sum(int v) {
	return two_get(ind[v]);
}


int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < 4 * (n + 1); i++) {
		d[i] = -1;
	}
	par[0] = -1;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(i);
		par[i] = p;
	}
	ind[0] = 0;
	ord.push_back(0);
	l[0] = ord.size();
	dfs(0);
	r[0] = ord.size();
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			x--;
			mark(x);
		} else if (t == 2) {
			int x;
			cin >> x;
			x--;
			int v = x;
			vector <int> pth;
			while (v != -1) {
				if (marked(v)) {
					upd(0, ind[v], ind[v] + 1, 0, n, 0);
					pth.push_back(v);
				}
				v = par[v];
			}
			v = x;
			for (int x : pth) {
				int me = v;
				if (me == x) {
					upd(0, chl[x], chr[x], 0, n, 1);
				} else {
					for (int i = K - 1; i >= 0; i--) {
						if (!park(st[st[me][i]][0], x)) {
							me = st[me][i];
						}
					}
					upd(0, chl[x], ind[me], 0, n, 1);
					upd(0, ind[me] + 1, chr[x], 0, n, 1);
				}
			}
		} else if (t == 3) {
			int x;
			cin >> x;
			x--;
			upd(0, ind[x], ind[x] + 1, 0, n, 0);
			upd(0, chl[x], chr[x], 0, n, 0);
		} else {
			int v;
			cin >> v;
			v--;
			cout << marked(v) + get(0, l[v], r[v], 0, n) << '\n';
		}
	}
}
