#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int M = 1e6 + 7;

bool term[M];
map <char, int> to[M];
int link[M];
int len[M];

int sz = 0;
int last = 0;

void init() {
	link[0] = -1;
	len[0] = 0;
	sz = 1;
	last = 0;
}

void add_char(char c) {
	int v = last;
	int me = sz++;
	len[me] = len[last] + 1;
	while (v != -1 && !to[v].count(c)) {
		to[v][c] = me;
		v = link[v];
	}
	if (v != -1) {
		int go = to[v][c];
		if (len[go] == len[v] + 1) {
			link[me] = go;
		} else {
			int cl = sz++;
			len[cl] = len[v] + 1;
			link[cl] = link[go];
			link[go] = cl;
			to[cl] = to[go];
			while (v != -1 && to[v][c] == go) {
				to[v][c] = cl;
				v = link[v];
			}
			link[me] = cl;
		}
	} else {
		link[me] = 0;
	}
	last = me;
}

int dp[M];
vector <pair <pair <int, int>, int> > e;

void start(char w[]) {
	int n = strlen(w);
	init();
	for (int i = 0; i < n; i++) {
		add_char(w[i]);
	}
	int v = last;
	while (v != -1) {
		term[v] = true;
		v = link[v];
	}
	vector <int> ord;
	for (int i = 1; i < sz; i++) {
		ord.push_back(i);
	}
	sort(ord.begin(), ord.end(), [&] (int i, int j) {
		return len[i] > len[j];
	});
	for (int v : ord) {
		dp[v] = term[v];
		for (auto c : to[v]) {
			dp[v] += dp[c.second];
		}
		int vl = len[v];
		for (auto c : to[v]) {
			if (dp[c.second] == dp[v])
				vl = max(vl, len[c.second]);
		}
		e.push_back({{len[v], vl}, dp[v]});
		//ans[len[v]] = max(ans[len[v]], dp[v]);
	}
	/*
	for (int i = n - 1; i >= 0; i--) {
		ans[i] = max(ans[i], ans[i + 1]);
	}
	*/
}

int round(int m, int k) {
	int val = 0;
	for (auto c : e) {
		if (c.first.first >= m && c.first.second <= k) {
			val = max(val, c.second);
		}
	}
	return val;
}

/*
char t[50];

int main() {
	string s = "abcabcabcdedea";
	for (int i = 0; i < (int) s.size(); i++) t[i] = s[i];
	start(t);
	cout << round(1, 2) << endl;
	cout << round(2, 3) << endl;
	cout << round(2, 2) << endl;
}
*/
