#include "Sgame.h"
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 110;
int n, occ[mx][mx];
string s;

void start(char *w) {
	while (w[n]) {
		s.push_back(w[n++]);
	}
	map<string, int> mp;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			mp[s.substr(i, j - i + 1)]++;
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			occ[i][j] = mp[s.substr(i, j - i + 1)];
		}
	}
}

int round(int m, int k) {
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			int len = j - i + 1;
			if (len < m || len > k) {
				continue;
			}
			int cnt = occ[i][j];
			if (i + k < n && occ[i][i + k] == cnt) {
				continue;
			}
			if (j - k >= 0 && occ[j - k][j] == cnt) {
				continue;
			}
			chkmax(ans, cnt);
		}
	}
	return ans;
}
