#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T> void uax(T &a, T b) { if (b > a) a = b; }
template<typename T> void uin(T &a, T b) { if (b < a) a = b; }

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define x first
#define y second
#define right right228
#define left left228
#define prev pref228

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;

mt19937 rnd(time(NULL));

const int N = 500001;
vector<int> p, cnt, ord, root, g[N], pos, k, tin, tout;
int timer = 0;
void dfs(int v) {
	cnt[v] = 1;
	tin[v] = timer++;
	for (auto to : g[v]) {
		dfs(to);
		cnt[v] += cnt[to];
	}
	forn(i, g[v].size()) {
		auto to = g[v][i];
		if (cnt[to] * 2 >= cnt[v]) {
			g[v].erase(g[v].begin() + i, g[v].begin() + i + 1);
			g[v].insert(g[v].begin(), to);
			break;
		}
	}
	tout[v] = timer++;
}
bool ispr(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
void zhfs(int v) {
	pos[v] = (int)k.size();
	k.push_back(v);
	ord.push_back(0);
	for (auto to : g[v]) {
		if (cnt[to] * 2 >= cnt[v]) root[to] = root[v];
		else root[to] = to;
		zhfs(to);
	}
}
struct node {
	int l, r, sum;
	node() { l = r = -1; sum = 0; }
};
int xx;
struct Segment_Tree {
	vector<node> t;
	void build(int v, int l, int r) {
		t[v].l = l, t[v].r = r;
		if (l + 1 < r) {
			int m = (l + r) >> 1;
			build(v + v, l, m); build(v + v + 1, m, r);
		}
	}
	Segment_Tree(int n) {
		t.resize(4 * n);
		build(1, 0, n);
	}
	void upd(int pos, int x, int v = 1) {
		if (t[v].l + 1 == t[v].r) {
			t[v].sum = x;
			ord[t[v].l] = x;
		}
		else {
			int m = (t[v].l + t[v].r) >> 1;
			if (pos < m) upd(pos, x, v + v);
			else upd(pos, x, v + v + 1);
			t[v].sum = t[v + v].sum + t[v + v + 1].sum;
		}
	}
	void del(int l, int r, int v = 1) {
		if (t[v].sum == 0) return;
		if (l >= r) return;
		if (t[v].l + 1 == t[v].r) {
			for (auto to : g[k[l]]) {
				if (ispr(to, xx)) continue;
				upd(pos[to], 1);
			}
			t[v].sum = 0;
		}
		else {
			int m = (t[v].l + t[v].r) >> 1;
			del(l, min(m, r), v + v);
			del(max(l, m), r, v + v + 1);
			t[v].sum = t[v + v].sum + t[v + v + 1].sum;
		}
	}
	int sum(int l, int r, int v = 1) {
		if (l >= r) return 0;
		if (t[v].l == l && t[v].r == r) return t[v].sum;
		int m = (t[v].l + t[v].r) >> 1;
		return sum(l, min(m, r), v + v) + sum(max(l, m), r, v + v + 1);
	}
};
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	int n;
	cin >> n;
	p.assign(n, -1);
	firn(i, n) {
		int v;
		cin >> v;
		p[i] = v - 1;
		g[v - 1].push_back(i);
	}
	cnt.assign(n, 0);
	pos.resize(n);
	root.assign(n, 0);
	tin.resize(n); tout.resize(n);
	dfs(0);
	zhfs(0);
	Segment_Tree T(n);
	int q;
	cin >> q;
	// forn(i, n) cout << k[i] << ' ';
	// forn(i, n) cout << root[i] << ' ';
	// cout << el;
	while(q--) {
		// forn(i, n) cout << ord[i] << ' ';
		// cout << el;
		int type, x;
		cin >> type >> x;
		x--;
		xx = x;
		if (type == 1) {
			T.upd(pos[x], 1);
			continue;
		}
		if (type == 3) {
			T.upd(pos[0], 0);
			for (auto to : g[0]) T.upd(pos[to], 0);
			continue;
		}
		if (type == 4) {
			cout << T.sum(pos[x], pos[x] + cnt[x]) << el;
			continue;
		}
		for (; x >= 0; x = p[root[x]]) {
			int l1 = pos[root[x]], r1 = pos[x] + 1;
			T.del(l1, r1);
		}
	}
	return 0;
}

