#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 5e5 + 100, LG = 17;
int used[N];
std::vector<int> g[N];
int n, m;
bool fl = true;
void dfs(int v, int curClr = 1) {
	used[v] = curClr;
	for (auto e : g[v]) {
		if (!used[e]) {
			dfs(e, 3 - curClr);
		}
		if (used[e] == curClr) {
			fl = false;
		}
	}
}
bool check(int mask) {
	memset(used, 0, sizeof(used));
	fl = true;
	FOR(i, n) {
		if (!used[i]) dfs(i);
	}
	return fl;
}
int mex(int c1, int c2) {
	for (int j = 0; j <= 3; ++j) {
		if (j != c1 && j != c2) {
			return j;
		}
	}
	return -1;
}
void solve(int l, int r, int c1, int c2) {
	if (l >= r) return;
	// while (l < r && g[l].size() == 0) {
	// 	++l;
	// }
	// while (l < r && g[r].size() == 0) {
	// 	--r;
	// }
	// debug(l << ' ' << r)
	used[l] = c1, used[r] = c2;
	int other = mex(c1, c2);
	int mx1 = l, mn2 = r;
	for (auto e : g[l]) {
		if (e < r)
			mx1 = std::max(mx1, e);
	}
	for (auto e : g[r]) {
		if (e > l)
			mn2 = std::min(mn2, e);
	}
	if (mx1 == mn2) {
		solve(l, mx1, c1, other);
		solve(mn2, r, other, c2);
	}
	else {
		solve(l, mx1, c1, (c1 + 1) % 3);
		solve(mn2, r, (c2 + 1) % 3, c2);
		if (mx1 != l && mn2 != r)
			solve(mx1, mn2, (c1 + 1) % 3, (c2 + 1) % 3);
	}
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n >> m;
	// std::vector<std::pair<int,int>> seg(m);
	std::vector<std::pair<int,int>> lel;
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		if (a > b) {
			std::swap(a, b);
		}
		g[a].pb(b);
		g[b].pb(a);
		lel.pb({a, b});
	}
	if (check(0)) {
		std::cout << 2 << '\n';
		FOR(i, n) {
			std::cout << used[i] << ' ';
		}
		return 0;
	}
	memset(used, 0, sizeof(used));
	std::sort(lel.begin(), lel.end());
	int r = -1;
	FOR(i, lel.size()) {
		int r1 = i;
		r = lel[i].second;
		while (r1 < m && lel[r1].first <= r) {
			r = std::max(lel[r1].second, r);
			r1++;
		}
		solve(lel[i].first, r, 0, 2);
		i = r1 - 1;
	}
	std::cout << 3 << '\n';
	FOR(i, n) {
		std::cout << used[i] + 1 << ' ';
	}
	// return -1;
}