
#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6 + 100;
int n;
string s;
map<string, int> cnt;
map<string, set<int>> lef;
map<string, set<int>> rig;

int answer[N];

void start (char input[]) {
	s = string(input);
	n = (int)s.size();
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= n - i; ++j) {
			++cnt[s.substr(i, j)];
			if (i) {
				lef[s.substr(i, j)].insert(s[i - 1]);
			} else {
				lef[s.substr(i, j)].insert(-1);
			}
			if (i + j < n) {
				rig[s.substr(i, j)].insert(s[i + j]);
			} else {
				rig[s.substr(i, j)].insert(-1);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= n - i; ++j) {
			string cur = s.substr(i, j);
			if (lef[cur].size() > 1 && rig[cur].size() > 1) {
				answer[cur.size()] = max(answer[cur.size()], cnt[cur]);
			}
		}
	}
}

int round (int l, int r) {
	int res = 0;
	for (int i = l; i <= r; ++i) {
		res = max(res, answer[i]);
	}
	return res;
}



#ifdef LC
char w_gr[5000001];
int main () {
	assert(freopen("input.txt", "r", stdin));
    int n,q,i,m,k;
	cin >> w_gr;
    start(w_gr);
    cin >> q;
	for (i=1; i<=q; i++) {
    	cin >> m >> k;
        cout << round(m,k) << endl ;
    }
    return 0;
}
#endif
