#include <bits/stdc++.h>
#ifndef PC 
	#include "Sgame.h"
#endif 
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
const int P = 239017;
const int MOD = 1e9 + 7;
const int MOD2 = 998244353;
int mult(int a, int b) {
	return (a * 1ll * b) % MOD;
}

void add(int &a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
	return a;
}

int mult2(int a, int b) {
	return (a * 1ll * b) % MOD2;
}

void add2(int &a, int b) {
	a += b;
	if (a >= MOD2) {
		a -= MOD2;
	}
}

int sum2(int a, int b) {
	a += b;
	if (a >= MOD2) {
		a -= MOD2;
	}
	return a;
}

string s;
bool small;
int p_pow[N], p_pow2[N], hs[N], hs2[N]	;
int get_hash(int l, int r) {
	int res = hs[r];
	if (l) {
		res -= hs[l - 1];
		if (res < 0) {
			res += MOD;
		}
	}
	return mult(res, p_pow[100000 - r]);
}

int get_hash2(int l, int r) {
	int res = hs2[r];
	if (l) {
		res -= hs2[l - 1];
		if (res < 0) {
			res += MOD2;
		}
	}
	return mult2(res, p_pow2[100000 - r]);
}

void start(char w[]) {
	p_pow[0] = 1;
	p_pow2[0] = 1;
	for (int i = 1; i <= 1e5; i++) {
		p_pow[i] = mult(p_pow[i - 1], P);
		p_pow2[i] = mult2(p_pow2[i - 1], P);
	}
	int ptr = 0;
	while ((int)w[ptr] != 0) {
		s.pb(w[ptr++]);
	}
	hs[0] = mult(s[0], p_pow[0]);
	hs2[0] = mult2(s[0], p_pow2[0]);
	for (int i = 1; i < SZ(s); i++) {
		hs[i] = sum(hs[i - 1], mult(p_pow[i], s[i]));
		hs2[i] = sum2(hs2[i - 1], mult2(p_pow2[i], s[i]));
	}
}

int round(int m, int k) {
	map<pair<int, int>, int> cnt;
	for (int i = 0; i + m <= SZ(s); i++) {
		//cout << get_hash2(i, i + m - 1) << '\n';
		cnt[{get_hash(i, i + m - 1), get_hash2(i, i + m - 1)}]++;
	}
	int ans = 0;
	for (auto it : cnt) {
		ans = max(ans, it.S);
	}
	return ans;
}

#ifdef PC 
char w_gr[5000001];
int main () {
    char w[3];
    w[0] = 'a';
    w[1] = 'a';
    w[2] = 0;
    start(w);
    cout << round(1, 2) << '\n';
    return 0;
}
#endif
