#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 5e5 + 10;
vector<int> g[N];
int color[N], mx;
void dfs(int v) {
        set<int> st;
        for (auto u : g[v]) {
                if (color[u]) {
                        st.insert(color[u]);
                }
        }
        color[v] = 1;
        while (st.find(color[v]) != st.end()) {
                color[v]++;
        }
        mx = max(mx, color[v]);
}

mt19937 rnd(228);

signed main() {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        int n, m;
        cin >> n >> m;
        for (int  i= 0; i < m; i++) {
                int u, v;
                cin >> u >> v;
               g[u].pb(v);
               g[v].pb(u);
        }
        for (int i = 1; i <= n; i++) {
                if (!color[i]) {
                        dfs(i);
                }
        }
        pair<int, vector<int>> best;
        best.F = n + 1;
        vector<int> order;
        for (int i = 1; i <= n; i++) {
        	order.pb(i);
        }
        while (clock() * 1.0  /CLOCKS_PER_SEC < 0.3) {
        	shuffle(all(order), rnd);
        	for (int i = 1; i <= n; i++) {
        		shuffle(all(g[i]), rnd);
        		color[i] = 0;
        	}
        	mx = 0;
        	for (int i : order) {
        		if (!color[i]) {
                        dfs(i);
                }
        	}
        	vector<int> cl;
        	for (int i = 1; i <= n; i++) {
        		cl.pb(color[i]);
        	}
        	best = min(best, make_pair(mx, cl));
        }

        cout << best.F << '\n';
        for (int i : best.S) {
                cout << i << ' ';
        }
        cout << '\n';
}                                                                                                                                                                                                       