#include <bits/stdc++.h>

using namespace std;

const int N = 5e5 + 7;

int cl[N];
vector <int> g[N];

bool bad = false;

void dfs(int u) {
	for (auto v : g[u]) {
		if (cl[v] == -1) {
			cl[v] = cl[u] ^ 1;
			dfs(v);
		} else if (cl[v] != (cl[u] ^ 1)) {
			bad = true;
		}
	}
}

vector <pair <int, int>> seg;
map <pair <int, int>, int> num;
vector <int> go[N];

int n;

struct ch {
	int l, r, a, b;
};

vector <ch> nd;

void jhfs(int u) {
	int a = cl[seg[u].first];
	int b = cl[seg[u].second];

	for (auto v : go[u]) {
		if (cl[seg[v].first] == -1) {
			cl[seg[v].first] = a;
		}
		if (cl[seg[v].second] == -1) {
			cl[seg[v].second] = 1 ^ 2 ^ b ^ cl[seg[v].first];
		}
		jhfs(v);
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int m;
	cin >> n >> m;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
		seg.push_back({u, v});
	}
	fill(cl, cl + n, -1);
	for (int i = 0; i < n; ++i) {
		if (cl[i] == -1) {
			cl[i] = 0;
			dfs(i);
		}
	}
	if (!bad) {
		cout << 2 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	} else {
		for (int i = 0; i < n; ++i) cl[i] = -1;
		sort(seg.begin(), seg.end(), [&] (pair <int, int> f, pair <int, int> s) {
			return f.second - f.first < s.second - s.first;
		});
		if (seg.back() != make_pair(0, n - 1)) seg.push_back({0, n - 1});
		for (int i = 0; i < (int)seg.size(); ++i) num[seg[i]] = i;
		set <pair <int, int>> cur;
		for (auto p : seg) {
			int id = num[p];
			while (true) {
				auto it = cur.lower_bound(make_pair(p.first, -1));
				if (it == cur.end()) break;
				if (it->second <= p.second) {
					go[id].push_back(num[*it]);
					cur.erase(it);
				} else break;
			}
			cur.insert(p);
		}
		/*for (int i = 0; i < (int)seg.size(); ++i) {
			cout << seg[i].first + 1 << ' ' << seg[i].second + 1 << endl;
			cout << "rofl\n";
			for (int j : go[i]) {
				cout << seg[j].first + 1 << ' ' << seg[j].second + 1 << endl;
			}
			cout << "enrofl\n";
		}*/
		cl[0] = 0;
		cl[n - 1] = 1;
		jhfs((int)seg.size() - 1);
		for (int i = 0; i < n; ++i) if (cl[i] == -1) cl[i] = 0;
		cout << 3 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	}
}