#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
vector <int> g[N];
vector <int> gs[N];

int l[N], r[N], sz[N];
int st[N], en[N];
 
int par[N];
bool hv[N];
int nxt[N];

set <pair <int, int>> who[N];

void prepare(int u) {
	sz[u] = 1;
	for (auto v : g[u]) {
		prepare(v);
		sz[u] += sz[v];
	}
	for (int i = 1; i < (int)g[u].size(); ++i) {
		if (sz[g[u][i]] > sz[g[u][0]]) swap(g[u][i], g[u][0]);
	}
}

vector <int> e;

int dfs(int u, int p, int s) {
	par[u] = p;
	st[u] = s;
	e.push_back(u);
	l[u] = (int)e.size() - 1;
	if (!g[u].empty()) {
		nxt[u] = g[u][0];
		en[u] = dfs(g[u][0], u, s);
		for (int i = 1; i < (int)g[u].size(); ++i) {
			dfs(g[u][i], u, g[u][i]);
		}
	} else {
		en[u] = u;
		nxt[u] = -1;
	}
	r[u] = (int)e.size() - 1;
	return en[u];
}

bool anc(int a, int b) {
	return l[a] <= l[b] && r[b] <= r[a];
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
	}
	prepare(0);
	dfs(0, -1, 0);
	int q;
	cin >> q;
	while (q--) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			--x;
			hv[x] = 1;
		} else if (t == 2) {
			int x;
			cin >> x;
			--x;
			int cur = x;
			while (cur != -1) {
				if (hv[cur]) for (auto v : g[cur]) hv[v] = true;
				cur = par[cur];
			}
			cur = x;
			while (cur != -1) {
				hv[cur] = false;
				cur = par[cur];
			}
		} else if (t == 3) {
			int x;
			cin >> x;
			--x;
			for (auto v : g[x]) {
				hv[v] = false;
			}
			hv[x] = false;
		} else {
			int x;
			cin >> x;
			--x;
			int res = 0;
			for (int i = 0; i < n; ++i) {
				if (anc(x, i) && hv[i]) ++res;
			}
			cout << res << '\n';
		}
	}
}