#include <bits/stdc++.h>

using namespace std;

const int N = 5e5 + 7;

int cl[N];
vector <int> g[N];

bool bad = false;

void dfs(int u) {
	for (auto v : g[u]) {
		if (cl[v] == -1) {
			cl[v] = cl[u] ^ 1;
			dfs(v);
		} else if (cl[v] != (cl[u] ^ 1)) {
			bad = true;
		}
	}
}

bool rec(int u) {
	//cout << u << ' ' << cl[u] << endl;
	for (auto v : g[u]) {
		if (cl[v] == -1) {
			cl[v] = (cl[u] + 1) % 3;
			if (rec(v)) return true;
			cl[v] = (cl[u] + 2) % 3;
			assert(rec(v));
		} else if (cl[v] == cl[u]) {
			return false;
		}
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	fill(cl, cl + n, -1);
	for (int i = 0; i < n; ++i) {
		if (cl[i] == -1) {
			cl[i] = 0;
			dfs(i);
		}
	}
	if (!bad) {
		cout << 2 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	} else {
		for (int i = 0; i < n; ++i) cl[i] = -1;
		for (int i = 0; i < n; ++i) {
			if (cl[i] == -1) {
				cl[i] = 0;
				rec(i);
			}
		}
		cout << 3 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	}
}