#include <bits/stdc++.h>

using namespace std;

const int N = 300 + 7;

int cl[N];
vector <int> g[N];

bool bad = false;

void dfs(int u) {
	for (auto v : g[u]) {
		if (cl[v] == -1) {
			cl[v] = cl[u] ^ 1;
			dfs(v);
		} else if (cl[v] != (cl[u] ^ 1)) {
			bad = true;
		}
	}
}

/*bool rec(int u) {
	//cout << u + 1 << ' ' << cl[u] + 1 << endl;
	for (auto v : g[u]) {
		if (cl[v] == -1) {
			cl[v] = (cl[u] + 1) % 3;
			if (rec(v)) return true;
			cl[v] = (cl[u] + 2) % 3;
			if (rec(v)) return true;
			cl[v] = -1;
			return false;
		} else if (cl[v] == cl[u]) {
			return false;
		}
	}
	return true;
}*/

vector <int> t;

bool used[N];
bool hv[N][N];

void jhfs(int u) {
	t.push_back(u);
	used[u] = 1;
	for (auto v : g[u]) {
		if (!used[v]) {
			jhfs(v);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
		hv[u][v] = 1;
		hv[v][u] = 1;
	}
	fill(cl, cl + n, -1);
	for (int i = 0; i < n; ++i) {
		if (cl[i] == -1) {
			cl[i] = 0;
			dfs(i);
		}
	}
	if (!bad) {
		cout << 2 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	} else {
		/*for (int i = 0; i < n; ++i) cl[i] = -1;
		for (int i = 0; i < n; ++i) {
			if (cl[i] == -1) {
				cl[i] = 0;
				rec(i);
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j : g[i]) {
				assert(cl[i] != cl[j]);
			}
		}*/
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				jhfs(i);
			}
		}
		for (int mask = 0; mask < (1 << n); ++mask) {
			for (int i = 0; i < n; ++i) {
				if (i == 0 || !hv[t[i]][t[i - 1]]) {
					cl[i] = 0;
				} else {
					if (mask & (1 << i)) cl[t[i]] = (cl[t[i - 1]] + 1) % 3;
					else cl[t[i]] = (cl[t[i - 1]] + 2) % 3;
				}
			}
			bool ok = true;
			for (int i = 0; i < n; ++i) {
				for (int j : g[i]) {
					if (cl[i] == cl[j]) {
						ok = false;
						break;
					}
				}
			}
			if (ok) break;
		}
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			for (int j : g[i]) {
				if (cl[i] == cl[j]) {
					ok = false;
					break;
				}
			}
		}
		assert(ok);
		cout << 3 << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cl[i] + 1 << ' ';
		}
	}
}