#include <bits/stdc++.h>
using namespace std;

vector <int> graf[300005];
int parent[300005];
int val[300005];

void query2(int v){
	int org = v;
	while(v){
		for(auto c : graf[v]) val[c] |= val[v];
		val[v] = 0;
		v = parent[v];
	}
	v = org;
	while(v){
		val[v] = 0;
		v = parent[v];
	}
}

void query3(int v){
	val[v] = 0;
	for(auto c : graf[v]) val[c] = 0;
}

int query4(int v){
	int res = val[v];
	for(auto c : graf[v]) res += query4(c);
	return res;
}

int main(int argc, char **argv){
	
	int n;
	cin >> n;
	for(int i=2; i<=n; i++){
		cin >> parent[i];
		graf[parent[i]].push_back(i);
	}
	int q;
	cin >> q;
	while(q--){
		int t;
		cin >> t;
		if(t == 1){
			int v;
			cin >> v;
			val[v] = 1;
		}
		if(t == 2){
			int v;
			cin >> v;
			query2(v);
		}
		if(t == 3){
			int v;
			cin >> v;
			query3(v);
		}
		if(t == 4){
			int v;
			cin >> v;
			cout << query4(v) << "\n";
		}
		for(int i=1; i<=n; i++) cout << val[i] << " ";
		cout << endl;
	}
	return 0;
}

