#include <bits/stdc++.h>
using namespace std;

vector <int> graf[300005];
int parent[300005];
int val[300005];

int bit[2000005];

int vr, n;

int in[300005];
int out[300005];
int iz[300005];

void dfs(int v){
	in[v] = ++vr;
	iz[in[v]] = v;
	for(auto c : graf[v]){
		dfs(c);
	}
	out[v] = vr;
}

void upd(int x, int val){
	while(x <= 300000){
		bit[x] += val;
		x += x & -x;
	}
}

int query(int x){
	int res = 0;
	while(x){
		res += bit[x];
		x -= x & -x;
	}
	return res;
}

void query2(int v){
	int org = v;
	while(v){
		for(auto c : graf[v]){
			if(!val[c] && val[v]){
				val[c] = val[v];
				upd(in[c], 1);
			}
		}
		v = parent[v];
	}
	v = org;
	while(v){
		if(val[v]){
			val[v] = 0;
			upd(in[v], -1);
		}
		v = parent[v];
	}
}

void query3(int v){
	if(val[v]){
		val[v] = 0;
		upd(in[v], -1);
	}
	for(auto c : graf[v]){
		if(val[c]){
			val[c] = 0;
			upd(in[c], -1);
		}
	}
}

int query4(int v){
	return query(out[v]) - query(in[v]-1);
}

int main(int argc, char **argv){
	
	cin >> n;
	for(int i=2; i<=n; i++){
		cin >> parent[i];
		graf[parent[i]].push_back(i);
	}
	dfs(1);
	int q;
	cin >> q;
	while(q--){
		int t;
		cin >> t;
		if(t == 1){
			int v;
			cin >> v;
			if(!val[v]){
				val[v] = 1;
				upd(in[v], 1);
			}
		}
		if(t == 2){
			int v;
			cin >> v;
			query2(v);
		}
		if(t == 3){
			int v;
			cin >> v;
			query3(v);
		}
		if(t == 4){
			int v;
			cin >> v;
			cout << query4(v) << "\n";
		}
		//for(int i=1; i<=n; i++) cout << val[i] << " ";
		//cout << endl;
	}
	return 0;
}

