#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define mid (l+r)/2
#define endl '\n'
#define lld long long
#define pii pair<int,int>
#define pli pair<lld,int>
#define pil pair<int,lld>
#define pll pair<lld,lld>
#define fi first
#define se second
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 500010
int N, M, col[MAXN], pos[MAXN];
vector<int> adj[MAXN];
vector<pii> e;
bool bipartite;
void dfs(int node, int boj) {
    col[node] = boj;
    for(auto x : adj[node]) {
        if(col[x] == -1) dfs(x, 3^boj);
    }
}
void dfs1(int node, int boj) {
    pos[node] = 1; col[node] = boj;
    for(auto x : adj[node]) {
        if(!pos[x]) {
            if(boj == 3) {
                dfs(x, col[x]);
            } else if(col[node] == col[x]) {
                dfs(x, 3);
            } else {
                dfs(x, col[x]);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
    cin >> N >> M;
    if(M == 0) {
        cout << 1 << endl;
        for(int i = 1; i <= N; i++) cout << 1 << ' ';
        cout << endl;
        return 0;
    }
    for(int i = 1; i <= M; i++) {
        int x,y; cin >> x >> y;
        e.pb({x, y});
        adj[x].pb(y);
        adj[y].pb(x);
    }
    for(int i = 1; i <= N; i++) col[i] = -1;
    bipartite = 1;
    for(int i = 1; i <= N; i++) {
        if(col[i] == -1) dfs(i, 1);
    }
    for(auto x : e) {
        if(col[x.fi] == col[x.se]) {
            bipartite = 0;
        }
    }
    if(bipartite) {
        cout << 2 << endl;
        for(int i = 1; i <= N; i++) cout << col[i] << ' ';
        cout << endl;
        return 0;
    }
    for(int i = 1; i <= N; i++) pos[i] = 0;
    for(int i = 1; i <= N; i++) {
        if(!pos[i]) {
            dfs1(i, col[i]);
        }
    }
    cout << 3 << endl;
    for(int i = 1; i <= N; i++) cout << col[i] << ' ';
    cout << endl;
    return 0;
}
