#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define mid (l+r)/2
#define endl '\n'
#define lld long long
#define pii pair<int,int>
#define pli pair<lld,int>
#define pil pair<int,lld>
#define pll pair<lld,lld>
#define fi first
#define se second
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 300010
int N, p[MAXN], Q, siz[MAXN], idx[MAXN], bit[MAXN], timer;
void update(int idx, int val) {
    while(idx < MAXN) {
        bit[idx] += val;
        idx += idx&-idx;
    }
}
int query(int idx) {
    int rez = 0;
    while(idx) {
        rez += bit[idx];
        idx -= idx&-idx;
    }
    return rez;
}
vector<int> adj[MAXN];
void namesti(int node, int val) {
    node = idx[node];
    val -= (query(node)-query(node-1));
    update(node, val);
}
void up(int node, int prev) {
    if(node == 0) return;
    if(query(idx[node])-query(idx[node]-1) > 0) {
        for(auto x : adj[node]) {
            if(x != prev) namesti(x, 1);
        }
        namesti(node, 0);
    }
    up(p[node], node);
}
int dfs(int node) {
    idx[node] = ++timer;
    siz[node] = 1;
    for(auto x : adj[node]) {
        siz[node] += dfs(x);
    }
    return siz[node];
}
int main() {
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
    cin >> N;
    for(int i = 2; i <= N; i++) {
        cin >> p[i];
        adj[p[i]].pb(i);
    }
    dfs(1);
    cin >> Q;
    while(Q--) {
        int tip, x; cin >> tip >> x;
        if(tip == 1) {
            namesti(x, 1);
        } if(tip == 2) {
            up(x, x);
        } if(tip == 3) {
            for(auto y : adj[x]) {
                namesti(y, 0);
            }
        } if(tip == 4) {
            cout << query(idx[x]+siz[x]-1) - query(idx[x]-1) << endl;
        }
    }
    return 0;
}
