#include <bits/stdc++.h>
using namespace std;
#define pb push_back
const int N=500050;
const int H=1005;
int deg[N],U[N],V[N],dst,ans[N],tmp[N],n,m;
void rot_e()
{
	for(int i=1;i<=m;i++)
	{
		U[i]-=dst-1;
		if(U[i]<=0) U[i]+=n;
		V[i]-=dst-1;
		if(V[i]<=0) V[i]+=n;
	}
}
vector<int> E[N];
bool has[H][H];
void Solve(int L, int R, int l, int r)
{
	if(l>r) return;
	int last=L,st=l;
	vector<int> ls,rs;
	bool ok=0;
	for(int i=l;i<=r;i++)
	{
		if(has[i][L] && !has[i][R]) ls.pb(i);
		if(has[i][R] && !has[i][L]) rs.pb(i);
		if(has[i][L] && has[i][R]) ans[i]=ans[L]^ans[R],ok=1;
		/*if(has[i][L] || has[i][R])
		{
			if(has[i][L]) ans[i]^=ans[R];
			if(has[i][R]) ans[i]^=ans[L];
			if(last!=L && has[last][i] && ans[i]==ans[last]) ans[i]^=ans[last];
			Solve(last,i,st,i-1);
			st=i+1;
			last=i;
		}*/
	}
	if(ok || ls.size() && rs.size())
	{
		reverse(ls.begin(),ls.end());
		int col=ans[R];
		for(int i:ls) ans[i]=col,col^=ans[L];
		col=ans[L];
		for(int i:rs) ans[i]=col,col^=ans[R];
	}
	else
	{
		reverse(ls.begin(),ls.end());
		int col=ans[R]^ans[L];
		for(int i:ls) ans[i]=col,col^=ans[L];
		col=ans[L]^ans[R];
		for(int i:rs) ans[i]=col,col^=ans[R];
	}
	//printf("%i %i (%i %i)\n",L,R,l,r);
	//for(int i=l;i<=r;i++) if(has[i][L]|| has[i][R]) printf("(%i %i) ",i,ans[i]);
	//printf("\n");


	for(int i=l;i<=r;i++)
	{
		if(has[i][L] || has[i][R])
		{
			Solve(last,i,st,i-1);
			//printf("(%i %i) ",i,ans[i]);
			assert(ans[i]!=ans[last]);
			st=i+1;
			last=i;
		}
	}
	//printf("\n");
	if(last==L)
	{
		while(l<=r && deg[l]==0) ans[l]=1,l++;
		if(l>r) return;
        int z=E[l][0];
        assert(z>l && z<=r);
        ans[l]=1;ans[z]=2;
        Solve(l,z,l+1,z-1);
        Solve(z,l,z+1,r);
	}
	else Solve(last,R,st,r);
	/*if(l>r) return;
	int i_l=lower_bound(E[L].begin(),E[L].end(),l)-E[L].begin();
	int i_r=lower_bound(E[R].begin(),E[R].end(),l)-E[R].begin();
	//printf("%i %i %i %i\n",L,R,l,r);
	//printf("E[L]: ");for(int x:E[L]) printf("%i ",x);printf("\n");
	//printf("E[R]: ");for(int x:E[R]) printf("%i ",x);printf("\n");
	int last=L,st=l;
	while(1)
	{
		int u=i_l<E[L].size()?E[L][i_l]:r+1;
		int v=i_r<E[R].size()?E[R][i_r]:r+1;
		//printf("%i %i\n",u,v);
		if(u>r && v>r) break;
		if(u==v)
		{
			ans[u]=ans[L]^ans[R];
			Solve(last,u,st,u-1);
			last=u;
			st=u+1;
			i_l++;
			i_r++;
		}
		else if(u<v)
		{
			ans[u]=ans[R];
			Solve(last,u,st,u-1);
			last=u;
			st=u+1;
			i_l++;
		}
		else
		{
			ans[v]=ans[L];
			Solve(last,v,st,v-1);
			last=v;
			st=v+1;
			i_r++;
		}
	}
	if(L==last)
	{
		while(l<=r && deg[l]==0) ans[l]=1,l++;//,printf("%i\n",l-1);
		if(l>r) return;
        int z=E[l][0];
        assert(z>l && z<=r);
        ans[l]=1;ans[z]=2;
        Solve(l,z,l+1,z-1);
        Solve(z,l,z+1,r);
	}
	else Solve(last,R,st,r);*/
}
bool was[N],ok=1;
void DFS(int u)
{
	was[u]=1;
	for(int v:E[u])
	{
		if(!was[v])
		{
			ans[v]=3-ans[u];
			DFS(v);
		}
		else if(ans[u]==ans[v]) ok=0;
	}
}
bool Check2()
{
	for(int i=1;i<=n;i++) if(!was[i])
	{
		ans[i]=1;
		DFS(i);
	}
	if(!ok) for(int i=1;i<=n;i++) ans[i]=0;
	return ok;
}
void Solve()
{
    for(int i=1;i<=m;i++)
	{
		E[U[i]].pb(V[i]);
		E[V[i]].pb(U[i]);
		has[U[i]][V[i]]=has[V[i]][U[i]]=1;
	}
	if(Check2()) return;
	for(int i=1;i<=n;i++) sort(E[i].begin(),E[i].end());
	int L=1,R=E[1][0];
	ans[L]=1;ans[R]=2;
	Solve(L,R,2,R-1);
	Solve(R,L,R+1,n);
}
void rot_ans()
{
	for(int i=1;i<=n;i++)
	{
		int j=i+dst-1;
		if(j>n) j-=n;
		tmp[j]=ans[i];
	}
	for(int i=1;i<=n;i++) ans[i]=tmp[i];
}
int main()
{
    scanf("%i %i",&n,&m);
    for(int i=1;i<=m;i++) scanf("%i %i",&U[i],&V[i]),deg[U[i]]++,deg[V[i]]++;
	for(int i=1;i<=n;i++) if(deg[i]>0){ dst=i;break;}
	if(dst==0)
	{
		printf("1\n");
		for(int i=1;i<=n;i++) printf("1 ");
		printf("\n");
		return 0;
	}
	rot_e();
	Solve();
	rot_ans();

	/*for(int i=1;i<=m;i++)
	{
		E[U[i]].pb(V[i]);
		E[V[i]].pb(U[i]);
	}
	for(int i=1;i<=n;i++)
	{
		bool val[4]={0};
		for(int j:E[i]) if(j<i) val[ans[j]]=1;
		for(int j=1;j<4;j++) if(!val[j]){ ans[i]=j;break;}
		assert(ans[i]!=0);
	}*/

	int mx=0;
	for(int i=1;i<=n;i++) mx=max(mx,ans[i]);
	printf("%i\n",mx);
	for(int i=1;i<=n;i++) printf("%i ",ans[i]);
    printf("\n");
    return 0;
}
