#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) (x.begin(), x.end())

typedef long long ll;
typedef short inth;

const int N = 5e5;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 17;

int tim, tin[M], tout[M];
int q[M * 4], cnt[M];
vector<int> g[M];
int pr[M];

void dfs(int v) {
    tin[v] = ++tim;
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        dfs(to);
    }
    tout[v] = tim;
}

void upd(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        q[v] = val;
        return;
    }
    int tm = (tl + tr)>>1;
    if (pos <= tm)
        upd(v<<1, tl, tm, pos, val);
    else
        upd(v<<1|1, tm + 1, tr, pos, val);
    q[v] = q[v<<1] + q[v<<1|1];
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || l > tr)
        return 0;
    if (l <= tl && tr <= r) {
        return q[v];
    }
    int tm = (tl + tr)>>1;
    int f = get(v<<1, tl, tm, l, r);
    int s = get(v<<1|1, tm + 1, tr, l, r);
    return f + s;
}

void rec(int v, int last) {
    if (!v)
        return;
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        if (to != last && to != pr[v]) {
            cnt[to] |= cnt[v];
            upd(1, 1, tim, tin[to], cnt[to]);
        }
    }
    cnt[v] = 0;
    upd(1, 1, tim, tin[v], 0);
    rec(pr[v], v);
}

int main() {
/*
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
*/
    int n;
    scanf("%d", &n);
    for (int i = 2, x; i <= n; ++i) {
        scanf("%d", &x);
        g[x].pb(i);
        pr[i] = x;
    }
    dfs(1);
    int m;
    scanf("%d", &m);
    for (int i = 1; i <= m; ++i) {
        int t, v;
        scanf("%d %d", &t, &v);
        if (t == 1) {
            upd(1, 1, n, tin[v], 1);
            cnt[v] = 1;
        } else if (t == 2) {
            rec(v, v);
        } else if (t == 3) {
            upd(1, 1, n, tin[v], 0);
            cnt[v] = 0;
            for (int i = 0; i < sz(g[v]); ++i) {
                int to = g[v][i];
                upd(1, 1, n, tin[to], 0);
                cnt[to] = 0;
            }
        } else {
            int ans = get(1, 1, n, tin[v], tout[v]);
            printf("%d\n", ans);
        }
    }
    return 0;
}
