#include "Sgame.h"
#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) (x.begin(), x.end())
#define pii pair<int, int>

typedef long long ll;
typedef short inth;

const int N = 1e2;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 17;
const int PR = 337;

int n;
unordered_map<ll, int> p, l;
int ans[M];
ll st[M];
string s;
set<pii> q[M];
bool pos[M][M];

void get(int m) {
    ll hash = 0;
    vector<int> t;
    for (int i = 1; i <= m; ++i) {
        hash += st[m - i] * (s[i] - 'a' + 1);
    }
    ans[m] = 1;
    p[hash] = 1;
    l[hash] = 1;
    vector<ll> ord;
    ord.pb(hash);
    for (int i = 2; i + m - 1 <= n; ++i) {
        hash -= st[m - 1] * (s[i - 1] - 'a' + 1);
        hash *= PR;
        hash += s[i + m - 1] - 'a' + 1;
        if (!p[hash]) {
            l[hash] = i;
            ord.pb(hash);
        }
        ans[m] = max(ans[m], ++p[hash]);
    }
    for (int i = 0; i < sz(ord); ++i) {
        ll cur = ord[i];
        int cnt = p[cur];
        pii d = mp(l[cur], 0);
        d.s = d.f + m - 1;
        auto k = q[cnt].upper_bound({d.f, n});
        if (!q[cnt].empty() && k != q[cnt].begin()) {
            --k;
            if (k->f <= d.f && k->s >= d.s)
                continue;
        }
        q[cnt].insert(d);
        pos[cnt][m] = 1;
    }
}

void start(char w[]) {
    s = "#";
    while (w[n]) {
        s += w[n++];
    }
    if (n > 1e2)
        return;
    st[0] = 1;
    for (int i = 1; i <= n; ++i)
        st[i] = st[i - 1] * PR;
    for (int i = n; i >= 1; --i) {
        get(i);
    }
}

int round(int m, int k) {
    if (n > 1e2)
        return 1 / 0;
    for (int mx = ans[m]; mx >= 1; --mx) {
        for (int i = m; i <= k; ++i) {
            if (pos[mx][i])
                return mx;
        }
    }
    return 0;
}
