/*DavitMarg*/
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <random>
#define LL long long
#define mod 1000000007ll
#define all(v) v.begin(),v.end()
#define MP make_pair
#define PB push_back
using namespace std;

//#define death


#ifndef death
    #include "Sgame.h"
#endif // death

const int N=500005;

LL p=567,pw[N];
LL h[N];
int ans[N];
map<LL,int> cnt;
int n;
string s;

LL getHash(int l,int r)
{
    LL H=h[r]-h[l-1];
    H*=pw[n-l];
    return H;
}

void start(char A[])
{
    n=strlen(A);
    s+="#";
    for(int i=0;i<n;i++)
        s+=A[i];
    pw[0]=1;
    for(int i=1;i<=n;i++)
        pw[i]=pw[i-1]*p;
    for(int i=1;i<=n;i++)
        h[i]=h[i-1]+pw[i]*(s[i]-'a'+1);
    for(int l=1;l<=n;l++)
        for(int r=l;r<=n;r++)
        {
            LL H=getHash(l,r);
            cnt[H]++;
            //cout<<l<<" : "<<r<<" = "<<H<<endl;
            ans[r-l+1]=max(ans[r-l+1],cnt[H]);
        }
}

int round(int L,int R)
{
    bool fnd=0;
    map<LL,bool> u;
    for(int l=1;l<=n;l++)
    {
        int r=l+R-1;
        if(r>n)
            break;
        LL H=getHash(l,r);
        if(cnt[H]!=ans[R])
            continue;
        if(r!=n && cnt[getHash(l,r+1)]==cnt[H])
            u[H]=1;
        if(l!=1 && cnt[getHash(l-1,r)]==cnt[H])
            u[H]=1;
    }
    for(int l=1;l<=n;l++)
    {
        int r=l+R-1;
        if(r>n)
            break;
        LL H=getHash(l,r);
        if(cnt[H]!=ans[R])
            continue;
        if(u.find(H)==u.end())
        {
            fnd=1;
            //cout<<l<<":"<<r<<endl;
        }
    }
    if(R!=n && fnd==0)
    {
        int res=0;
        for(int k=L;k<=R;k++)
            for(int i=1;i<=n;i++)
            {
                int l=i,r=i+k-1;
                if(r>n)
                    break;
                LL H=h[r]-h[l-1];
                H*=pw[n-l];
                //cout<<l<<" : "<<r<<" = "<<H<<endl;
                int x=cnt[H];
                if(ans[R+1]!=x)
                    res=max(x,res);
            }
        return res;
    }
    return ans[L];
}

#ifdef death

int main()
{
    char S[102];
    cin>>S;
    start(S);
    int Q;
    cin>>Q;
    while(Q--)
    {
        int L,R;
        cin>>L>>R;
        cout<<round(L,R)<<endl;
    }
    return 0;
}

#endif // death

/*


abcabcabcdedea 10

*/
