#include<iostream>
#include<vector>
#include<set>
using namespace std;

const int maxn = 500100;
int par[maxn];
bool inf[maxn];
vector<int> ch[maxn];
int from[maxn];
int to[maxn];

int n;

int _fromcnt;
void dfs(int i)
{
    from[i] = _fromcnt ++;
    for(int j = 0; j < ch[i].size(); j ++)
    {
        dfs(ch[i][j]);
    }
    to[i] = _fromcnt;
    return;
}


int sum[3 * maxn];
set<int> upd[maxn];

int get(int i, int f, int t, int qf, int qt)
{
    if(f == t)  return 0;
    if(t <= qf) return 0;
    if(qt <= f) return 0;
    if(qf <= f && t <= qt)  return sum[i];
    //cout << f << " " << t << " " << qf << " " << qt<< endl;
    int m = (f + t) / 2;
    return get(2 * i + 1, f, m, qf, qt) + get(2 * i + 2, m, t, qf, qt);
}
void _set(int i, int f, int t, int q, int val)
{
    if(f + 1 == t)
    {
        sum[i] = val;
        return;
    }
    int m = (f + t) / 2;
    if(q < m)   _set(2 * i + 1, f, m, q, val);
    else    _set(2 * i + 2, m, t, q, val);
    sum[i] = sum[2 * i + 1] + sum[2 * i + 2];
}

void type1(int i)
{
    _set(0, 0, n, from[i], 1);
    if(par[i] != -1)upd[par[i]].insert(i);
}
void type4(int i)
{
    cout << get(0, 0, n, from[i], to[i]) << "\n";
}
void type3(int i)
{
    for(set<int>::iterator j = upd[i].begin(); j != upd[i].end(); j ++)
    {
        _set(0, 0, n, from[*j], 0);
    }
    upd[i].clear();
    _set(0, 0, n, from[i], 0);
}

void print()
{
    for(int i = 0; i < 2 * n; i ++)
    {
        cout << sum[i] << " ";
    }
    cout << endl;
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    par[0] = -1;
    for(int i = 1; i < n; i ++)
    {
        cin >> par[i];
        par[i] --;
        ch[par[i]].push_back(i);
    }
    dfs(0);
    for(int i = 0; i < n;  i++)
    {
        //cout << from[i] + 1 << " - " << to[i] + 1 << endl;
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++)
    {
        int t, ind;
        cin >> t >> ind;
        ind--;
        if(t == 1)  type1(ind);
        //if(t == 2)  type2(ind);
        if(t == 3)  type3(ind);
        if(t == 4)  type4(ind);
        //print();
    }

}
/**
7
1 1 3 3 4 4
6
1 5
1 6
4 2
4 1
1 3
4 3
*/
/**
5
1 1 2 2
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

*/
