#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

int n;
vector<int> adj[nmax];

int parent[nmax];

int in[nmax],out[nmax];

int where[nmax];

int t=0;
void dfs(int node)
{
    t++;
    where[node]=t;
    in[node]=t;

    for(auto k:adj[node])
        dfs(k);

    out[node]=t;
}

int tree[nmax*4];
void update(int node,int l,int r,int pos,int to)
{
    if(l==r)
    {
        //cout<<"node "<<node<<endl;
        tree[node]=to;
        return;
    }

    int av=(l+r)/2;
    if(pos<=av)update(node*2,l,av,pos,to);
    else update(node*2+1,av+1,r,pos,to);

    tree[node]=tree[node*2]+tree[node*2+1];
}

int query(int node,int l,int r,int lq,int rq)
{
    //cout<<"query "<<node<<" "<<l<<" "<<r<<" "<<lq<<" "<<rq<<endl;

    if(l==lq&&r==rq)return tree[node];

    int av=(l+r)/2,ret=0;

    if(lq<=av)ret=ret+query(node*2,l,av,lq,min(av,rq));
    if(av<rq)ret=ret+query(node*2+1,av+1,r,max(av+1,lq),rq);

    return ret;
}
int main()
{
    scanf("%i",&n);
    for(int i=2;i<=n;i++)
    {
        scanf("%i",&parent[i]);
        adj[parent[i]].push_back(i);
    }

    dfs(1);

    int q;
    scanf("%i",&q);

    int type,node;
    for(int i=1;i<=q;i++)
    {
        scanf("%i%i",&type,&node);
        if(type==1)
        {
            update(1,1,n,node,1);
        }
        if(type==4)
        {
            printf("%i\n",query(1,1,n,in[node],out[node]));
        }
        /*
        if(type==3)
        {
            update_all(1,1,n,in[node],out[node]);
        }
        */
    }
    return 0;
}
/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

4
1 1 1
4
1 1
1 2
4 1
4 3
*/
