#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int n,m;
vector<int> adj[nmax];

vector<int> current;

bool been[nmax];

void dfs(int node)
{
    if(been[node])return;
    been[node]=1;
    current.push_back(node);

    for(auto k:adj[node])
        dfs(k);
}

int test[nmax],colour[nmax];

bool bipar;

void test_dfs(int node,int c)
{
    if(colour[node]&&colour[node]!=c)bipar=0;

    if(bipar==0)return;

    if(colour[node])return;

    colour[node]=c;

    for(auto k:adj[node])
        test_dfs(k,3-c);
}

bool can(int node,int c)
{
    for(auto k:adj[node])
        if(colour[k]==c)return 0;
    return 1;
}
priority_queue< pair<int/*min degree*/,int/*node*/> > pq,idle;

vector<int> order_to_make;

bool taken[nmax];

int deg[nmax];

void go(int node)
{
    current={};
    dfs(node);

    sort(current.begin(),current.end());

    bipar=1;

    test_dfs(node,1);

    if(bipar)return;

    order_to_make={};

    for(auto k:current)
        {
            deg[k]=adj[k].size();
            colour[k]=0;
        }
    pq=idle;
    for(auto k:current)
        pq.push({-adj[k].size(),k});

    while(pq.size())
    {
        pair<int/*min degree*/,int/*node*/> now=pq.top();
        pq.pop();

        //cout<<now.first<<" "<<now.second<<endl;

        int node=now.second;

        if(taken[node])continue;

        taken[node]=1;

        assert(now.first>=-2);

        order_to_make.push_back(node);

        for(auto k:adj[node])
        {
            deg[k]--;
            pq.push({-deg[k],k});
        }
    }

    reverse(order_to_make.begin(),order_to_make.end());

    //for(auto k:order_to_make)cout<<k<<" ";cout<<endl;

    for(auto k:order_to_make)
    {
        //for(int p=1;p<=n;p++)cout<<colour[p]<<" ";cout<<endl;

            for(int j=1;j<=3;j++)
            if(can(k,j))
            {
                colour[k]=j;
                //break;
            }
    }
}
int main()
{
    scanf("%i%i",&n,&m);

    int u,v;
    for(int i=1;i<=m;i++)
    {
        scanf("%i%i",&u,&v);
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=n;i++)
        sort(adj[i].begin(),adj[i].end());

    for(int i=1;i<=n;i++)
    {
        if(been[i]==0)
        {
            go(i);
        }
    }


    int mx=0;
    for(int i=1;i<=n;i++)
        mx=max(mx,colour[i]);

    assert(mx<=3);

    for(int i=1;i<=n;i++)
        for(auto k:adj[i])
        assert(colour[i]!=colour[k]);

    printf("%i\n",mx);
    for(int i=1;i<=n;i++)printf("%i ",colour[i]);
    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

4 5
1 2
2 3
3 4
4 1
2 4
*/
