#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 7;

int n, m, c[MAXN], c_ans[MAXN];
vector<int> adj[MAXN];
bool used[MAXN];

void color(int u){
	used[u] = true;
	map<int, bool> mp;
    for(int to: adj[u]){
		if(used[to]){
			mp[c[to]] = true;
		}
    }

    int pr = 0;
    for(auto it: mp){
        if(it.first > pr + 1){
            c[u] = pr + 1;
            break;
        }
        pr = it.first;
    }
    if(!c[u]){
		c[u] = pr + 1;
    }

    for(int to: adj[u]){
		if(!used[to]){
			color(to);
		}
    }
}

vector<int> curr;

void dfs(int u){
	used[u] = true;
	curr.push_back(u);

	for(int to: adj[u]){
		if(!used[to]){
			dfs(to);
		}
	}
}

void solve(){
	for(int i = 1; i <= n; ++i){
        if(!used[i]){
			curr.clear();
			dfs(i);
			int best = (int)curr.size() + 1;
			for(int x: curr){
                for(int y: curr){
					used[y] = false;
					c[y] = 0;
             }
                color(x);
				int mx = 0;
				for(int y: curr){
                    mx = max(mx, c[y]);
				}

				if(mx < best){
					best = mx;
					for(int y: curr){
						c_ans[y] = c[y];
					}
				}
			}
			for(int x: curr){
				used[x] = true;
			}
        }
	}
}

void write(){
	int mx = 0;
	for(int i = 1; i <= n; ++i){
		mx = max(mx, c_ans[i]);
	}

	cout << mx << "\n";
	for(int i = 1; i <= n; ++i){
		cout << c_ans[i] << " ";
	}
	cout << "\n";
}

void read(){
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> m;
	for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
	}
}

int main(){
	read();
	solve();
	write();
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
