#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 3e5 + 5;

int n, Q, par[N];
vector <int> nb[N];

int from[N], to[N], timer;
bool in_subtree(int u, int v)
{
    return (from[u] <= from[v] && to[u] >= from[v]);
}
void DFS(int v)
{
    from[v] = to[v] = ++timer;
    for(int u: nb[v])
    {
        DFS(u);
        to[v] = max(to[v], to[u]);
    }
}

int fen[N];
void upd(int idx, int x)
{
    for(; idx <= n; idx += (idx & (-idx)))
        fen[idx] += x;
}

int query(int idx)
{
    int res = 0;
    for(; idx > 0; idx -= (idx & (-idx)))
        res += fen[idx];
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int type, v;

    cin >> n;
    for(int i = 2; i <= n; i++)
    {
        cin >> par[i];
        nb[par[i]].pb(i);
    }

    DFS(1);

    cin >> Q;
    while(Q--)
    {
        cin >> type >> v;
        if(type == 1)
        {
            if(query(from[v]) - query(from[v] - 1) == 0)
                upd(from[v], 1);
        }
        if(type == 2)
        {
            int x = 1;
            while(1)
            {
                int go;
                int on = query(from[x]) - query(from[x] - 1);
                if(on)
                    upd(from[x], -1);
                for(int u: nb[x])
                    if(in_subtree(u, v))
                        go = u;
                    else
                    {
                        if(on && (query(from[u]) - query(from[u] - 1) == 0))
                            upd(from[u], 1);
                    }
                if(x == v)
                    break;

                x = go;
            }

        }
        if(type == 3)
        {
            if(query(from[v]) - query(from[v] - 1))
                upd(from[v], -1);
            for(int u: nb[v])
                if(query(from[u]) - query(from[u] - 1))
                    upd(from[u], -1);
        }
        if(type == 4)
        {
            cout << query(to[v]) - query(from[v] - 1) << endl;
        }
    }

    return 0;
}

/*

9
1 1 2 3 3 4 5 1
5
1 9
1 1
1 1
1 7
4 1

5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

*/
