#include <iostream>
#include <vector>
//#define endl '\n'
using namespace std;

const int MAXN = 300005;

int n, q;
vector<int> g[MAXN];

int p[MAXN], c[MAXN];
int cl[MAXN], in[MAXN];

int cnt[MAXN];

void Init()
{
    /*ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);*/

    cin >> n;
    p[1] = 0;
    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
}

void DFS(int u = 1)
{
    cnt[u] = 1;
    for (int v : g[u])
    {
        DFS(v);
        cnt[u] += cnt[v];
    }
}

bool is_infested(int x)
{
    return in[x] != 0;
    // return in[x] > cl[x] and in[x] > cl[p[x]];
}

void make_infested(int x, int i)
{
    int xcpy = x;
    if (!is_infested(x))
    {
        while (x != 0)
        {
            c[x]++;
            x = p[x];
        }
    }
    in[xcpy] = i;
}

void make_clear(int x)
{
    in[x] = 0;
    while (x != 0)
    {
        c[x]--;
        x = p[x];
    }
}

int main()
{
    Init();
    // DFS();

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int t, x;
        cin >> t >> x;
        if (t == 1)
        {
            make_infested(x, i);
        }
        if (t == 2)
        {
            int pr = 0;
            while (x != 0)
            {
                if (is_infested(x))
                {
                    for (int v : g[x])
                    {
                        if (v != pr) make_infested(v, i);
                    }
                    make_clear(x);
                }
                pr = x;
                x = p[x];
            }
        }
        if (t == 3)
        {
            int rm = 0, xcpy = x;
            for (int v : g[x])
            {
                if (is_infested(v))
                {
                    make_clear(v);
                    rm++;
                }
            }
            if (is_infested(x))
            {
                make_clear(x);
                rm++;
            }
            x = p[x];
            while (x != 0)
            {
                c[x] -= rm;
                x = p[x];
            }
            // cl[xcpy] = i;
        }
        if (t == 4)
        {
            cout << c[x] << endl;
        }

       /* cout << "check: \n";
        for (int j = 1; j <= n; ++ j)
        {
            cout << j << ' ' << is_infested(j) << ' ' << c[j] << endl; ;
        }
        cout << endl;//*/
    }
}
