#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;
const long long mod = 23799971;
const long long base = 31;
const int maxn = 10000;

string s;
long long pr[maxn];
long long base_pow[maxn];
int n;

int get(int l, int r)
{
    return (pr[r] - pr[l-1] * base_pow[r - l + 1] % mod + mod) % mod;
}

int how_many(string p)
{
    long long curr_hsh = 0;
    for (auto i: p)
        curr_hsh = (curr_hsh * base + i - 'a' + 1) % mod;

    int sz = p.size();
    int ans = 0;
    for (int i = 1; i <= n - sz + 1; i++)
        if (get(i, i + sz - 1) == curr_hsh)
            ans++;

        return ans;
}

int maxs[maxn];
void start(char w[])
{
    for (int i = 0; w[i] != '\0'; i++)
        s.push_back(w[i]);

    n = s.size();

    base_pow[0] = 1;

    for (int i = 1; i <= n; i++)
        base_pow[i] = base_pow[i-1] * base % mod;

    for (int i = 1; i <= n; i++)
        pr[i] = (pr[i-1] * base + s[i-1] - 'a' + 1) % mod;

    for (int i = 1; i <= n; i++)
    {
        string curr_s;
        for (int j = i; j <= n; j++)
        {
            curr_s.push_back(s[j-1]);

            int curr_cnt = how_many(curr_s);
            bool can = true;
            for (char k = 'a'; k <= 'z'; k++)
                if (how_many(k + curr_s) >= curr_cnt || how_many(curr_s + k) >= curr_cnt)
            {
                can = false;
                break;
            }

            if (can)
                maxs[j-i+1] = max(maxs[j-i+1], curr_cnt);
        }
    }
}



int round(int m, int k)
{
    int ans = 0;
    for (int i = m; i <= k; i++)
    ans = max(ans, maxs[i]);

    return ans;
}
