#include <bits/stdc++.h>
#ifndef LOCAL
	#include "Sgame.h"
#endif

#define int32_t int
#define int64_t long long
#define uint64_t unsigned long long

const int32_t BASE = 147;
const int32_t BASE2 = 137;
std::vector< uint64_t > basePowers, h, basePowers2, h2;

int32_t n;
std::string s;
std::vector< int32_t > lcp;

bool are_equal(int32_t i, int32_t j, int32_t len) {
	uint64_t aux1 = h[i + len - 1] - (i == 0 ? 0 : h[i - 1]);
	uint64_t aux2 = h[j + len - 1] - (j == 0 ? 0 : h[j - 1]);

	if(i < j) {
		aux1 *= basePowers[j - i];	
	}
	else {
		aux2 *= basePowers[i - j];
	}

	bool p = aux1 == aux2;
	
	aux1 = h2[i + len - 1] - (i == 0 ? 0 : h2[i - 1]);
	aux2 = h2[j + len - 1] - (j == 0 ? 0 : h2[j - 1]);

	if(i < j) {
		aux1 *= basePowers2[j - i];	
	}
	else {
		aux2 *= basePowers2[i - j];
	}

	bool q = aux1 == aux2;

	return p && q;
}

bool cmp(int32_t i, int32_t j) {
	int32_t low = 1, high = std::min(n - i, n - j);
	
	while(low <= high) {
		int32_t mid = (low + high) / 2;

		if(are_equal(i, j, mid)) {
			low = mid + 1;
		}
		else {
			high = mid - 1;
		}
	}
	
	low--;

	if(i + low >= n) {
		return 1;
	}
	else if(j + low >= n) {
		return 0;
	}
	else {
		return s[i + low] < s[j + low]; 
	}
}

void start(char w[]) {
	s = w;
	std::reverse(s.begin(), s.end());
	
	n = s.size();

	basePowers.resize(n);
	h.resize(n);
	
	basePowers2.resize(n);
	h2.resize(n);

	basePowers[0] = 1;
	h[0] = (s[0] - 'a' + 1);

	basePowers2[0] = 1;
	h2[0] = (s[0] - 'a' + 1);
	for(int32_t i = 1; i < n; i++) {
		basePowers[i] = basePowers[i - 1] * BASE;
		h[i] = (s[i] - 'a' + 1) * basePowers[i] + h[i - 1];
		
		basePowers2[i] = basePowers2[i - 1] * BASE2;
		h2[i] = (s[i] - 'a' + 1) * basePowers2[i] + h2[i - 1];
	}
	
	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = i + 1; j < n; j++) {
			for(int32_t len = 0; len < n; len++) {
				if(i + len >= n || j + len >= n) {
					break;
				}
			}
		}
	}

	std::vector< int32_t > suffArr(n);
	for(int32_t i = 0; i < n; i++) {
		suffArr[i] = i;
	}

	std::sort(suffArr.begin(), suffArr.end(), cmp);
	
	lcp.resize(n - 1);
	for(int32_t i = 0; i < n - 1; i++) {
		int32_t low = 1, high = std::min(n - suffArr[i], n - suffArr[i + 1]);
	
		while(low <= high) {
			int32_t mid = (low + high) / 2;

			if(are_equal(suffArr[i], suffArr[i +  1], mid)) {
				low = mid + 1;
			}
			else {
				high = mid - 1;
			}
		}
			
		lcp[i] = low - 1;
	}
}

int32_t round(int32_t m, int32_t k) {
	int32_t ans = 0;
	for(int32_t i = 0; i < n - 1; i++) {
		int32_t minVal = lcp[i], len = 1;
		for(int32_t j = i; j < n - 1; j++) {
			minVal = std::min(minVal, lcp[j]);
			len++;
			
			if(minVal >= m && minVal <= k) {
				ans = std::max(ans, len);
			}
		}
	}

	return ans;
}

#ifdef LOCAL
	int main() {
		char w[] = "abcabcabcdedea";
		start(w);

		std::cout << round(1, 2) << '\n';
		std::cout << round(2, 3) << '\n';
		std::cout << round(2, 2) << '\n';
	}
#endif
