#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 300000;
int n;

struct tree
{
    bool ill;
    int illnum;
    int par;
    vector<int> kids;
};
tree t[MAXN+10];

int fenwick[MAXN+10]; // emi ne mi trqbva fenwick fk

void update(int c, int st)
{
    while (c!=0)
    {
        t[c].illnum += st;
        c = t[c].par;
    }
    t[0].illnum +=st;
    /*while (c<n)
    {
        fenwick[c] += st;
        c = c + (c&(-c));
    }*/

}

/*int dfssum(int c)
{
    int sm=0;
    if (t[c].ill) sm++;
    for (int i=0; i<t[c].kids.size(); i++)
    {
        sm += dfssum(t[c].kids[i]);
    }
    return sm;
}*/

int sum(int c)
{
    int sm=0;
    return sm;
}

void input()
{
    int a, b;
    int q;
    cin>>n;
    for (int i=1; i<n; i++)
    {
        cin>>a;
        t[i].par = a-1;
        t[a-1].kids.push_back(i);
    }

    /*for (int i=0; i<n; i++)
    {
        cerr<<i<<"  -  "<<t[i].par<<"  -  ";
        for (int j=0; j<t[i].kids.size(); j++)
        {
            cerr<<t[i].kids[j]<<' ';
        }
        cerr<<endl;
    }*/


    int past;

    cin>>q;
    for (int i=0; i<q; i++)
    {
        cin>>a>>b;
        b--;
        if (a==1)
        {
            if (t[b].ill==0)
            {
                update(b, 1);
                t[b].ill = 1;
            }
        }
        else if (a==2)
        {
            past = 0;
            do
            {
                if (t[b].ill==1)
                {
                    update(b, -1);
                    t[b].ill = 0;
                    for (int z=0; z<t[b].kids.size(); z++)
                    {
                        if (t[t[b].kids[z]].ill==0 && t[b].kids[z]!=past)
                        {
                            update(t[b].kids[z], 1);
                            t[t[b].kids[z]].ill = 1;
                        }
                    }
                }
                if (b==0) break;
                past = b;
                b = t[b].par;
            }
            while (true);
        }
        else if (a==3)
        {
            if (t[b].ill==1)
            {
                update(b, -1);
                t[b].ill = 0;
            }
            for (int j=0; j<t[b].kids.size(); j++)
            {
                if (t[t[b].kids[j]].ill==1)
                {
                    update(t[b].kids[j], -1);
                    t[t[b].kids[j]].ill = 0;
                }
            }
        }
        else
        {
            cout<<t[b].illnum<<endl;
        }
        /*for (int p=0; p<n; p++) cerr<<t[p].ill<<' ';
        cerr<<endl;*/
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    return 0;
}

/*
5
1 1 1 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
