#include <bits/stdc++.h>

using namespace std;

int n,q;
int arr[300000];
bool flag=0;
int prval=-1;
struct tree
{
    vector<tree*>children;
    int num;
    int infected;
};
tree *ptrs[300001];
void buildtree(tree *&root,int arr[])
{
    root=new tree();
    ptrs[1]=root;
    root->num=1;
    for(int i=2;i<=n;i++)
    {
        if(arr[i-2]==1)
        {
            tree *tmp=new tree;
            tmp->num=i;
            ptrs[i]=tmp;
            root->children.push_back(tmp);
        }
        else
        {
            tree *tmp=new tree;
            tmp->num=i;
            ptrs[i]=tmp;
            ptrs[arr[i-2]]->children.push_back(tmp);

        }
    }
}
void infect(int i)
{
    if(ptrs[i]->infected==0)prval++;
    ptrs[i]->infected=1;
}
void ultrasound(int a)
{
    flag=1;
    bitset<300001>frompath;
    if(a==1)
    {
        if(ptrs[a]->infected==1)
        {
            ptrs[a]->infected=0;
            frompath[a]=1;
            for(int i=0;i<ptrs[a]->children.size();i++)
            {
                if(!frompath[ptrs[a]->children[i]->num])ptrs[a]->children[i]->infected=1;
            }
        }

    }
    else
    {
        while(a!=1)
        {
            frompath[a]=1;
            if(ptrs[a]->infected==1)
            {
               ptrs[a]->infected=0;
                for(int i=0;i<ptrs[a]->children.size();i++)
                {
                    if(!frompath[ptrs[a]->children[i]->num])ptrs[a]->children[i]->infected=1;
                }

            }
             a=arr[a-2];
        }
        if(ptrs[a]->infected==1)
        {
            ptrs[a]->infected=0;
            frompath[a]=1;
            for(int i=0;i<ptrs[a]->children.size();i++)
            {
                if(!frompath[ptrs[a]->children[i]->num])ptrs[a]->children[i]->infected=1;
            }
        }

    }


}
void prof(int a)
{
    flag=1;
    ptrs[a]->infected=0;
    for(int i=0;i<ptrs[a]->children.size();i++)
    {
        ptrs[a]->children[i]->infected=0;
    }
}
void infectedn(int a)
{
    if(flag==0&&prval!=-1)
    {
        printf("%d\n",prval);
        return;
    }
    int br=0;
    queue<int>ar;
    ar.push(a);
    //cout<<" INFECTED:"<<endl;
    while(!ar.empty())
    {
        int node=ar.front();
        ar.pop();
        if(ptrs[node]->infected==1)
        {
            //cout<<node<<endl;
            br++;
        }
        for(int i=0;i<ptrs[node]->children.size();i++)
        {
            ar.push(ptrs[node]->children[i]->num);
        }
    }
    //cout<<endl;
    prval=br;
    flag=0;
    printf("%d\n",br);
}
int main()
{
    scanf("%d",&n);

    tree* root=NULL;
    for(int i=0;i<n-1;i++)
    {
        scanf("%d",&arr[i]);
    }
    buildtree(root,arr);
    //cout<<"TUKA"<<endl;
    scanf("%d",&q);
    for(int i=0;i<q;i++)
    {
        int t,x;
        scanf("%d %d",&t,&x);
        if(t==1)
        {
            infect(x);
        }
        else if(t==2)
        {
            ultrasound(x);
        }
        else if(t==3)
        {
            prof(x);
        }
        else
        {
            infectedn(x);
        }
    }
}
