#include <iostream>
#include <cstdio>
#include <vector>
#include <bitset>
#include <queue>

using namespace std;

int n,m;
vector<int>gr[500001];
int color[500001];
int mincolor=0;

bitset<500001> used;
void init()
{
    scanf("%d %d",&n,&m);
    int a,b;
    for(int i=0;i<m;i++)
    {
        scanf("%d %d",&a,&b);
        gr[a-1].push_back(b-1);
        gr[b-1].push_back(a-1);
    }
}

void bfs(int start)
{
    queue<int>nodes;
    nodes.push(start);
    while(!nodes.empty())
    {
        int node=nodes.front();
        nodes.pop();
        if(used[node])continue;
        used[node]=1;
        for(int i=0;i<gr[node].size();i++)
        {
            nodes.push(gr[node][i]);
        }
        if(node!=start)
        {
            bitset<500001> cantbe;
            for(int i=0;i<gr[node].size();i++)
            {
                cantbe[color[gr[node][i]]]=1;
            }
            for(int i=1;i<=n;i++)
            {
                if(!cantbe[i])
                {
                    color[node]=i;
                    break;
                }
            }
            cantbe.reset();
        }
    }
}
int main()
{
    init();
    //cout<<"TUKA"<<endl;
    for(int i=0;i<n;i++)
    {
        if(gr[i].size()>mincolor)
        {
            mincolor=gr[i].size();
        }
    }

    for(int i=0;i<n;i++)
    {
        if(!used[i])
        {
            color[i]=1;
            bfs(i);
        }
    }
    for(int i=0;i<n;i++)
    {
        printf("%d ",color[i]);
    }
    printf("\n");
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
