#include <iostream>
#include <cstdio>
#include <vector>
#include <bitset>

using namespace std;

int n,m;
vector<int>gr[500001];
int color[500001];
int mincolor=0;
bitset<500001> used;
void init()
{
    scanf("%d %d",&n,&m);
    int a,b;
    for(int i=0;i<m;i++)
    {
        scanf("%d %d",&a,&b);
        gr[a-1].push_back(b-1);
        gr[b-1].push_back(a-1);
    }
}

void dfs(int node,int prev)
{
    used[node]=1;
    bitset<500000> cantbe;
    for(int i=0;i<gr[node].size();i++)
    {
        cantbe[color[gr[node][i]]]=1;

    }
    for(int i=1;i<=mincolor;i++)
    {
        if(!cantbe[i])
        {
            color[node]=i;
            break;
        }
    }
    for(int i=0;i<gr[node].size();i++)
    {
        if(!used[gr[node][i]])
        {
            dfs(gr[node][i],node);
        }
    }
}
int main()
{
    init();
    for(int i=0;i<n;i++)
    {
        if(gr[i].size()>mincolor)
        {
            mincolor=gr[i].size();
        }
    }
    dfs(0,-1);

    for(int i=0;i<n;i++)
    {
        if(!used[i])dfs(i,-1);
        printf("%d ",color[i]);
    }
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
