#include<iostream>
#include<vector>
using namespace std;

long long n,q;
long long p[300005];
bool infested[300005];
long long br[300005];
vector<int>conn[300005];

void update(long long ind,long long val)
{
    br[ind]+=val;
    if(p[ind]!=0)update(p[ind],val);
    return;
}

void ultrasound(long long ind,long long prev)
{
    //cout<<ind<<endl;
    long long i;
    if(infested[ind]==true)
    {
        for(i=0;i<conn[ind].size();i++)
        {
            if(infested[conn[ind][i]]==false && (conn[ind][i]!=prev || prev==-1))
            {
                infested[conn[ind][i]]=true;
                br[conn[ind][i]]++;
                br[ind]++;
            }
        }
        infested[ind]=false;
    }
    br[ind]=0;
    for(i=0;i<conn[ind].size();i++)br[ind]+=br[conn[ind][i]];
    if(ind!=1)ultrasound(p[ind],ind);
    return;
}

int main()
{
    long long i,j,t,comm,par;
    cin>>n;
    for(i=1;i<n;i++)
    {
        cin>>j;
        p[i+1]=j;
        conn[j].push_back(i+1);
    }
    
    cin>>q;
    for(t=0;t<q;t++)
    {
        cin>>comm>>par;
        if(comm==4)cout<<br[par]<<endl;
        if(comm==2)
        {
            ultrasound(par,-1);
        }
        if(comm==3)
        {
            j=0;
            for(i=0;i<conn[par].size();i++)
            {
                if(infested[conn[par][i]]){br[conn[par][i]]--;j++;}
                infested[conn[par][i]]=false;
            }
            if(infested[par])j++;
            infested[par]=false;
            update(par,0-j);
        }
        if(comm==1)
        {
            if(infested[par]==false)update(par,1);
            infested[par]=true;
        }
        //for(i=1;i<=n;i++)cout<<br[i]<<' ';cout<<endl;
    }
    return 0;
}
/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
