#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 3 + 5;
const int TSIZE = (1 << 20);

int n;
vector <int> graph[MAXN];

void read_input()
{
    scanf("%d", &n);

    int p;
    for(int i = 0; i < n - 1; i++)
    {
        scanf("%d", &p);
        graph[i + 2].push_back(p);
        graph[p].push_back(i + 2);
    }
}

int br = 1;
int tree[MAXN];
int pos[2][MAXN];

void dfs(int v, int p)
{
    pos[0][v] = br++;

    for(auto x : graph[v])
    {
        if(x != p)
        dfs(x, v);
    }

    pos[1][v] = br++;
}

void update(int ind, int val)
{
    for(int i = ind; i < br; i += (i & -i))
    {
        //printf("%d %d\n", i, val);
        tree[i] += val;
    }
}

int query(int ind)
{
    int ans = 0;
    for(int i = ind; i > 0; i -= (i & -i))
    {
        ans += tree[i];
    }
    //printf("%d\n", ans);
    return ans;
}

int query(int l, int r)
{
    return query(r) - query(l - 1);
}

int col[MAXN];

int main()
{
    read_input();
    dfs(1, 1);
    //printf("%d\n", br);
    //update(3, 5);
    //printf("%d\n", query(1, 5));
    int q;
    scanf("%d", &q);

    int t, v;
    for(int i = 0; i < q; i++)
    {
        scanf("%d %d", &t, &v);
        if(t == 1)
        {
            if(col[v] != 1)
            {
                col[v] = 1;
            }
            update(pos[0][v], 1);
        }
        else
        {
            printf("%d\n", query(pos[0][v], pos[1][v]));
        }
    }

    return 0;
}

/*
5
1 1 3 3
*/
