#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 5 + 5;

int n, m;
vector <int> graph[MAXN];

void read_input()
{
    scanf("%d %d", &n, &m);

    int v, w;
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d", &v, &w);

        graph[v].push_back(w);
        graph[w].push_back(v);
    }
}

int col[MAXN];
int par[MAXN];

int ans = 0;
int br = 0;

void dfs(int v, int p)
{
    if(col[v] == 2) return;

    if(col[v] == 1)
    {
        int temp = p;
        vector <int> vr;
        vr.push_back(v);
        while(temp != v)
        {
            vr.push_back(temp);
            temp = par[temp];
        }
        if((vr.size() & 1) == 1)
        {
            ans = 3;
        }
        /*for(auto x : vr)
        {
            printf("%d ", x);
        }
        printf("\n");*/
        return;
    }
    par[v] = p;
    br++;
    col[v] = 1;

    for(auto x : graph[v])
    {
        if(x == p) continue;
        dfs(x, v);
    }

    col[v] = 2;
}

void solve()
{
    bool fl = false;
    for(int i = 1; i <= n; i++)
    {
        if(col[i] != 2)
        {
            br = 0;
            dfs(i, i);
            if(br > 1)
            {
                fl = true;
            }
        }
    }
    if(!fl)
    {
        printf("1\n");
        for(int i = 0; i < n; i++)
        {
            printf("1 ");
        }
        printf("\n");
        return;
    }
    if(ans == 0)
    {
        ans = 2;
    }
    printf("%d\n", ans);
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
6 5
1 2
2 3
1 4
3 4
6 5
*/

/*
6 7
1 2
2 3
1 4
3 4
6 5
6 4
4 5
*/
