#include<iostream>
#include<cstring>
#include<string>
#include<algorithm>
#include "Sgame.h"

using namespace std;

const int MAXN = 3e5 + 5;

int n;

pair <pair <int, int>, int> currLine[MAXN];
int suffixArray[20][MAXN];
int order[MAXN];

int lcp(int x, int y)
{
    int ans = 0;
    for(int i = 19;i>=0;i--)
    {
        if(x+(1<<i)-1>=n || y+(1<<i)-1>=n) continue;
        if(suffixArray[i][x]==suffixArray[i][y])
        {
            ans += (1<<i);

            x += (1<<i);
            y += (1<<i);
        }
    }

    return ans;
}

void start(char w[])
{
    n = strlen(w);

    for(int i = 0;i<n;i++)
    {
        suffixArray[0][i] = w[i] - 'a';
       // cout << suffixArray[0][i] << " ";
    }
    //cout << '\n';

    for(int i = 1;i<20;i++)
    {
        for(int j = 0;j<n;j++)
        {
            currLine[j].second = j;
            currLine[j].first.first = suffixArray[i-1][j];

            if(j+(1<<(i-1))>=n)
            {
                currLine[j].first.second = -1;
            }
            else
            {
                currLine[j].first.second = suffixArray[i-1][j+(1<<(i-1))];
            }
        }

        int index = 0;
        sort(currLine, currLine+n);

        for(int j = 0;j<n;j++)
        {
            if(j!=0 && currLine[j].first!=currLine[j-1].first) index++;
            suffixArray[i][ currLine[j].second ]  = index;
        }
    }

    for(int i = 0;i<n;i++)
    {
        order[ suffixArray[19][i] ] = i;
    }

    //cout << lcp(0, 1) << '\n';
}

int round(int m, int k)
{
    if(k==n)
    {
        int ans = 0;
        for(int i = 0;i<n;i++)
        {
            int l = i, r = n - 1, mid;

            while(l+1<r)
            {
                mid = (l+r)/2;

                if(lcp(order[i], order[mid])>=m) l = mid;
                else r = mid - 1;
            }

            if(lcp(order[i], order[r])>=m) ans = max(ans, r-i+1);
            else ans = max(ans, l-i+1);
        }

        return ans;
    }
}
