#include<iostream>
#include<vector>
using namespace std;
vector<int>susedi[500005];
int father[500005];
bool infested[500005];
void path(int v,int f){
    if(v==0){
        return;
    }
    if(infested[v]){
        infested[v]=0;
        for(int i=0;i<susedi[v].size();i++){
            if(susedi[v][i]==f)continue;
            infested[susedi[v][i]]=1;
        }
        path(father[v],v);
    }else{
        path(father[v],v);
    }
}
void clean(int v){
    infested[v]=0;
    for(int i=0;i<susedi[v].size();i++){
        infested[susedi[v][i]]=0;
    }
}
int count(int v){
    int ans=infested[v];
    for(int i=0;i<susedi[v].size();i++){
        ans+=count(susedi[v][i]);
    }
    return ans;
}
void print(int n){
    for(int i=1;i<=n;i++){
        cout<<infested[i]<<" ";
    }
    cout<<endl;
}
int main(){
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    cin>>n;
    for(int i=2;i<=n;i++){
        int a;
        cin>>a;
        father[i]=a;
        susedi[a].push_back(i);
    }
    int q;
    cin>>q;
    for(int i=0;i<q;i++){
        int a,b;
        cin>>a>>b;
        if(a==1){
            infested[b]=1;
        }
        if(a==2){
            path(b,0);
        }if(a==3){
            clean(b);
        }if(a==4){
            cout<<count(b)<<"\n";
        }
        //print(n);
    }
    std::cout.flush();
    return 0;
}
