#include<iostream>
#include<vector>
#pragma optimeze "Ofast"
using namespace std;
vector<int>susedi[500005];
int father[500005];
bool infested[500005];
int vals[500005];
void increase(int v,int val)
{
    if(v==0)
    {
        return;
    }
    vals[v]+=val;
    increase(father[v],val);
}
void path(int v,int f,int val)
{
    if(v==0)
    {
        return;
    }
    //vals[v]+=val;
    if(infested[v])
    {
        infested[v]=0;
        val--;
        for(int i=0; i<susedi[v].size(); i++)
        {
            if(susedi[v][i]==f)continue;
            val+=!infested[susedi[v][i]];
            vals[susedi[v][i]]+=!infested[susedi[v][i]];
            infested[susedi[v][i]]=1;
        }
        path(father[v],v,val);
    }
    else
    {
        path(father[v],v,val);
    }
    vals[v]+=val;
}
void clean(int v)
{
    int reduction=0;
    reduction=infested[v];
    infested[v]=0;
    for(int i=0; i<susedi[v].size(); i++)
    {
        reduction+=infested[susedi[v][i]];
        vals[susedi[v][i]]-=infested[susedi[v][i]];
        infested[susedi[v][i]]=0;
    }
    increase(v,-reduction);
}
int count(int v)
{
    /*int ans=infested[v];
    for(int i=0;i<susedi[v].size();i++){
        ans+=count(susedi[v][i]);
    }
    return ans;*/
    return vals[v];
}
void print(int n)
{
    for(int i=1; i<=n; i++)
    {
        cout<<infested[i]<<" ";
    }
    cout<<endl;
    for(int i=1; i<=n; i++)
    {
        cout<<vals[i]<<" ";
    }
    cout<<endl;
}
int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    cin>>n;
    for(int i=2; i<=n; i++)
    {
        int a;
        cin>>a;
        father[i]=a;
        susedi[a].push_back(i);
    }
    int q;
    cin>>q;
    for(int i=0; i<q; i++)
    {
        int a,b;
        cin>>a>>b;
        if(a==1)
        {
            if(!infested[b])
            {
                infested[b]=1;
                increase(b,1);
            }
        }
        if(a==2)
        {
            path(b,0,0);
        }
        if(a==3)
        {
            clean(b);
        }
        if(a==4)
        {
            cout<<count(b)<<"\n";
        }
        //print(n);
    }
    std::cout.flush();
    return 0;
}
