#include<bits/stdc++.h>
using namespace std;
#define ll long long
struct node
{
  int parent;
  bool key;
  vector<int> kids;
};
ll n,q;
vector<node> V;
inline void Q1(ll id)
{
  V[id].key=1;
}
int Q4(ll id)
{
  //cout<<id<<endl;
  int res=0;
  for(int i=0;i<V[id].kids.size();i++)
  {
    res+=Q4(V[id].kids[i]);
  }
  res+=V[id].key;
  return res;
}
inline void Q3(ll id)
{
  for(int i=0;i<V[id].kids.size();i++)
  {
    V[V[id].kids[i]].key=0;
  }
  V[id].key=0;
}
inline void Q2(ll id)
{
  stack<ll> st;
  st.push(id);
  int y=V[id].parent;
  while(y>0)
  {
    //cout<<y<<endl;
    st.push(y);
    y=V[y].parent;
  }
  while(!st.empty())
  {
    int curr=st.top();
    st.pop();
    for(auto yy : V[curr].kids)
    {
      V[yy].key=1;
    }
    V[curr].key=0;
  }
}
int main()
{
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int curr;
  cin>>n;
  V.resize(n+1);
  for(int i=0;i<n-1;i++)
  {
    cin>>curr;
    curr--;
    V[curr].kids.push_back(i+1);
    V[i+1].parent=curr;
  }
  cin>>q;
  int u,v;
  while(q--)
  {
    cin>>u>>v;
    v--;
    if(u==1)
    {
      Q1(v);
    }
    else if(u==4)
    {
      cout<<Q4(v)<<endl;
    }
    else if(u==2)
    {
      Q2(v);
    }
    else
    {
      Q3(v);
    }
  }
}
