#include <bits/stdc++.h>
#define MAXN 500003
#define endl '\n'
using namespace std;

int n, m;
vector <int> adj[MAXN];
int used[MAXN];

void input()
{
    cin >> n >> m;
    fill (used, used + n, -1);
    for (int i = 0; i < m; ++i)
    {
        int from, to;
        cin >> from >> to;
        adj[from].push_back(to);
        adj[to].push_back(from);
    }
}

bool dfs(int tmp, int k)
{
    ///cout << tmp << ": " << endl;
    set <int> clrs;
    for (int i = 1; i <= k; ++i)
        clrs.insert(i);
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (used[nb] != -1)
        {
            ///cout << nb << " - " << used[nb] << endl;
            clrs.erase(used[nb]);
        }
    }
    if (clrs.empty())
        return 0;
    used[tmp] = *clrs.end();
    ///cout << "used: " << used[tmp] << endl;
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (used[nb] == -1)
        {
            bool b = dfs(nb, k);
            if (!b)
                return 0;
        }
    }
    return 1;
}

void solve1()
{
    int ans = -1;
    for (int k = 1; k <= n; ++k)
    {
        fill (used, used + n + 1, -1);
        bool f = 1;
        for (int j = 1; j <= n; ++j)
        {
            if (used[j] == -1)
            {
                bool b = dfs(j, k);
                if (b == 0)
                {
                    f = 0;
                    break;
                }
            }
        }
        if (f)
        {
            ans = k;
            break;
        }
    }
    cout << ans << endl;
    cout << used[1];
    for (int i = 2; i <= n; ++i)
        cout << " " << used[i];
    cout << endl;
}

void solve()
{
    int l = 1;
    int r = n;
    int mid;
    int ans = MAXN;
    while (l <= r)
    {
        int mid = (l + r) >> 1;
        fill(used, used + n + 1, -1);
        /**cout << endl << mid << endl;
        cout << "-------------" << endl;*/
        bool f = 1;
        for (int i = 1; i <= n; ++i)
            if (used[i] == -1)
            {
                bool b = dfs(i, mid);
                if (b == 0)
                {
                    f = 0;
                    break;
                }
            }
        if (f)
        {
            ans = min(ans, mid);
            ///cout << "**" << endl;
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }
    cout << ans << endl;
    cout << used[1];
    for (int i = 2; i <= n; ++i)
        cout << " " << used[i];
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve1();

    return 0;
}

/**
6 5
1 2
2 3
1 4
3 4
6 5
----


*/
