#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define NMax 5000

int n, m;

struct edge
{
    int v1, v2;

    edge(){};
    edge(int a,int b)
    {
        v1 = a, v2 = b;
    }
} edges[5000];

void rec(string a)
{
    if(a.size() == n)
    {
        bool ok = 1;

        for(int i = 0; i < m; i++)
            if(a[edges[i].v1 - 1] == a[edges[i].v2 - 1])
            {
                ok = 0;
                break;
            }
        if(ok == 1)
        {
            for(int i = 0; i < n; i++)
                cout<<a[i]<<" ";
            cout<<endl;
            exit(0);
        }
        return ;
    }

    rec(a+"1");
    rec(a+"2");
    rec(a+"3");
}

int main()
{
    scanf("%d%d", &n, &m);

    int from, to;
    for(int i=0; i<m; i++)
    {
        scanf("%d%d", &from, &to);
        edges[i] = edge(from, to);
    }
    rec("");

    return 0;
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
