#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define NMax 5000

int n, m;
vector<int> nb[NMax + 2];

struct edge
{
    int v1, v2;

    edge(){};
    edge(int a,int b)
    {
        v1 = a, v2 = b;
    }
} edges[5000];

void rec(string a)
{
    if(a.size() == n)
    {
        bool ok = 1;

        for(int i = 0; i < m; i++)
            if(a[edges[i].v1 - 1] == a[edges[i].v2 - 1])
            {
                ok = 0;
                break;
            }
        if(ok == 1)
        {
            int minn = 5, maxn = 0;

            for(int i=0; i<a.size(); i++)
            {
                if(a[i] - '0' > maxn) maxn = a[i] - '0';
                if(a[i] - '0' < minn) minn = a[i] - '0';
            }
            cout << maxn - minn + 1 << endl;
            for(int i = 0; i < n; i++)
                cout << a[i] << " ";
            cout << endl;
            exit(0);
        }
        return ;
    }

    for(int i = 0; i < nb[a.size()-1].size(); i++)
        if(nb[a.size()][i] < a.size()-1 && a[nb[a.size()][i]-1] == a[a.size()-1]) return ;
    rec(a+"1");
    rec(a+"2");
    rec(a+"3");
}

int main()
{
    scanf("%d%d", &n, &m);

    int from, to;
    for(int i=0; i<m; i++)
    {
        scanf("%d%d", &from, &to);
        edges[i] = edge(from, to);
        nb[from].push_back(to);
        nb[to].push_back(from);
    }
    rec("");

    return 0;
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
