#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxN=1024;
int n, m;
int color[maxN], maxc = 0;
bool col[maxN];
vector <int> adj[maxN];
struct sot
{
    int siz;
    int ind;
    sot(){}
    sot(int _siz, int _ind)
    {
        siz = _siz;
        ind = _ind;
    }
}star[maxN];
bool cmp (sot a, sot b)
{
    return a.siz<b.siz;
}
void dfs(int ind)
{
    memset(col, 0, sizeof(col));
    if(color[ind])return;
    for(int i=0; i<adj[ind].size(); i++)
    {
        if(col[color[adj[ind][i]]] == false)col[color[adj[ind][i]]] = true;
    }
    for(int i=1; i<=maxc; i++)
    {
        if(col[i]==false)
        {
            color[ind] = i;
            break;
        }
    }
    if(!color[ind])
    {
        ++maxc;
        color[ind]=maxc;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    int a, b;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    for(int i=1; i<=n;i++)
    {
        star[i].ind = i;
        star[i].siz=adj[i].size();
    }
    sort(star+1, star+n+1, cmp);
    for(int i=1; i<=n; i++)
    {
        dfs(star[i].ind);
    }
    cout<<maxc<<"\n";
    cout<<color[1];
    for(int i=2; i<=n; i++)cout<<" "<<color[i];
    cout<<"\n";
    return 0;
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
/*
7 9
1 2
2 3
2 4
2 5
3 5
4 5
4 6
5 6
5 7
*/
