#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxN=300005;
int subtree[maxN], par[maxN], n, q;
bitset<maxN> isInf;
vector<int> children[maxN];
void update (int ind, int add)
{
    if(ind==-1)return;
    subtree[ind]+=add;
    update(par[ind], add);
}
void infest(int ind)
{
    if(isInf[ind])return;
    isInf[ind]=true;
    ++subtree[ind];
    update(par[ind], 1);
}
void clean(int ind)
{
    int sum = 0;
    if(isInf[ind])
    {
        --sum;
        isInf[ind] = false;
    }
    for(int i=0; i<children[ind].size(); i++)
    {
        if(isInf[children[ind][i]])
        {
            isInf[children[ind][i]] = false;
            --sum;
            --subtree[children[ind][i]];
        }
    }
    subtree[ind]+=sum;
    update(par[ind], sum);
}
void print(int ind)
{
    cout<<subtree[ind]<<"\n";
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    par[1]=-1;

    cin>>n;
    int x, type;
    for(int i=2; i<=n; i++)
    {
        cin>>x;
        par[i]=x;
        children[x].push_back(i);
    }
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>type>>x;
        if(type ==1)infest(x);
        else if(type==3)clean(x);
        else if(type==4)print(x);
    }
    return 0;
}
/*
5
1 1 3 3
8
*/
