#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define fr first
#define sc second
#define vec vector
#define pii pair<int,int>

typedef long long ll;
typedef unsigned int uint;
using namespace std;
const uint nmax = 300005;
int n , q;
int p[nmax];
vec <int> ch[nmax];
pii range[nmax];
int sg[4*nmax], lz[4*nmax];
int pos;
void dfs(int nod){
    range[nod].fr = ++pos;
    for(int i : ch[nod]){
        dfs(i);
    }
    range[nod].sc = pos;
}
void update_nod(int nod){
if(lz[nod] == 1){
    lz[nod] = 0;
    sg[nod] = 0;
    lz[2*nod] = 1;
    lz[2*nod+1] = 1;

}
}
void update(int nod , int l , int r , int pos, int val){
    if( l > r || pos > r || pos < l )return ;
    update_nod(nod);
    sg[nod] += val;
    int mid = (l+r)/2;
    if(l == r)return ;
    update(nod*2,l , mid , pos , val);
    update(nod*2 + 1 , mid + 1 , r , pos , val);
}
int query(int nod, int l ,int r , int lt, int rt){
    //cout << nod << '\n';
    if(l > rt || r < lt || lt > rt )return 0;
    update_nod(nod);
    if(lt >= l && rt <= r){
        return sg[nod];
    }
    if(lt == rt )return 0;
    int mid = (lt+rt)/2;
    return query(2*nod , l , r , lt, mid) + query(2*nod + 1 , l, r , mid+1 , rt);
}
void clr(int nod , int l , int r , int lt , int rt){
    if(lt > rt || l > rt || r < lt )return ;
    if(lt >= l && rt <= r){
        lz[nod] = 1;
        sg[nod] = 0;
        update_nod(nod);
        return ;
    }
    if(lt == rt){
        return ;
    }
    int mid = (lt + rt)/2;
    clr(nod*2,l,r,lt,mid);
    clr(2*nod+1,l,r,mid+1,rt);
    sg[nod] = sg[nod*2] + sg[nod*2+1];
}
int main(){
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);
    cin >> n;
    for(int i = 2 ; i <= n ; i++){
        cin >> p[i];
        ch[p[i]].pb(i);
    }
    dfs(1);
    int ty , x;
    cin >> q;
    for(int qu = 1 ;qu <= q ; qu ++){
        cin >> ty >> x;
        if(ty == 1){
            if(query(1,range[x].fr , range[x].fr, 1, n) == 0){
                update(1 , 1 , n ,range[x].fr,1);
            }
        }
        if(ty == 2){
            return 0;
        }
        if(ty == 3){
            clr(1, range[x].fr , range[x].sc , 1, n);
        }
        if(ty == 4){
            cout << query(1,range[x].fr , range[x].sc, 1 , n) << '\n';
        }
    }

}
