#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

const int N = 5e5;

int color[1 + N];
int ncolor[1 + N];
int viz[1 + N];
vector <int> gr[1 + N];

void dfs (int node, int c) {
    viz[node] = 1;
    color[node] = c + 1;
    for (auto vec : gr[node])
        if (viz[vec] == 0) {
            dfs (vec, !c);
        }
}


vector <pair <int, int> > extra;
int n, m;
void two_sat () {
    int sz = extra.size ();
    for (int mask = 0; mask < (1 << sz); mask++) {
        vector <int> trei;
        for (int i = 0; i < sz; i++)
            if (mask & (1 << i))
                trei.pb (extra[i].first);
            else
                trei.pb (extra[i].second);
        for (int i = 1; i <= n; i++)
            ncolor[i] = color[i];
        for (auto x : trei)
            ncolor[x] = 3;
        bool ok = true;
        for (int i = 1; i <= n; i++)
            for (auto vec : gr[i])
                if (ncolor[i] == ncolor[vec])
                    ok = false;
        if (ok) {
            for (int i = 1; i <= n; i++)
                color[i] = ncolor[i];
            return;
        }
    }
}

int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].pb (y);
        gr[y].pb (x);
    }

    for (int i = 1; i <= n; i++)
        if (viz[i] == 0)
            dfs (i, 0);
    for (int i = 1; i <= n; i++)
        for (auto vec : gr[i]) {
            if (color[i] == color[vec]) {
                if (i < vec)
                    extra.pb ({i, vec});
            }
        }
    if (extra.size ()) {
        two_sat ();
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans = max (ans, color[i]);

    cout << ans << "\n";
    for (int i = 1; i <= n; i++) {
        cout << color[i] << " ";
    }
    return 0;
}
