#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

const int N = 5e5;

int color[1 + N];
int ncolor[1 + N];
int viz[1 + N];
vector <int> gr[1 + N];

void dfs (int node, int c) {
    viz[node] = 1;
    color[node] = c + 1;
    for (auto vec : gr[node])
        if (viz[vec] == 0) {
            dfs (vec, !c);
        }
}


vector <pair <int, int> > extra;
int n, m;
void two_sat () {
    int sz = extra.size ();
    for (int mask = 0; mask < (1 << sz); mask++) {
        vector <int> trei;
        for (int i = 0; i < sz; i++)
            if (mask & (1 << i))
                trei.pb (extra[i].first);
            else
                trei.pb (extra[i].second);
        for (int i = 1; i <= n; i++)
            ncolor[i] = color[i];
        for (auto x : trei)
            ncolor[x] = 3;
        bool ok = true;
        for (int i = 1; i <= n; i++)
            for (auto vec : gr[i])
                if (ncolor[i] == ncolor[vec])
                    ok = false;
        if (ok) {
            for (int i = 1; i <= n; i++)
                color[i] = ncolor[i];
            return;
        }
    }
    assert (0);
}

int colors;

void back (int node) {
    if (node == n + 1) {
        cout << colors << "\n";
        for (int i = 1; i <= n; i++)
            cout << color[i] << " ";
        exit (0);
    }
    for (int i = 1; i <= colors; i++) {
        bool ok = true;
        for (auto vec : gr[node])
            if (color[vec] == i && vec < node)
                ok = false;
        if (ok == false)
            continue;
        color[node] = i;
        back (node + 1);
    }
}

int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].pb (y);
        gr[y].pb (x);
    }
    for (colors = 1; colors <= n; colors++) {
        back (1);
    }
    return 0;
}
