#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;
int nr;
const int N = 3e5;
int in[1 + N];
int out[1 + N];
int lin[1 + 2 * N];
int h[1 + N];
vector <int> gr[1 + N];
int par[1 + N];
void dfs (int node, int f) {
    h[node] = h[f] + 1;
    par[node] = f;
    in[node] = ++nr;
    lin[nr] = node;
    for (auto son : gr[node])
        if (f != son)
            dfs (son, node);
    out[node] = ++nr;
    lin[nr] = node;
}
int aib[1 + 2 * N];
int lsb (int x) {
    return x & -x;
}


void update (int pos, int val) {
    while (pos <= nr) {
        aib[pos] += val;
        pos += lsb (pos);
    }
}
int query (int pos) {
    int ans = 0;
    while (pos) {
        ans += aib[pos];
        pos -= lsb (pos);
    }
    return ans;
}



int qry (int l, int r) {
    return query (r) - query (l - 1);
}

void upd (int pos, int val) {
    int x = qry (pos, pos);
    if (x + val < 0 || x + val > 1)
        return;
    update (pos, val);
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        gr[p].pb (i);
    }

    nr = 0;
    dfs (1, 0);
  //  for (int i = 1; i <= nr; i++)
  //      cout << lin[i] << " ";
  //  cout << "\n";
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        int type, x;
        cin >> type >> x;
        if (type == 1) {
            upd (in[x], 1);
        }
        if (type == 2) {
            int lst = -1;
            while (x) {
                if (qry (in[x], in[x])) {
                    upd (in[x], -1);
                    for (auto son : gr[x])
                        if (lst != son)
                            upd (in[son], 1);
                }
                lst = x;
                x = par[x];
            }
        }

        if (type == 3) {
            upd (in[x], -1);
            for (auto son : gr[x])
                upd (in[son], -1);
        }

        if (type == 4) {
            cout << qry (in[x], out[x]) << "\n";
        }
    }
    return 0;
}
/**
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
**/
