#include <bits/stdc++.h>

using namespace std;

const int MAXN = (int) 5e5;

vector <int> g[MAXN + 1];

int main() {
#ifdef HOME
    ifstream cin("A.in");
    ofstream cout("A.out");
#endif // HOME
    int i, n, m;
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n >> m;

    vector <int> deg(n + 1);
    for(i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
        deg[x]++, deg[y]++;
    }

    vector <int> col(n + 1), vis(n + 1);
    priority_queue < pair <int, int> > pq;

    int ans = 0;
    for(i = 1; i <= n; i++) {
        if(vis[i] == 0) {
            vis[i] = 1;
            pq.push({deg[i], i});
            while(pq.size()) {
                auto cur = pq.top();
                set <int> vals;
                pq.pop();
                for(auto it : g[cur.second]) {
                    if(vis[it]) {
                        vals.insert(col[it]);
                    }
                }
                int j = 1;
                while(vals.find(j) != vals.end()) {
                    j++;
                }
                col[cur.second] = j;
                for(auto it : g[cur.second]) {
                    if(vis[it] == 0) {
                        pq.push({deg[it], it});
                        vis[it] = 1;
                    }
                }
            }
        }
    }

    for(i = 1; i <= n; i++) {
        ans = max(ans, col[i]);
    }
    cout << ans << "\n";
    for(i = 1; i <= n; i++) {
        cout << col[i] << " ";
    }

    return 0;
}
