#include <iostream>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int MAX_N = 5e5;
const int MASK = (1 << 20) - 1;

int n;

int lval[20][MAX_N];
long long v[MAX_N];
int sa[MAX_N];
int lcp[MAX_N];

int stk[MAX_N + 1];
int st[MAX_N], dr[MAX_N];

int rmq[20][MAX_N + 1];

void start(char w[]) {
    n = 0;
    while (w[n])
        n++;

    for (int i = 0; i < n; i++)
        lval[0][i] = w[i] - 'a' + 1;
    for (int l = 1; l < 20; l++) {
        for (int i = 0; i < n; i++) {
            v[i] = (((long long)lval[l - 1][i]) << 40);
            if (i + (1 << l - 1) < n)
                v[i] += (((long long)lval[l - 1][i + (1 << l - 1)]) << 20);
            v[i] += i;
        }
        sort(v, v + n);
        int ix = 1;
        for (int i = 0; i < n; i++) {
            ix += (i != 0 && (v[i] >> 20) != (v[i - 1] >> 20));
            lval[l][v[i] & MASK] = ix;
        }
    }
    for (int i = 0; i < n; i++)
        sa[i] = (v[i] & MASK);
    for (int i = 1; i < n; i++) {
        for (int l = 19; l >= 0; l --)
            if (lcp[i] + (1 << l) < n && lval[l][sa[i] + lcp[i]] == lval[l][sa[i - 1] + lcp[i]])
                lcp[i] += (1 << l);
    }

    int vf = -1;
    for (int i = 0; i <= n; i++) {
        while (vf >= 0 && lcp[stk[vf]] > lcp[i]) {
            dr[stk[vf]] = i;
            vf--;
        }
        if (vf >= 0) {
            if (lcp[i] > lcp[stk[vf]])
                st[i] = stk[vf];
            else
                st[i] = st[stk[vf]];
        }
        stk[++vf] = i;
    }
    for (int i = 1; i < n; i++)
        rmq[0][lcp[i]] = max(rmq[0][lcp[i]], dr[i] - st[i]);
    rmq[0][n] = 1;
    for (int l = 1; l < 20; l++)
        for (int i = 1; i + (1 << l) - 1 <= n; i++)
            rmq[l][i] = max(rmq[l - 1][i], rmq[l - 1][i + (1 << l - 1)]);

//    for (int i = 1; i <= n; i++)
//        cout << i << ": " << rmq[0][i] << endl;
}


int round(int m, int k) {
    int l = 0;
    while ((2 << l) < k - m + 1)
        l++;
    return max(rmq[l][m], rmq[l][k - (1 << l) + 1]);
}
