#include <iostream>
#include <vector>
#include <set>
#include <deque>
#include <algorithm>
#define DIM 500010
using namespace std;

//ifstream fin ("date.in");
//ofstream fout ("date.out");
vector <int> L[DIM];
set <int> c;
deque <int> d;
int viz[DIM],cul[DIM];
int n,m,x,y,i,ok;
void dfs (int nod, int maxi){
    if (ok)
        return;
    viz[nod] = 1;
    /// vreau sa gasesc o culoare valida cu care sa il colorez pe nod
    /// ma intereseaza cea mai mic culoare care nu apare
    c.clear();
    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (cul[vecin])
            c.insert(cul[vecin]);
    }

    //sort (c.begin(),c.end());
    if (c.empty()){ /// n am niciun vecin colorat
        cul[nod] = maxi;
    } else {
        for (int i=1;i<=maxi;i++){
            if (c.find(i) == c.end()){
                cul[nod] = i;
                break;
            }
        }
        if (!cul[nod]) /// am depasit deja nr maxim de culori
            ok = 1;
    }

    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (!viz[vecin])
            dfs (vecin,maxi);
    }
}
int get_culoare (int nod, int maxi){
    c.clear();
    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (cul[vecin])
            c.insert(cul[vecin]);
    }
    int sol = 0;
    if (c.empty()){ /// n am niciun vecin colorat
        sol = 1;
    } else {
        for (int i=1;i<=maxi;i++){
            if (c.find(i) == c.end()){
                sol = i;
                break;
            }
        }
        if (!sol) /// am depasit deja nr maxim de culori
            sol = maxi+1;
    }
    return sol;
}
void bfs (int nod, int maxi){
    d.clear();
    d.push_back(nod);
    viz[nod] = 1;
    while (!d.empty()){
        int x = d.front();
        /// vreau sa aflu culoarea lui x
        cul[x] = get_culoare(x,maxi);
        if (cul[x] > maxi){
            ok = 1;
            break;
        }
        d.pop_front();
        for (auto vecin:L[x]){
            if (!viz[vecin]){
                viz[vecin] = 1;
                d.push_back(vecin);
            }
        }
    }
}
int verif (int val){
    int i;
    for (i=1;i<=n;i++)
        viz[i] = cul[i] = 0;
    ok = 0;
    for (i=1;i<=n;i++){
        if (!viz[i]){
            bfs (i,val);
            if (ok)
                return 0;
        }}
    return 1;
}
int main (){
    /// NU UITA DE FISIERE
    cin>>n>>m;
    for (i=1;i<=m;i++){
        cin>>x>>y;
        L[x].push_back(y);
        L[y].push_back(x);
    }
    //for (i=1;i<=n;i++)
      //  sort (L[i].begin(),L[i].end());
    int st = 1, dr = n, sol = 0;
    while (st <= dr){
        int mid = (st+dr)>>1;
        if (verif(mid)){
            sol = mid;
            dr = mid-1;
        } else st = mid+1;
    }
    verif (sol);
    cout<<sol<<"\n";
    for (i=1;i<=n;i++)
        cout<<cul[i]<<" ";




    return 0;
}
