#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define DIM 500010
using namespace std;

//ifstream fin ("date.in");
//ofstream fout ("date.out");
vector <int> L[DIM];
set <int> c;
int viz[DIM],cul[DIM];
int n,m,x,y,i,ok;
void dfs (int nod, int maxi){
    if (ok)
        return;
    viz[nod] = 1;
    /// vreau sa gasesc o culoare valida cu care sa il colorez pe nod
    /// ma intereseaza cea mai mic culoare care nu apare
    c.clear();
    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (cul[vecin])
            c.insert(cul[vecin]);
    }

    //sort (c.begin(),c.end());
    if (c.empty()){ /// n am niciun vecin colorat
        cul[nod] = 1;
    } else {
        for (int i=1;i<=maxi;i++){
            if (c.find(i) == c.end()){
                cul[nod] = i;
                break;
            }
        }
        if (!cul[nod]) /// am depasit deja nr maxim de culori
            ok = 1;
    }

    for (int i=0;i<L[nod].size();i++){
        int vecin = L[nod][i];
        if (!viz[vecin])
            dfs (vecin,maxi);
    }
}
int verif (int val){
    int i;
    for (i=1;i<=n;i++)
        viz[i] = cul[i] = 0;
    ok = 0;
    for (i=1;i<=n;i++){
        if (!viz[i]){
            dfs (i,val);
            if (ok)
                return 0;
        }
    }
    return 1;
}
int main (){
    /// NU UITA DE FISIERE
    cin>>n>>m;
    for (i=1;i<=m;i++){
        cin>>x>>y;
        L[x].push_back(y);
        L[y].push_back(x);
    }
    int ok = 0;
    for (i=1;i<=n;i++){
        if (L[i].size())
            ok = 1;
    }
    if (!ok){
        cout<<"1\n";
        for (i=1;i<=n;i++)
            cout<<"1 ";
        return 0;
    }
    int st = 1, dr = 4, sol = 0;
    while (st <= dr){
        int mid = (st+dr)>>1;
        if (verif(mid)){
            sol = mid;
            dr = mid-1;
        } else st = mid+1;
    }
    verif (sol);
    cout<<sol<<"\n";
    for (i=1;i<=n;i++)
        cout<<cul[i]<<" ";




    return 0;
}

/*#include <iostream>
#include <vector>
#include <set>
#include <deque>
#include <algorithm>
#define DIM 500010
using namespace std;

//ifstream fin ("date.in");
//ofstream fout ("date.out");
vector <int> L[DIM];
set <int> c;
deque <int> d;
int viz[DIM],cul[DIM];
int n,m,x,y,i,ok;

int main (){
    /// NU UITA DE FISIERE
    cin>>n>>m;
    for (i=1;i<=m;i++){
        cin>>x>>y;
        L[x].push_back(y);
        L[y].push_back(x);
    }
    int ok = 0;
    for (i=1;i<=n;i++){
        if (L[i].size())
            ok = 1;
    }
    if (!ok){
        cout<<"1\n";
        for (i=1;i<=n;i++)
            cout<<"1 ";
        return 0;
    }
    /// cicluri de lungime lg
    for (lg=3;lg<=n;lg++){
        for (i=1;i<=n;i++){

        }
    }
    //for (i=1;i<=n;i++)
      //  sort (L[i].begin(),L[i].end());
    int st = 1, dr = n, sol = 0;
    while (st <= dr){
        int mid = (st+dr)>>1;
        if (verif(mid)){
            sol = mid;
            dr = mid-1;
        } else st = mid+1;
    }
    verif (sol);
    cout<<sol<<"\n";
    for (i=1;i<=n;i++)
        cout<<cul[i]<<" ";

    return 0;
}*/
