#include <cstdio>
#include <vector>
#pragma GCC optimize ("Ofast")
#define DIMN 300010
using namespace std;
vector <int> v[300010],todo[DIMN];
int pozit[DIMN],poztt[DIMN];
int tt[300010],infest[300010],sol;
int aint[4*DIMN],eul[DIMN] , elem , start[DIMN] , ed[DIMN];
void update (int nod,int st,int dr ,int poz , int val){
    int mid = (st + dr)/2;
    if (poz == st && st == dr){
        aint[nod] = val;
        return;
    }
    if (poz <= mid)
        update (2*nod , st , mid , poz , val);
    else update (2*nod+1 , mid+1 , dr , poz , val);

    aint[nod] = aint[2*nod] + aint[2*nod+1];

}
int query (int nod,int st , int dr , int l , int r){
    int mid = (st + dr)/2,s=0;

    if (l<=st && dr<=r){
       // printf ("%d %d %d\n",st,dr,aint[nod]);
        return aint[nod];
    }
    if (l<=mid)
        s+=query(2*nod , st , mid , l , r);
    if (mid+1 <= r)
        s+=query (2*nod+1 , mid+1 , dr , l ,r);

    return s;

}
void dfs (int nod){
    int i;
    sol += infest[nod];
    for (i=0;i<v[nod].size();i++)
        dfs(v[nod][i]);

}
void euler (int nod){
    int i,vecin;
    eul[++elem] = nod;
    start[nod] = elem;

    for (i=0;i<v[nod].size();i++){
        vecin = v[nod][i];
        euler(vecin);
    }

    ed[nod] = elem; /// intre astea e subarborele
}
int main()
{
    FILE *fin = stdin;
    FILE *fout = stdout;
    int n, fth , i , vecin , q , tip , nod,prev;
    fscanf (fin,"%d",&n);
    for (i=2;i<=n;i++){
        fscanf (fin,"%d",&fth);
        v[fth].push_back(i);
        tt[i] = fth;
    }
    euler(1);
    fscanf (fin,"%d",&q);
       // printf ("%d %d\n",start[9] , ed[9]);
       // printf ("a");
        for (;q;q--){
            fscanf (fin,"%d%d",&tip,&nod);
            if (tip == 1){
                update (1,1,elem,start[nod],1);
                if (!infest[nod]){
                    infest[nod] = 1;
                    todo[nod].push_back(nod);
                    pozit[nod] = todo[nod].size()-1;
                    todo[tt[nod]].push_back(nod);
                    poztt[nod] = todo[tt[nod]].size()-1;
                }
            }
            else if (tip == 2){
                prev = -1;
                while (nod){
                    if (infest[nod]){
                        for (i=0;i<v[nod].size();i++){
                            vecin = v[nod][i];
                            if (vecin != prev){
                                if (!infest[vecin]){
                                    todo[vecin].push_back(vecin);
                                    pozit[vecin] = todo[vecin].size()-1;
                                    todo[tt[vecin]].push_back(vecin);
                                    poztt[vecin] = todo[tt[vecin]].size()-1;
                                    infest[vecin] = 1;
                                    update (1,1,elem,start[vecin],1);
                                }
                                //printf ("%d ",vecin);
                            }
                        }
                        todo[nod][pozit[nod]] = todo[nod][todo[nod].size() - 1];
                        todo[nod].pop_back();
                        todo[tt[nod]][poztt[nod]] = todo[tt[nod]][todo[tt[nod]].size() - 1];
                        todo[tt[nod]].pop_back();
                        update (1,1,elem,start[nod],0);
                    }

                    infest[nod] = 0;
                    prev = nod;
                    nod = tt[nod];
                }
            }
            else if (tip == 3){
                infest[nod] = 0;
                for (i=0;i<todo[nod].size();i++){
                    vecin = todo[nod][i];
                    update (1,1,elem,start[vecin],0);
                    infest[vecin] = 0;
                }
                todo[nod].clear();
            }
            else if (tip == 4){
                fprintf (fout,"%d\n",query(1,1,elem,start[nod],ed[nod]));
            }
        }
    return 0;
}
