#include <cstdio>
#include <vector>
#include <algorithm>

#pragma GCC optimizer("Ofast");

using namespace std;

vector<int>G[500005];
int ans[500005];
int d[500005];
int st[500005];
int dr[500005];

int k;

struct stare{
  int rep, l, r;
}stk[500005];

int xx[500005];

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= m; ++i) {
    int u, v;
    scanf("%d%d", &u, &v);
    G[u].push_back(v);
    G[v].push_back(u);
    dr[u]++;
    dr[v]++;
  }
  for (int i = 1; i <= n; ++i) {
    sort(G[i].begin(), G[i].end());
    st[i] = 0;
    dr[i]--;
  }

  int top = 1;
  stk[1] = {1, 1, n};
  while (top) {
    stare aux = stk[top--];
    int l = aux.l, r = aux.r, rep = aux.rep;
    if (l > r)
      continue;
    vector<int>v;
    int sz = G[rep].size();
    int x = 1;
    for (int i = 0; i < sz; ++i) {
      xx[ans[G[rep][i]]] = 1;
    }
    while (xx[x])
      x++;
    for (int i = 0; i < sz; ++i)
      xx[ans[G[rep][i]]] = 0;
    ans[rep] = x;
    d[ans[rep]]++;
    if (d[ans[rep]] == 1)
      k++;
    while (st[rep] <= dr[rep] && G[rep][st[rep]] < l)
      st[rep]++;
    while (dr[rep] >= st[rep] && G[rep][dr[rep]] > r)
      dr[rep]--;
    if (st[rep] > dr[rep]) {
      stk[++top] = {rep + 1, rep + 1, r};
      stk[++top] = {l, l, rep - 1};
    } else {
      int w1 = G[rep][dr[rep]];
      int w2 = G[rep][st[rep]];
      if (w1 < rep)
        w1 = rep + 1;
      if (w2 > rep)
        w2 = rep - 1;
      stk[++top] = {w2, l, rep - 1};
      stk[++top] = {w1, rep + 1, r};
    }
  }

  printf("%d\n", k);
  for (int i = 1; i <= n; ++i)
    printf("%d ", ans[i]);

  return 0;
}
