#include <bits/stdc++.h>

using namespace std;

const int MAXN = 300005;

int papa[MAXN];
vector<int>G[MAXN];
int inf[MAXN];

int first[MAXN], last[MAXN];
int aib[MAXN];
int m;

void dfs(int node) {
  ++m;
  first[node] = m;
  for (auto it:G[node])
    dfs(it);
  last[node] = m;
}

void upd(int pos, int val) {
  for (; pos <= m; pos += (pos & -pos))
    aib[pos] += val;
}

int qry(int pos) {
  int ans = 0;
  for (; pos; pos -= (pos & -pos))
    ans += aib[pos];
  return ans;
}

void baga(int node, int from) {
  if (node == 0)
    return ;
  if (inf[node])
    for (auto it:G[node])
      if (it != from && !inf[it]) {
        upd(first[it], 1);
        inf[it] = 1;
      }
  if (inf[node]) {
    inf[node] = 0;
    upd(first[node], -1);
  }
  baga(papa[node], node);
}

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n;
  scanf("%d", &n);
  for (int i = 2; i <= n; ++i) {
    scanf("%d", &papa[i]);
    G[papa[i]].push_back(i);
  }

  dfs(1);

  int q;
  scanf("%d", &q);
  for (int i = 1; i <= q; ++i) {
    int t, x;
    scanf("%d%d", &t, &x);
    if (t == 1) {
      if (!inf[x]) {
        inf[x] = 1;
        upd(first[x], 1);
      }
    } else if (t == 2) {
      baga(x, 0);
    } else if (t == 3){
      if (inf[x]) {
        inf[x] = 0;
        upd(first[x], -1);
      }
      for (auto it:G[x])
        if (inf[it]) {
          inf[it] = 0;
          upd(first[it], -1);
        }
    } else {
      printf("%d\n", qry(last[x]) - qry(first[x] - 1));
    }
  }

  return 0;
}
