#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

vector<int>G[500005];
vector<int>G1[500005];
int ans[500005];
int d[500005];
int st[500005];
int dr[500005];

int k;

void solve(int rep, int l, int r) {
  while (st[rep] <= dr[rep] && G[rep][st[rep]] < l)
    st[rep]++;
  while (dr[rep] >= st[rep] && G[rep][dr[rep]] > r)
    dr[rep]--;
  vector<int>v;
  for (auto it:G1[rep])
    v.push_back(ans[it]);
  sort(v.begin(), v.end());
  int x = 1;
  for (auto it:v)
    if (it == x)
      x++;
    else
      break;
  ans[rep] = x;
  d[ans[rep]]++;
  for (auto it:G[rep])
    if (!ans[it])
      G1[it].push_back(rep);
  if (d[ans[rep]] == 1)
    k++;
  if (st[rep] > dr[rep]) {
    if (l <= rep - 1)
      solve(l, l, rep - 1);
    if (rep + 1 <= r)
      solve(rep + 1, rep + 1, r);
  } else {
    int w1 = G[rep][dr[rep]];
    int w2 = G[rep][st[rep]];
    if (w1 < rep)
      w1 = rep + 1;
    if (w2 > rep)
      w2 = rep - 1;
    if (rep + 1 <= r)
      solve(w1, rep + 1, r);
    if (l <= rep - 1)
      solve(w2, l, rep - 1);
  }
}

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= m; ++i) {
    int u, v;
    scanf("%d%d", &u, &v);
    G[u].push_back(v);
    G[v].push_back(u);
  }
  for (int i = 1; i <= n; ++i) {
    sort(G[i].begin(), G[i].end());
    st[i] = 0;
    dr[i] = G[i].size() - 1;
  }

  solve(1, 1, n);

  printf("%d\n", k);
  for (int i = 1; i <= n; ++i)
    printf("%d ", ans[i]);

  return 0;
}
