#include <bits/stdc++.h>

using namespace std;

const int Nmax = 5e5 + 5;

int n, m;
int used[Nmax];
vector<int> v[Nmax];

bool ok = 1;


void dfs(int node, int col)
{
    if(used[node])
    {
        ok &= (used[node] == col);
        return;
    }
    used[node] = col;

    for(auto it : v[node])
        dfs(it, 3 - col);
}

int main()
{
  //  freopen("input", "r", stdin);
    cin.sync_with_stdio(false); cin.tie(0);

    cin >> n >> m;

    int i;
    for(i=1; i<=m; ++i)
    {
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }

    for(i=1; i<=n; ++i)
        if(!used[i])
            dfs(i, 1);

    if(ok)
    {
        cout << 2 << '\n';
        for(i=1; i<=n; ++i) cout << used[i] << ' '; 
        cout << '\n';
        return 0;
    }


    return 0;
}

