#include <bits/stdc++.h>
using namespace std;

ifstream fi("infestation.in");
ofstream fo("infestation.out");

const int N = 1e5 + 5;

vector<int> g[N];
bool inf[N];
int far[N];

int n, q;

static int query(int nod) {
	int ant = int(inf[nod]);
	for (auto v: g[nod])
		ant+= query(v);
	return ant; }

static void direct_clear(int nod) {
	for (auto v: g[nod])
		inf[v] = false;
	inf[nod] = false; }

static void lightning_update(int nod, int prv = -1) {
	if (inf[nod]) {
		for (auto v: g[nod]) if (v != prv)
			inf[v] = true; }
	inf[nod] = false;
	if (far[nod]) lightning_update(far[nod], nod); }

int main() {
	freopen("infestation.in", "r", stdin);
	freopen("infestation.out", "w", stdout);
	cin >> n;
	for (int i = 2; i <= n; ++i) {
		cin >> far[i];
		g[far[i]].push_back(i); }

	cin >> q;
	while (q--) {
		int op;
		cin >> op;
		switch (op) {
		case 1: {
			int nod;
			cin >> nod;
			inf[nod] = true;
			break; }
		case 2: {
			int nod;
			cin >> nod;
			lightning_update(nod);
			break; }
		case 3: {
			int nod;
			cin >> nod;
			direct_clear(nod);
			break; }
		case 4: {
			int nod;
			cin >> nod;
			cout << query(nod) << '\n';
			break; } } }

	return 0; }

