#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 3e5 + 5;

int N, T[NMAX], Type, X, ans = 0, Q;

vector < int > G[NMAX];
bool Infectat[NMAX];

bool Sel[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    T[1] = 0;

    for(int i = 2; i <= N; ++i)
    {
        cin >> T[i];

        G[T[i]].push_back(i);
    }

    return;
}

static inline void Go1 ()
{
    Infectat[X] = 1;

    return;
}

static inline void Go2 ()
{
    vector < int > V;

    int Node = X;

    while(Node != 1)
    {
        V.push_back(Node);

        Node = T[Node];
    }

    V.push_back(1);

    sort(V.begin(), V.end());

    for(auto it : V)
    {
        if(Infectat[it] == 0)
            continue;

        Infectat[it] = 0;

        for(auto j : G[it])
        {
            if(binary_search(V.begin(), V.end(), j))
                continue;

            Infectat[j] = 1;
        }
    }

    return;
}

static inline void Go3 ()
{
    Infectat[X] = 0;

    for(auto it : G[X])
        Infectat[it] = 0;

    return;
}

static inline void DFS (int Node)
{
    if(Infectat[Node])
        ++ans;

    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    return;
}

static inline void Go4 ()
{
    ans = 0;

    for(int i = 1; i <= N; ++i)
        Sel[i] = 0;

    DFS(X);

    cout << ans << '\n';

    return;
}

static inline void Test_Case ()
{
    cin >> Type >> X;

    if(Type == 1)
        Go1();

    if(Type == 2)
        Go2();

    if(Type == 3)
        Go3();

    if(Type == 4)
        Go4();

    return;
}

int main()
{
    Read();

    cin >> Q;

    while(Q--)
        Test_Case();

    return 0;
}
