#include <bits/stdc++.h>

using namespace std;;

vector <int> t;
vector < vector <int> > g;
vector <int> event;

void dfs(int v, int from = -1) {
    event.push_back(v);
    for (int to : g[v]) {
        if (to == from) continue;
        dfs(to, v);
    }
    event.push_back(v);
}

void update(int l, int r, int v, int k, int val) {
    if (l == r) {
        t[v] = val;
        return ;
    }
    int m = (l + r)/ 2;
    if (m >= k) update(l, m, 2 * v, k, val);
    else update(m + 1, r, 2 * v + 1, k, val);
    t[v] = t[2 * v + 1] + t[2 * v];
}

int sum(int l, int r, int tl, int tr, int v) {
    if (l > r) return 0;
    if (l == tl && r == tr) {
        return t[v];
    }
    int m = (tl + tr)/ 2;
    return sum(l, min(r, m), tl, m, 2 * v) + sum(max(m + 1, l), r, m + 1, tr, 2 * v + 1);
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        g[a - 1].push_back(i);
        g[i].push_back(a - 1);
    }
    dfs(0);
    t.resize((int)event.size() * 4);
    unordered_map <int, pair <int, int> > p;
    p[event[0]].first = 0;
    for (int i = 1; i < (int)event.size(); i++) {
        if (p[event[i]].first == 0) {
            if (event[0] == event[i]) p[event[i]].second = i;
            else p[event[i]].first = i;
        } else {
            p[event[i]].second = i;
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, x;
        cin >> t >> x;
        if (t == 1) {
            update(0, 2 * n - 1, 1, p[x - 1].first, 1);
        }
        if (t == 3) {
            update(0, 2 * n - 1, 1, p[x - 1].first, 0);
            for (int to : g[x - 1]) {
                update(0, 2 * n - 1, 1, p[to].first, 0);
            }
        }
        if (t == 4) {
            cout << sum(p[x - 1].first, p[x - 1].second, 0, 2 * n - 1, 1) << '\n';
        }
    }
}
