#include <bits/stdc++.h>

using namespace std;;

vector <int> t;
vector < vector <int> > g;
vector <int> event;

void dfs(int v, int from = -1) {
    event.push_back(v);
    for (int to : g[v]) {
        if (to == from) continue;
        dfs(to, v);
    }
    event.push_back(v);
}

int _find(int l, int r, int v, int k) {
    if (l == r) {
        return t[v];
    }
    int m = (l + r)/ 2;
    if (m >= k) return _find(l, m, 2 * v, k);
    else return _find(m + 1, r, 2 * v + 1, k);
}

void update(int l, int r, int v, int k, int val) {
    if (l == r) {
        t[v] = val;
        return ;
    }
    int m = (l + r)/ 2;
    if (m >= k) update(l, m, 2 * v, k, val);
    else update(m + 1, r, 2 * v + 1, k, val);
    t[v] = t[2 * v + 1] + t[2 * v];
}

int sum(int l, int r, int tl, int tr, int v) {
    if (l > r) return 0;
    if (l == tl && r == tr) {
        return t[v];
    }
    int m = (tl + tr)/ 2;
    return sum(l, min(r, m), tl, m, 2 * v) + sum(max(m + 1, l), r, m + 1, tr, 2 * v + 1);
}

main() {
    //freopen("inputc.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> pr(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        pr[i] = a - 1;
        g[a - 1].push_back(i);
        g[i].push_back(a - 1);
    }
    dfs(0);
    t.resize(6 * n);
    unordered_map <int, pair <int, int> > p;
    p[event[0]].first = 0;
    for (int i = 1; i < (int)event.size(); i++) {
        if (p[event[i]].first == 0) {
            if (event[0] == event[i]) p[event[i]].second = i;
            else p[event[i]].first = i;
        } else {
            p[event[i]].second = i;
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        //cout << ">" << i << "<" << endl;
        int tp, x;
        cin >> tp >> x;
        if (tp == 1) {
            update(0, 2 * n - 1, 1, p[x - 1].first, 1);
        }
        if (tp == 2) {
            vector <int> path;
            int j = x - 1;
            while (j != 0) {
                path.push_back(j);
                j = pr[j];
            }
            path.push_back(0);
            for (int j = 0; j < (int)path.size(); j++) {
                //cout << j <<endl;
                if (_find(0, 2 * n - 1, 1, p[path[j]].first) == 1) {
                    //cout << j << endl;
                    for (int to : g[path[j]]) {
                        //cout << _find(0, 2 * n - 1, 1, p[to].first) << endl;
                        if (to == path[max(0, j - 1)] || to == path[min((int)path.size() - 1, j + 1)]) continue;
                        //cout << to << endl;
                        update(0, 2 * n - 1, 1, p[to].first, 1);
                    }
                }
                update(0, 2 * n - 1, 1, p[path[j]].first, 0);
            }
        }
        if (tp == 3) {
            update(0, 2 * n - 1, 1, p[x - 1].first, 0);
            for (int to : g[x - 1]) {
                update(0, 2 * n - 1, 1, p[to].first, 0);
            }
        }
        if (tp == 4) {
            cout << sum(p[x - 1].first, p[x - 1].second, 0, 2 * n - 1, 1) << '\n';
        }
        /*for (int j : t) {
            cout << j << ' ';
        }
        cout << endl;
        cout << sum(0, 2 * n - 1, 0, 2 * n - 1, 1) << '\n';*/
    }
}
