#include <bits/stdc++.h>

using namespace std;

int n, m, ans = 1;
vector < vector <int> > g;
vector <int> clr;

void dfs(vector <bool> &used, int v) {
    used[v] = 1;
    set <int> cl;
    for (int to : g[v]) {
        if (used[to]) {
            cl.insert(clr[to]);
        }
    }
    if (cl.empty()){
        ans = 1;
        clr[v] = 1;
    } else {
        int j = 1;
        for (int i : cl) {
            if (i != j) {
                clr[v] = j;
                break;
            }
            if (clr[v] == -1) {
                clr[v] = *(cl.rbegin()) + 1;
            }
            ans = max(ans, clr[v]);
        }
    }
    for (int to : g[v]) {
        if (!used[to]) {
            dfs(used, to);
        }
    }
}

main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    g.resize(n);
    clr.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector <bool> used(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(used, i);
        }
    }
    cout << ans << '\n';
    for (int i : clr)
        cout << i << ' ';
}
