#include <bits/stdc++.h>
using namespace std;
vector<int> graph[500000];
short color[500000];
bool used[500000];
int p[500000];
bool tr = false;
void bfs(int n){
  used[n] = true;
  color[n] = 1;
  queue<int> q;
  queue<int> q2;
  q.push(n);
  while(!q.empty() || !q2.empty()){
    int node;
    if(!q2.empty()){
       node = q2.front();
       q2.pop();
    }
    else{
      node = q.front();
      q.pop();
    }
    if(color[node] == 0){
      if(color[p[node] - 1] != 1){
        color[node] = 1;
      }
      else{
         color[node] = 2;
      }
    }
    for(int to : graph[node]){       
      int pa = p[to] - 1;
      if(used[to] && color[to] == 0){
         if(color[pa] == color[node]){
           continue;
         }
         else{
           tr = true;
         }
         if(color[pa] == 1 && color[node] == 2){
           color[to] = 3;
         }
         if(color[pa] == 1 && color[node] == 3){
           color[to] = 2;
         }
         if(color[pa] == 2 && color[node] == 1){
           color[to] = 3;
         }
         if(color[pa] == 2 && color[node] ==3){
           color[to] = 1;
         }
         if(color[pa] == 3 && color[node] == 1){
           color[to] = 2;
         }
         if(color[pa] == 3 && color[node] == 2){
           color[to] = 1;
         }
         q2.push(to);
      }
      else if(!used[to]){
        p[to] = node + 1;
        q.push(to);
        used[to] = true;
      }
    }
  }
}
int main(){
  ios_base :: sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < 500000; ++i){
    graph[i].resize(1000);
  }
  for(int i = 0; i < m; ++i){
    int a, b;
    cin >> a >> b;
    graph[a - 1].push_back(b - 1);
    graph[b - 1].push_back(a - 1);
  }
  for(int i = 0; i < n; ++i){
    if(!used[i]){
       bfs(i);
    }
  }
  if(tr){
    cout << 3 << endl;
  }
  else{
    cout << 2 << endl;
  }
  for(int i = 0; i < n; ++i){
    cout << color[i] << " ";
  }
  return 0;
}