//#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define endl '\n'
#define double long double

int n, m;
vector<vector<int> > g;
vector<int> clr;
vector<int> st;
bool ok = false;
int cst = 1;
void dfs(int v, int c){
	if(clr[v] != 0){
		if(clr[v] == c) return ;
		else ok = true;
	}
	clr[v] = c;
	for(int to: g[v]){
		dfs(to, 3 - c);
		if(ok) break;
	}
}

void unfill(int v, int nst){
	//clr[v] = 0;
	for(int to: g[v]){
		if(st[to] > nst){
			unfill(to, nst);
			clr[to] = 0;
		}
	}
}

bool paint(int v, int cst = 1){
	st[v] = cst;
	int x = 0,y = 0,z = 0;
	for(int to: g[v]){
		if(st[to] != 0 && st[to] <= cst){
			if(clr[to] == 1) x++;
			else if(clr[to] == 2) y++;
			else if(clr[to] == 3) z++;
		}
	}
	for(int k = 1; k <= 3; k++){
		if(k == 1 && x) continue;
		if(k == 2 && y) continue;
		if(k == 3 && z) continue;
		clr[v] = k;
		bool ok = true;
		for(int to: g[v]){
			if(clr[to] == 0 || st[to] > cst)
				if(!paint(to, cst + 1)){
					ok = false;
					break;
				}
		}
		if(ok) return true;
	}
	return false;
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin >> n >> m;
	g.resize(n);
	clr.resize(n, 0);
	st.resize(n, 0);
	for(int i = 0; i < m; i++){
		int u, v;
		cin >> u >> v;
		u--, v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for(int i = 0; i < n; i++){
		if(clr[i] == 0) dfs(i, 1);
	}
	if(!ok){
		cout << 2 << endl;
		for(int i = 0; i < n; i++){
			cout << clr[i] << ' ';
		}
		cout << endl;
		return 0;
	} else{
		for(int i = 0; i < n; i++) clr[i] = 0;
		for(int i = 0; i < n; i++)
			if(clr[i] == 0)
				if(!paint(i)) assert(0);
		cout << 3 << endl;
		for(int i = 0; i < n; i++) cout << clr[i] << ' ';
		cout << endl;
	}
}