#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<vector<int>> g;
vector<int> col;
set<pair<int, int>> s;

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    col.assign(n, -1);
    for(int i = 0; i < n; i++) {
        s.insert(make_pair(size(g[i]), i));
    }
    vector<int> sz(n);
    for(int i = 0; i < n; i++) {
        sz[i] = size(g[i]);
    }
    queue<int> q;
    q.push(s.rbegin()->second);
    s.erase(--s.end());
    vector<int> us(n, 0);
    us[q.front()] = 1;
    vector<int> p(n);
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        vector<pair<int, int>> temp;
        for(int i = 0; i < size(g[v]) + 1; i++) {
            p[i] = 0;
        }
        for(int i : g[v]) {
            if(col[i] == -1 && us[i] == 0) {
                us[i] = 1;
                s.erase(make_pair(sz[i], i));
                sz[i]--;
                s.insert(make_pair(sz[i], i));
                temp.push_back(make_pair(sz[i], i));
            }
            if(col[i] != -1 && col[i] <= size(g[v])) {
                p[col[i]] = 1;
            }
        }
        sort(rall(temp));
        for(int i = 0; i < size(temp); i++) {
            q.push(temp[i].second);
        }
        for(int i = 0; i < size(g[v]) + 1; i++) {
            if(p[i] == 0) {
                col[v] = i;
                break;
            }
        }
    }
    int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, col[i]);
    }
    cout << mx + 1 << "\n";
    for(int i = 0; i < n; i++) {
        cout << col[i] + 1 << " ";
    }
}

int main() {
    io();
    solve();
    return 0;
}
