#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<set<int>> g;
vector<int> col, p;

void dfs(int v) {
    for(int i = 0; i < size(g[v]) + 1; i++) {
        p[i] = 0;
    }
    for(int i : g[v]) {
        if(col[i] != -1 && col[i] <= size(g[v])) {
            p[col[i]] = 1;
        }
    }
    for(int i = 0; i < size(g[v]) + 1; i++) {
        if(p[i] == 0) {
            col[v] = i;
            break;
        }
    }
    for(int i : g[v]) {
        if(col[i] == -1) {
            dfs(i);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    col.assign(n, -1);
    vector<int> sz(n);
    for(int i = 0; i < n; i++) {
        sz[i] = size(g[i]);
    }
    p.resize(n);
    vector<pair<int, int>> tt;
    for(int i = 0; i < n; i++) {
        tt.push_back(make_pair(sz[i], i));
    }
    sort(rall(tt));
    for(auto it : tt) {
        if(col[it.s] == -1) {
            dfs(it.s);
        }
    }
    int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, col[i]);
    }
    cout << mx + 1 << "\n";
    for(int i = 0; i < n; i++) {
        cout << col[i] + 1 << " ";
    }
}

int main() {
    io();
    solve();
    return 0;
}
