#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<set<int>> g;
vector<int> col;
vector<int> cc;
stack<int> st;

bool okk = true;

void dfs(int v, int c = 0) {
    st.push(v);
    if(okk == false) {
        return;
    }
    col[v] = c;
    for(int i : g[v]) {
        if(col[i] == c) {
            while(st.top() != i) {
                cc.push_back(st.top());
                st.pop();
            }
            cc.push_back(i);
            okk = false;
            return;
        }else if(col[i] == -1) {
            dfs(i, 1 - c);
            if(okk == false) {
                return;
            }
        }
    }
    st.pop();
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    col.assign(n, -1);
    for(int i = 0; i < n; i++) {
        if(col[i] == -1) {
            dfs(i);
        }
    }
    if(okk) {
        int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, col[i]);
    }
    cout << mx + 1 << "\n";
    for(int i = 0; i < n; i++) {
        cout << col[i] + 1 << " ";
    }
    exit(0);
    }
    col.assign(n, -1);
    int l = 0;
    for(int i : cc) {
        col[i] = l;
        l ^= 1;
    }
    if(!cc.empty()) {
        col[cc.back()] = 3;
    }
    vector<int> sz(n);
    set<pair<int, int>> s;
    for(int i = 0; i < n; i++) {
        if(col[i] != -1) {
            continue;
        }
        s.insert(make_pair(0, i));
        sz[i] = 0;
    }
    for(int i = 0; i < n; i++) {
        if(col[i] != -1) {
            for(int j : g[i]) {
                if(col[j] == -1) {
                    s.erase(make_pair(sz[j], j));
                    sz[j]++;
                    s.insert(make_pair(sz[j], j));
                }
            }
        }
    }
    vector<int> p(n);
    while(!s.empty()) {
        int v = s.rbegin()->second;
        s.erase(--s.end());
        for(int i = 0; i < size(g[v]) + 1; i++) {
            p[i] = 0;
        }
        for(int i : g[v]) {
            if(col[i] == -1) {
            s.erase(make_pair(sz[i], i));
            sz[i]--;
            s.insert(make_pair(sz[i], i));
            }
            if(col[i] != -1 && col[i] <= size(g[v])) {
                p[col[i]] = 1;
            }
        }
        for(int i = 0; i < size(g[v]) + 1; i++) {
            if(p[i] == 0) {
                col[v] = i;
                break;
            }
        }
    }
    int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, col[i]);
    }
    cout << mx + 1 << "\n";
    for(int i = 0; i < n; i++) {
        cout << col[i] + 1 << " ";
    }
}

int main() {
    io();
    solve();
    return 0;
}
