#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<vector<int>> g;
vector<int> col;

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    col.assign(n, -1);
    set<pair<int, int>> s;
    for(int i = 0; i < n; i++) {
        s.insert(make_pair(size(g[i]), i));
    }
    vector<int> p(n);
    while(!s.empty()) {
        int v = s.rbegin()->second;
        s.erase(--s.end());
        for(int i = 0; i < size(g[v]); i++) {
            p[i] = 0;
        }
        for(int i : g[v]) {
            if(col[i] != -1 && col[i] < size(g[v])) {
                p[col[i]] = 1;
            }
        }
        bool ok = false;
        for(int i = 0; i < size(g[v]); i++) {
            if(p[i] == 0) {
                col[v] = i;
                ok = true;
                break;
            }
        }
        if(ok == false) {
            col[v] = size(g[v]);
        }
    }
    int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, col[i]);
    }
    cout << mx + 1 << "\n";
    for(int i = 0; i < n; i++) {
        cout << col[i] + 1 << " ";
    }
}

int main() {
    io();
    solve();
    return 0;
}
