#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <bitset>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define normsize(v) int(v.size())
#define pb push_back
using namespace std;
#pragma GCC target("avx")
#pragma GCC optimize("no-stack-protector", "unroll-loops", "fast-math", "O3")
struct segment_tree {
    vector < int > t;
    int siz;
    void build(int siz1) {
        t.resize(4 * siz1);
        siz = siz1;
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        ll ans = 0;
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return ;
        }
        int m = (l + r) / 2;
        if (val <= m) upd(v * 2 + 1, l, m, pos, val);
        else upd(v * 2 + 2, m + 1, r, pos, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};
vector < vector < int > > childs;
vector < int > p;
vector < int > inf;
int ans = 0;
void ask(int v) {
    ans += inf[v];
    fori(childs[v].size()) {
        ask(childs[v][i]);
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    childs.resize(n);
    inf.resize(n);
    p.resize(n);
    p[0] = -1;
    fori(n - 1) {
        int x;
        cin >> x;
        x--;
        p[i + 1] = x;
        childs[x].pb(i + 1);
    }
    int q;
    cin >> q;
    int x, t;
    while (q--) {
        cin >> t;
        if (t == 1) {
            cin >> x;
            x--;
            inf[x] = 1;
        } else if (t == 2) {
            int x;
            cin >> x;
            x--;
            int z = x;
            while (true) {
                if (z == -1) break;
                if (inf[z] == 0) {z = p[z]; continue;}
                fori(childs[z].size()) {
                    inf[childs[z][i]] = 1;
                }
                z = p[z];
            }
            while (true) {
                if (x == -1) break;
                inf[x] = 0;
                x = p[x];
            }
        } else if (t == 3) {
            cin >> x;
            x--;
            inf[x] = 0;
            fori(childs[x].size()) {
                inf[childs[x][i]] = 0;
            }
        } else {
            cin >> x;
            x--;
            ans = 0;
            //fori(n) ans += inf[i];
            ask(x);
            cout << ans << "\n";
        }
    }
}

/**
6 9
1 2
2 3
3 4
4 5
5 6
6 1
6 2
2 5
5 3
**/




