#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string.h>
#include <math.h>
#include <algorithm>
//#include <unordered_set>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define normsize(v) int(v.size())
#define pb push_back
using namespace std;
#pragma GCC target("avx")
#pragma GCC optimize("no-stack-protector", "unroll-loops", "fast-math", "O3")
struct segment_tree {
    vector < int > t;
    int siz;
    void build(int siz1) {
        t.resize(4 * siz1);
        siz = siz1;
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        ll ans = 0;
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return ;
        }
        int m = (l + r) / 2;
        if (val <= m) upd(v * 2 + 1, l, m, pos, val);
        else upd(v * 2 + 2, m + 1, r, pos, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};
vector < int > keks;
int n;
vector < vector < int > > g;
vector < bool > isUsed;
vector < int > col;
void buba(int v) {
    isUsed[v] = true;
    forj(g[v].size()) {
        int to = g[v][j];
        if (isUsed[to]) continue;
        col[to] = 3 - col[v];
        buba(to);
    }
}
//unordered_set < int > all0;
set < int > all0;
//unordered_set < int > all1;
set < int > all1;
//unordered_set < int > all2; /// te, y kogo 2 pocrashennix soseda
set < int > all2; /// te, y kogo 2 pocrashennix soseda
vector < char > knt;
vector < vector < char > > iskek;
void tryhard(int v, int col) {
    if (knt[v] == 0)
        all0.erase(v);
    else if (knt[v] == 1)
        all1.erase(v);
    else if (knt[v] == 2)
        all2.erase(v);

    for (int j = 0; j < g[v].size(); j++) {
        int to = g[v][j];

        iskek[to][col - 1]++;
        if (iskek[to][col - 1] == 1) {
            knt[to]++;
            if (knt[to] == 2 && isUsed[to] == false) {
                all1.erase(to);
                all2.insert(to);
            } else if (knt[to] == 1 && isUsed[to] == false) {
                all0.erase(to);
                all1.insert(to);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    keks.resize(n);
    fori(m) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    col.resize(n);
    isUsed.resize(n);
    fori(n) {
        if (!isUsed[i]) {
            col[i] = 1;
            buba(i);
        }
    }
    bool ok = true;
    fori(n) {
        forj(g[i].size()) {
            int to = g[i][j];
            if (col[i] == col[to]) {
                ok = false;
                break;
            }
        }
        if (!ok) break;
    }
    if (ok) {
        cout << 2 << "\n";
        fori(n) cout << col[i] << " ";
        return 0;
    }
    cout << 3 << "\n";

    fori(n) col[i] = 0;
    iskek.resize(n);
    fori(n) iskek[i].resize(3);
    fori(n) all0.insert(i);
    knt.resize(n);
    fori(n) knt[i] = 0;
    fori(n) isUsed[i] = 0;
    fori(n) {
        if (g[i].size() == 0) continue;
        col[i] = 1;
        tryhard(i, 1);
        isUsed[i] = 1;
        isUsed[g[i][0]] = 1;
        col[g[i][0]] = 2;
        tryhard(g[i][0], 2);
        break;
    }
    for (int ghj = 0; ghj < n - 2; ghj++) {
        int v = -1;
        if (all2.size() != 0) {
            v = *all2.begin();
        } else if (all1.size() != 0) {
            v = *all1.begin();
        } else if (all0.size() != 0) {
            v = *all0.begin();
        }
        if (v == -1) {
            cout << "buba";
            return 0;
        }
        isUsed[v] = true;
        if (iskek[v][2] == 0) {
            col[v] = 3;
            tryhard(v, 3);
        } else if (iskek[v][1] == 0) {
            col[v] = 2;
            tryhard(v, 2);
        } else if (iskek[v][0] == 0) {
            col[v] = 1;
            tryhard(v, 1);
        }
    }
    /*
    for (int ghj = 0; ghj < n - 2; ghj++) {
        int mx = -1;
        fori(n) {
            if (isUsed[i]) continue;
            iskek[0] = 0; iskek[1] = 0; iskek[2] = 0;
            forj(g[i].size()) {
                int to = g[i][j];
                if (col[to]) {
                    iskek[col[to] - 1] = 1;
                }
            }
            mx = max(mx, iskek[0] + iskek[1] + iskek[2]);
        }
        if (mx == -1 || mx == 3) {
            //cout << "buba\n";
            //fori(n) cout << col[i] << " ";
            exit(0);
        }
        fori(n) {
            if (isUsed[i]) continue;
            iskek[0] = 0; iskek[1] = 0; iskek[2] = 0;
            forj(g[i].size()) {
                int to = g[i][j];
                if (col[to]) {
                    iskek[col[to] - 1] = 1;
                }
            }
            if (iskek[0] + iskek[1] + iskek[2] != mx) continue;
            isUsed[i] = 1;
            if (!iskek[2]) col[i] = 3;
            if (!iskek[1]) col[i] = 2;
            if (!iskek[0]) col[i] = 1;
            //cout << iskek[0] + iskek[1] + iskek[2] << " " << i << " " << col[i] << "\n";
            break;
        }

    }*/
    fori(n) cout << col[i] << " ";
    return 0;
}

/**
6 9
1 2
2 3
3 4
4 5
5 6
6 1
6 2
2 5
5 3
**/




