#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define pb push_back
#define vc vector
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

using ortree = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 5e5;
const int INF = 1e9;
const int MOD = 1e9+7;

//-fsanitize=address,bounds,undefined -D_GLIBCXX_DEBUG
int color[MAXN];
int d[MAXN];
bool used[MAXN];
vc<int> g[MAXN];
set<pr<int, int>> xrs;

void dfs(int v, int col){
	used[v] = 1;
	color[v] = col;
	for (auto to : g[v]){
		if (!used[to]){
			dfs(to, col ^ 1);
		}
	}
}

void solve(istream &in, ostream &out){
	int n, m;
	in >> n >> m;
	vc<pr<int, int>> rebers;
	for (int i = 0; i < m; i++){
		int a, b;
		in >> a >> b;
		a--, b--;
		rebers.pb({a, b});
		g[a].pb(b);
		g[b].pb(a);
	}		
	for (int i = 0; i < n; i++){
		if (!used[i]){
			dfs(i, 0);
		}
	}
	int ans = 2;
	for (auto v : rebers){
		if (color[v.fs] == color[v.sc]){
			ans = 3;
			break;
		}
	}
	if (ans == 2){
		out << ans << '\n';
		for (int i = 0; i < n; i++){
			out << color[i] + 1<< ' ';	
		}
		return;
	}
	for (int i = 0; i < n; i++){
		d[i] = len(g[i]);
		xrs.insert({d[i], i});	
		used[i] = 0;
		color[i] = 0;
	}
	vc<int> pros;
	while(len(xrs) > 0){
		auto x = (*xrs.begin()).sc;
		xrs.erase(xrs.begin());
		used[x] = 1;
		for (auto to : g[x]){
			if (!used[to]){
				xrs.erase({d[to], to});
				d[to]--;
				xrs.insert({d[to], to});
			}
		}
		pros.pb(x);
	}
	reverse(all(pros));
	for (auto v : pros){
		int mem = 0;
		for (auto to : g[v]){
			if (!used[to]){
				mem |= (1 << color[to]); 
			}
		}
		used[v] = 0;
		for (int j = 0; j < ans; j++){
			if ((mem & (1 << j)) == 0){
				color[v] = j;
				break;
			}
		}
	}
	for (auto v : rebers){
		if (color[v.fs] == color[v.sc]){
			exit(1);
		}
	}
	out << ans << '\n';
	for (int i = 0; i < n; i++){
		out << color[i] + 1 << ' ';
	}
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve(cin, cout);
}