#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define pb push_back
#define vc vector
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")

using namespace std;
//using namespace __gnu_pbds;

//using ortree = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 5e5;
const int INF = 1e9;
const int MOD = 1e9+7;

//-fsanitize=address,bounds,undefined -D_GLIBCXX_DEBUG
int color[MAXN];
int d[MAXN];
bool used[MAXN];
vc<int> g[MAXN];

void dfs(int v, int col){
	used[v] = 1;
	color[v] = col;
	for (auto to : g[v]){
		if (!used[to]){
			dfs(to, col ^ 1);
		}
	}
}

void solve(istream &in, ostream &out){
	int n, m;
	in >> n >> m;
	vc<pr<int, int>> rebers;
	for (int i = 0; i < m; i++){
		int a, b;
		in >> a >> b;
		a--, b--;
		rebers.pb({a, b});
		g[a].pb(b);
		g[b].pb(a);
	}		
	for (int i = 0; i < n; i++){
		d[i] = len(g[i]);
		used[i] = 0;
		color[i] = 0;
	}
	vc<int> pros;
	queue<int> q;
	for (int i = 0; i < n; i++){
		if (d[i] <= 1){
			q.push(i);
			used[i] = 1;
		}
	}	
	while(!q.empty()){
		auto v = q.front();
		q.pop();
		for (auto to : g[v]){
			d[to]--;
			if (!used[to] && d[to] <= 1){
				q.push(to);
				used[to] = 1;
			}
		}
		pros.pb(v);
	}
	for (int i = 0; i < n; i++){
		if (d[i] <= 2){
			q.push(i);
			used[i] = 1;
		}
	}
	while(!q.empty()){
		auto v = q.front();
		q.pop();
		for (auto to : g[v]){
			d[to]--;
			if (!used[to] && d[to] <= 2){
				q.push(to);
				used[to] = 1;
			}
		}
		pros.pb(v);
	}
	reverse(all(pros));
	int ans = 3;
	for (auto v : pros){
		int mem = 0;
		for (auto to : g[v]){
			if (!used[to]){
				mem |= (1 << color[to]); 
			}
		}
		used[v] = 0;
		for (int j = 0; j < ans; j++){
			if ((mem & (1 << j)) == 0){
				color[v] = j;
				break;
			}
		}
	}
	ans = 0;
	for (int i = 0; i < n; i++){
		ans = max(ans, color[i] + 1);
	}
	out << ans << '\n';
	for (int i = 0; i < n; i++){
		out << color[i] + 1 << ' ';
	}
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve(cin, cout);
}