#ifndef ON_PC
#include "Sgame.h"
#endif

#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define pb push_back
#define vc vector
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;

const int MAXN = 1e5;
const int INF = 1e9;
const int MOD = 1e9+9;

int ans[MAXN];
char s[MAXN];
int mms[MAXN];

//-fsanitize=address,bounds,undefined -D_GLIBCXX_DEBUG

void start(char w[]){
	int lasts = 0;
	while('a' <= w[lasts] && w[lasts] <= 'z'){
		s[lasts] = w[lasts];
		lasts++;
	}
	for (int i = 0; i < lasts; i++){
		fill(mms, mms + MAXN, 0);
		for (int j = i; j < lasts; j++){
			for (int k = 0; k + j < lasts; k++){
				if (s[i + k] != s[j + k]){
					break;
				}
				mms[k]++;
			}
		}
		for (int k = 0; k + i < lasts; k++){
			ans[k + 1] = max(ans[k + 1], mms[k]);
		}
	}
}

int round(int m, int k){
	int anss = 0;
	for (int d = m; d <= k; d++){
		anss = max(anss, ans[d]);
	}
	return anss;
}

#ifdef ON_PC
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string s;
	cin >> s;
	char w[len(s) + 1];
	for (int i = 0; i < len(s); i++){
		w[i] = s[i];
	}
	w[len(s)] = ' ';
	start(w);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++){
		int a, b;
		cin >> a >> b;
		cout << round(a, b) << '\n';
	}
}
#endif