#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 5e5 + 1;
vector<int> g[N];
int used[N];
int clr[N];
int fl = 1;

void run() {
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    g[a].push_back(b);
    g[b].push_back(a);
  }
  vector<int> ord = {1, 2, 4};
  while (1) {
    fl = 1;
    fill(clr, clr + n, 7);
    for(int i = 0; i < n && fl; i++) {
      if (clr[i] == 1 || clr[i] == 2 || clr[i] == 4) continue;
      if (clr[i] == 0) {
        fl = 0;
        break;
      }
      shuffle(all(ord), gen);
      for(int x : ord) {
        if (clr[i] & x) {
          clr[i] = x;
          for(int to : g[i]) {
            if (clr[to] & x)
              clr[to] ^= x;
          }
          break;
        }
      }
    }
    if (!fl) continue;
    cout << 3 << '\n';
    for(int i = 0; i < n; i++) {
      for(int k = 0; k < 3; k++) {
        if (clr[i] >> k & 1) {
          cout << k + 1 << ' ';
          break;
        }
      }
    }
    return;
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  run();

}
