#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

const int N = 2e3 + 20;
int f[N];

inline void inc(int x, int y) {
  for(; x < N; x |= (x + 1))
    f[x] += y;
}

inline int get(int x) {
  int re = 0;
  for(; x >= 0; x = (x & (x + 1)) - 1)
    re += f[x];
  return re;
}

inline int get(int x, int y) {
  return get(y) - get(x - 1);
}

int p[N], tin[N], tout[N];
int id[N], rid[N];
vector<int> g[N];
int t;

void dfs(int v) {
  tin[v] = t;
  for(int to : g[v]) {
    t++;
    dfs(to);
  }
  tout[v] = t;
}

int st[N];
vector<int> to_cl[N];

int sz[N];

void calc(int v) {
  sz[v] = 1;
  for(int to : g[v]) {
    calc(to);
    sz[v] += sz[to];
  }
}

int tt = 0;
int comp[N], bg[N], ed[N];
int pp = 0;

void build(int v, bool head) {
  for(int i = 0; i < size(g[v]); i++) {
    if (sz[g[v][i]] > sz[g[v][0]])
      swap(g[v][i], g[v][0]);
  }
  if (head) {
    tt++;
    bg[tt] = v;
  }
  id[v] = pp++;
  rid[id[v]] = v;
  ed[tt] = v;
  comp[v] = tt;
  for(int i = 0; i < size(g[v]); i++) {
    build(g[v][i], (i != 0));
  }
}

set<int> dead_inside[N];
inline void put(int x) {
  if (!st[x]) {
    st[x] = 1;
    dead_inside[comp[x]].insert(id[x]);
    if (x)
      to_cl[p[x]].push_back(x);
    inc(tin[x], 1);
  }
}


inline void cl(int x) {
  if (st[x]) {
    st[x] = 0;
    dead_inside[comp[x]].erase(id[x]);
    inc(tin[x], -1);
  }
}

void run() {
  int t = 0;
  int n;
  cin >> n;
  for(int i = 1; i < n; i++) {
    cin >> p[i];
    p[i]--;
    g[p[i]].push_back(i);
  }
  dfs(0);
  calc(0);
  build(0, 1);
  int q;
  cin >> q;
  while(q--) {
    int t, x;
    cin >> t >> x;
    --x;
    if (t == 1) {
      put(x);
    } else if (t == 4) {
      cout << get(tin[x], tout[x]) << '\n';
    } else if (t == 2) {
      int y = x;
      int la = -1;
      while (1) {
        while (!dead_inside[comp[x]].empty()) {
          int d = *dead_inside[comp[x]].begin();
          d = rid[d];
          if (!(tin[d] <= tin[y] && tout[y] <= tout[d])) break;
          cl(d);
          for(int to : g[d]) {
            if (to == la) continue;
            else if (d == y) put(to);
            else if (ed[d]) {
              if (to != la) put(to);
            }
            else if (comp[d] != comp[to]) put(to);
          }
        }
        if (!bg[comp[x]]) break;
        la = bg[comp[x]];
        x = p[bg[comp[x]]];
      }
    } else if (t == 3) {
      cl(x);
      for(int to : to_cl[x]) {
        cl(to);
      }
      to_cl[x].clear();
    }
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  run();

}
