#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

string s;
const int N = 5e3 + 1;
int res[N], fl[N];
int p[N], pn[N], c[N], cn[N], cnt[N];

void sufmas() {
  s += '#';
  for(char c : s) cnt[c]++;
  int n = size(s);
  partial_sum(cnt, cnt + N, cnt);
  for(int i = 0; i < n; i++) {
    p[--cnt[s[i]]] = i;
  }
  int classes = 0;
  for(int i = 1; i < n; i++) {
    if (s[p[i]] != s[p[i - 1]])
      classes++;
    c[i] = classes;
  }
  for(int d = 0; (1 << d) < size(s); d++) {
    for(int i = 0; i < n; i++) {
      pn[i] = p[i] - (1 << d);
      if (pn[i] < 0) pn[i] += n;
    }
    fill(cnt, cnt + N, 0);
    for(int i = 0; i < n; i++)
      cnt[c[i]]++;
    partial_sum(cnt, cnt + N, cnt);
    for(int i = n - 1; i >= 0; i--)
      p[i] = --cnt[c[pn[i]]];
    for(int i = 0; i < n; i++) {
      cout << p[i] << ' ';
    }
    exit(0);
  }
  s.pop_back();
  exit(0);
}

void precal() {
  map<string, int> tot;
  for(int len = 1; len <= size(s); len++) {
    map<string, int> cnt;
    for(int i = 0; i + len <= size(s); i++) {
      cnt[s.substr(i, len)]++;
      tot[s.substr(i, len)]++;
    }
    for(auto v : cnt) chkmax(res[len], v.y);
  }
  for(int len = 1; len <= size(s); len++) {
    for(int i = 0; i + len <= size(s); i++) {
      string c = s.substr(i, len);
      int be = 1;
      for(int j = 0; j < 26; j++) {
        string a = c + string(1, 'a' + j);
        string b = string(1, 'a' + j) + c;
        if (max(tot[a], tot[b]) == tot[c]) be = 0;
      }
      if (be)
        chkmax(fl[len], tot[c]);
    }
  }
}

void start(char w[]) {
  for(int i = 0; ; i++) {
    if (!w[i]) break;
    s += w[i];
  }
  sufmas();
  precal();
}

int round(int l, int r) {
  if (res[l] != res[r]) return res[l];
  int ans = 0;
  for(int i = l; i <= r; i++) chkmax(ans, fl[i]);
  return ans;
}

#ifdef LOCAL
signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  char t[100];
  cin >> t;
  start(t);
  int m;
  cin >> m;
  for(int i = 0; i < m; i++) {
    int l, r;
    cin >> l >> r;
    cout << round(l, r) << endl;
  }
}
#endif
