#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
mt19937_64 gen;

string s;
const int N = 5e3 + 1;
int res[N], fl[N];
int p[N], pn[N], c[N], cn[N], cnt[N];

void sufmas() {
  s += '#';
  for(char c : s) cnt[c]++;
  int n = size(s);
  partial_sum(cnt, cnt + N, cnt);
  for(int i = 0; i < n; i++) {
    p[--cnt[s[i]]] = i;
  }
  int classes = 0;
  for(int i = 1; i < n; i++) {
    if (s[p[i]] != s[p[i - 1]])
      classes++;
    c[i] = classes;
  }
  for(int d = 0; (1 << d) < size(s); d++) {
    for(int i = 0; i < n; i++) {
      pn[i] = p[i] - (1 << d);
      if (pn[i] < 0) pn[i] += n;
    }
    fill(cnt, cnt + N, 0);
    for(int i = 0; i < n; i++)
      cnt[c[i]]++;
    partial_sum(cnt, cnt + N, cnt);
    for(int i = n - 1; i >= 0; i--)
      p[i] = --cnt[c[pn[i]]];
    for(int i = 0; i < n; i++) {
      cout << p[i] << ' ';
    }
    exit(0);
  }
  s.pop_back();
  exit(0);
}

void calc_LCP() {

}

int f[N];

int pa(int x) {
  if (x == f[x]) return x;
  return f[x] = pa(f[x]);
}

void join(int x, int y) {
  f[pa(x)] = pa(y);
}
inline void inc(int x, int y) {
  for(; x < N; x |= (x + 1))
    f[x] += y;
}

inline int get(int x) {
  int re = 0;
  for(; x >= 0; x = (x & (x + 1)) - 1)
    re += f[x];
  return re;
}

inline int get(int x, int y) {
  return get(y) - get(x - 1);
}

int tin[N], tout[N];
int id[N], rid[N];
vector<int> g[N];
int t;

void dfs(int v) {
  tin[v] = t;
  for(int to : g[v]) {
    t++;
    dfs(to);
  }
  tout[v] = t;
}

int st[N];
vector<int> to_cl[N];

int sz[N];

void calc(int v) {
  sz[v] = 1;
  for(int to : g[v]) {
    calc(to);
    sz[v] += sz[to];
  }
}

int tt = 0;
int comp[N], bg[N], ed[N];
int pp = 0;

void build(int v, bool head) {
  for(int i = 0; i < size(g[v]); i++) {
    if (sz[g[v][i]] > sz[g[v][0]])
      swap(g[v][i], g[v][0]);
  }
  if (head) {
    tt++;
    bg[tt] = v;
  }
  id[v] = pp++;
  rid[id[v]] = v;
  ed[tt] = v;
  comp[v] = tt;
  for(int i = 0; i < size(g[v]); i++) {
    build(g[v][i], (i != 0));
  }
}

set<int> dead_inside[N];
inline void put(int x) {
  if (!st[x]) {
    st[x] = 1;
    dead_inside[comp[x]].insert(id[x]);
    if (x)
      to_cl[p[x]].push_back(x);
    inc(tin[x], 1);
  }
}


inline void cl(int x) {
  if (st[x]) {
    st[x] = 0;
    dead_inside[comp[x]].erase(id[x]);
    inc(tin[x], -1);
  }
}

void run() {
  int t = 0;
  int n;
  cin >> n;
  for(int i = 1; i < n; i++) {
    cin >> p[i];
    p[i]--;
    g[p[i]].push_back(i);
  }
  dfs(0);
  calc(0);
  build(0, 1);
  int q;
  cin >> q;
  while(q--) {
    int t, x;
    cin >> t >> x;
    --x;
    if (t == 1) {
      put(x);
    } else if (t == 4) {
      cout << get(tin[x], tout[x]) << '\n';
    } else if (t == 2) {
      int y = x;
      int la = -1;
      while (1) {
        while (!dead_inside[comp[x]].empty()) {
          int d = *dead_inside[comp[x]].begin();
          d = rid[d];
          if (!(tin[d] <= tin[y] && tout[y] <= tout[d])) break;
          cl(d);
          for(int to : g[d]) {
            if (to == la) continue;
            else if (d == y) put(to);
            else if (ed[d]) {
              if (to != la) put(to);
            }
            else if (comp[d] != comp[to]) put(to);
          }
        }
        if (!bg[comp[x]]) break;
        la = bg[comp[x]];
        x = p[bg[comp[x]]];
      }
    } else if (t == 3) {
      cl(x);
      for(int to : to_cl[x]) {
        cl(to);
      }
      to_cl[x].clear();
    }
  }
}

void precal() {
  map<string, int> tot;
  for(int len = 1; len <= size(s); len++) {
    map<string, int> cnt;
    for(int i = 0; i + len <= size(s); i++) {
      cnt[s.substr(i, len)]++;
      tot[s.substr(i, len)]++;
    }
    for(auto v : cnt) chkmax(res[len], v.y);
  }
  for(int len = 1; len <= size(s); len++) {
    for(int i = 0; i + len <= size(s); i++) {
      string c = s.substr(i, len);
      int be = 1;
      for(int j = 0; j < 26; j++) {
        string a = c + string(1, 'a' + j);
        string b = string(1, 'a' + j) + c;
        if (max(tot[a], tot[b]) == tot[c]) be = 0;
      }
      if (be)
        chkmax(fl[len], tot[c]);
    }
  }
}

void start(char w[]) {
  for(int i = 0; ; i++) {
    if (!w[i]) break;
    s += w[i];
  }
  exit(0);
  sufmas();
  precal();
}

int round(int l, int r) {
  if (res[l] != res[r]) return res[l];
  if (res[r] != res[r + 1]) return res[r];
  int ans = 0;
  for(int i = l; i <= r; i++) chkmax(ans, fl[i]);
  return ans;
}

#ifdef LOCAL
signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  char t[100];
  cin >> t;
  start(t);
  int m;
  cin >> m;
  for(int i = 0; i < m; i++) {
    int l, r;
    cin >> l >> r;
    cout << round(l, r) << endl;
  }
}
#endif
