#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cmath>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <algorithm>
#include <numeric>
#include <random>
#include <bitset>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

const int N = 300001, L = 19;
int tin[N], tout[N], ct, h[N], par[N], f[N], x[N];
set<int> es[N];
vector<int> g[N];

void add(int v, int d) {
	for (int i = v; i < N; i |= (i + 1))
		f[i] += d;
}

int sum(int v) {
	int res = 0;
	for (int i = v; i; i &= (i - 1))
		res += f[i - 1];
	return res;
}

int sum(int l, int r) {
	return sum(r) - sum(l);
}

void dfs(int v, int p) {
	tin[v] = ct++;
	for (int u : g[v]) {
		h[u] = h[v] + 1;
		dfs(u, v);
	}
	tout[v] = ct;
}

int main() {
#ifdef ONPC
	freopen("in", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n, q, t, v;
	cin >> n;
	for (int i = 1; i < n; i++) {
		cin >> par[i];
		par[i]--;
		g[par[i]].push_back(i);
	}
	dfs(0, 0);
	cin >> q;
	rep(z, q) {
		cin >> t >> v;
		v--;
		if (t == 1) {
			if (x[v])
				continue;
			x[v] = 1;
			add(tin[v], 1);
			if (v)
				es[par[v]].insert(v);
		}
		else if (t == 3) {
			if (x[v]) {
				x[v] = 0;
				add(tin[v], -1);
				if (v)
					es[par[v]].erase(v);
			}
			for (int i : es[v]) {
				x[i] = 0;
				add(tin[i], -1);
			}
			es[v].clear();
		}
		else if (t == 4)
			cout << sum(tin[v], tout[v]) << '\n';
	}
}

