#include <bits/stdc++.h>
using namespace std;

const int MEM = 1e8;
char mem[MEM];
int ptr = 0;

void *operator new(size_t sz) {
    ptr += sz;
    return mem + ptr - sz;
}

void operator delete(void *) noexcept {

}
void operator delete(void *, size_t) noexcept {

}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second

const int MAXN = 5e5 + 5;
int n, m;
vector<int> g[MAXN];
int a[MAXN];

int ff(const vector<int> &t, int x) {
    // prev(lower_bound)
    if (t.empty()) return -1;
    auto it = lower_bound(all(t), x);
    if (it == t.begin()) {
        it = prev(t.end());
    } else {
        it = prev(it);
    }
    return *it;
}

int ub(const vector<int> &t, int x) {
    // cout << "ub " << x << endl;
    // upper_bound
    if (t.empty()) return -1;
    auto it = upper_bound(all(t), x);
    if (it == t.end()) {
        it = t.begin();
    }
    // cout << " : " << *it << endl;
    return *it;
}

bool in_arc(int x, int y, int v) {
    if (x <= y && x <= v && v <= y) return true;
    if (y < x && (v <= y || x <= v)) return true;
    return false;
}

int get(int x) {
    if (x == 1) return 2;
    return 1;
}

int get(int x, int y) {
    if (x != 1 && y != 1) return 1;
    if (x != 2 && y != 2) return 2;
    if (x != 3 && y != 3) return 3;
    assert(false);
}

void solve(int x, int y) {
    // if ((x != 0 || y != 1) && (x != 1 || y != 0)) return;
    // cout << "solve " << x << ' ' << y << endl;
    if (x == y) return;
    vector<int> arcs;
    int v = x;
    while (true) {
        auto it = lower_bound(all(g[v]), y);
        if (v != x && it != g[v].end() && *it == y) {
            arcs.push_back(y);
            break;
        }
        int to = ff(g[v], y);
        // cout << "to " << to << endl;
        if (to == -1 || !in_arc(v, y, to) || (to == y && v == x)) {
            break;
        }
        arcs.push_back(to);
        v = to;
    }

    // for (auto it : arcs) {
    //     cout << it << ' ';
    // }
    // cout << endl;

    if (arcs.empty() || arcs.back() != y) {
        // cout << "ok" << endl;
        rep(i, arcs.size()) {
            a[arcs[i]] = get(a[x]);
            solve(x, arcs[i]);
            x = arcs[i];
        }
        // for (auto it : arcs) {
        //     solve(x, it);
        //     x = it;
        // }

        int v = y;
        while (v != x) {
            int to = ub(g[v], x);
            // cout << v << " -> " << to << endl;
            if (to != -1 && in_arc(x, v, to) && (v != y || to != x)) {
                if (v == y) {
                    a[to] = get(a[y]);
                } else {
                    a[v] = 1;
                    a[to] = 2;
                }

                solve(x, to);
                solve(to, v);
                break;
            }
            if (v == 0) {
                v = n - 1;
            } else {
                v--;
            }
        }
    } else {
        arcs.pop_back();
        rep(i, arcs.size()) {
            if (i + 1 == arcs.size()) {
                // cout << "get " << a[x] << ' ' << a[y] << endl;
                a[arcs[i]] = get(a[x], a[y]);
            } else {
                // cout << "get " << a[y] << endl;
                a[arcs[i]] = get(a[x]);
            }
            // cout << i << " : " << arcs[i] << ' ' << a[arcs[i]] << endl;
            solve(x, arcs[i]);
            x = arcs[i];
        }
        solve(x, y);
    }
}

bool is_d(char ch) {
    return ('0' <= ch && ch <= '9');
}

int readInt() {
    int x = 0;
    bool d = 0;
    while (true) {
        char ch = getchar();
        if (!is_d(ch)) {
            if (d) break;
            continue;
        } else {
            d = true;
            x *= 10;
            x += (ch - '0');
        }
    }
    return x;
}

// void writeInt(int x) {
//     if (x == 0) {
//         putchar('0');
//         return;
//     }
// }

int main() {
    FAST_IO;
    // cin >> n >> m;
    n = readInt();
    m = readInt();
    rep(i, m) {
        int u, v;
        // cin >> u >> v;
        u = readInt();
        v = readInt();
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    rep(v, n) {
        // sort(all(g[v]), [&](int a, int b){
        //     if (a < v && b > v) return a;
        //     if (b < v && a > v) return b;
        //     return a < b;
        // });
        sort(all(g[v]));
    }

    // if (n > 1e5 + 5) {
    //     return 0;
    // }

    rep(i, n) {
        a[i] = 1;
    }

    rep(i, n) {
        if (!g[i].empty()) {
            int j = g[i][0];
            a[i] = 1;
            a[j] = 2;
            solve(i, j);
            solve(j, i);
            break;
        }
    }
    // a[0] = 1;
    // a[3] = 2;
    // solve(3, 0);

    cout << *max_element(a, a + n) << '\n';
    rep(i, n) {
        cout << a[i] << ' ';
    }
    cout << '\n';
}
