#include "Sgame.h"
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second

const int MAXN = 5e5 + 5;
int n;
string s;
int best[MAXN];

int get(string t) {
    int res = 0;
    for (int i = 0; i + t.size() <= s.size(); ++i) {
        if (s.substr(i, t.size()) == t) {
            res++;
        }
    }
    return res;
}

bool is_ok(string t) {
    char beg = -1, en = -1;
    for (int i = 0; i + t.size() <= s.size(); ++i) {
        if (s.substr(i, t.size()) == t) {
            if (i) {
                if (beg == -1) {
                    beg = s[i - 1];
                } else {
                    if (beg != s[i - 1]) {
                        beg = -2;
                    }
                }
            } else {
                beg = -2;
            }
            int j = i + t.size();
            if (j != n) {
                if (en == -1) {
                    en = s[j];
                } else {
                    if (en != s[j]) {
                        en = -2;
                    }
                }
            } else {
                en = -2;
            }
            // cout << i << ' ' << beg << ' ' << en << endl;
        }
    }

    // cout << t << ' ' << (int)beg << ' ' << (int)en << endl;

    return (beg == -2 && en == -2);
}

void start(char w[]) {
    s = w;
    n = s.size();

    rep(i, n) {
        assert('a' <= s[i] && s[i] <= 'z');
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 1; i + j <= n; ++j) {
            string t = s.substr(i, j);
            if (is_ok(t)) {
                // cout << t << endl;
                best[t.size()] = max(best[t.size()], get(t));
            }
        }
    }
}

int round(int m, int k) {
    // cout << "round " << m << ' ' << k << endl;
    int res = 0;
    for (int i = m; i <= k; ++i) {
        res = max(res, best[i]);
    }
    return res;
}
