#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second
#define hash hash123

const int MAXN = 3e5 + 5;
int n, q;
int p[MAXN];
vector<int> g[MAXN];
int tt;
int tin[MAXN];
int tout[MAXN];
bool act[MAXN];
set<int> act_ch[MAXN];

void dfs(int v) {
    tin[v] = tt++;
    for (auto to : g[v]) {
        dfs(to);
    }
    tout[v] = tt;
}

int t[MAXN];

void add(int p, int x) {
    for (int i = p; i < n; i = (i | (i + 1))) {
        t[i] += x;
    }
}

int get(int r) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += t[i];
    }
    return res;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

int main() {
    FAST_IO;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    p[0] = -1;

    dfs(0);
    cin >> q;
    rep(i, q) {
        int t, v;
        cin >> t >> v;
        v--;
        if (t == 1) {
            if (act[v]) continue;
            act[v] = true;
            if (p[v] != -1) {
                act_ch[p[v]].insert(v);
            }
            add(tin[v], 1);
        } else if (t == 2) {
            assert(false);
        } else if (t == 3) {
            for (auto it : act_ch[v]) {
                act[it] = false;
                add(tin[it], -1);
            }
            act_ch[v].clear();

            if (act[v]) {
                if (p[v] != -1) {
                    act_ch[p[v]].erase(v);
                }
                act[v] = false;
                add(tin[v], -1);
            }
        } else {
            cout << get(tin[v], tout[v] - 1) << endl;
        }
    }
}
