#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 3e5 + 7;

vector <int> g[N];
int par[N];
int fenw[N];
int tin[N], tout[N];

int tt = 0;

void dfs(int v) {
	tin[v] = tt++;
	for (int to : g[v]) {
		dfs(to);
	}
	tout[v] = tt;
}

void inc(int x, int y) {
	for (; x < N; x = (x | (x + 1))) {
		fenw[x] += y;
	}
}

int get(int x) {
	int ans = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1) {
		ans += fenw[x];
	}
	return ans;
}

bool bad[N];

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	par[0] = -1;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(i);
		par[i] = p;
	}
	dfs(0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			x--;
			if (!bad[x]) {
				bad[x] = true;
				inc(tin[x], 1);
			}
		} else if (t == 2) {
			int x;
			cin >> x;
			x--;
			int prev = -1;
			while (x != -1) {
				if (bad[x]) {
					bad[x] = false;
					inc(tin[x], -1);
					for (auto c : g[x]) {
						if (c != prev && !bad[c]) {
							inc(tin[c], 1);
							bad[c] = true;
						}
					}
				}
				prev = x;
				x = par[x];
			}
		} else if (t == 3) {
			int x;
			cin >> x;
			x--;
			for (auto c : g[x]) {
				if (bad[c]) {
					bad[c] = false;
					inc(tin[c], -1);
				}
			}
			if (bad[x]) {
				bad[x] = false;
				inc(tin[x], -1);
			}
		} else {
			int v;
			cin >> v;
			v--;
			cout << get(tout[v] - 1) - get(tin[v] - 1) << endl;
		}
	}
}
