#include <bits/stdc++.h>

using namespace std;

const int N = 5e5 + 7;

vector <int> g[N];

bool u[N];
int col[N];

void dfs(int v, int c) {
	if (u[v]) return;
	col[v] = c;
	u[v] = true;
	for (int to : g[v]) {
		if (!u[to]) {
			dfs(to, c ^ 1);
		}
	}
}

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) if (!u[i]) dfs(i, 0);
	bool bad = false;
	for (int i = 0; i < n; i++) {
		for (int j: g[i]) {
			if (col[i] == col[j])
				bad = true;
		}
	}
	if (!bad) {
		cout << 2 << endl;
		for (int i = 0; i < n; i++) {
			cout << col[i] + 1 << ' ';
		}
		cout << endl;
	} else {
		set <pair <int, int> > q;
		vector <int> deg(n);
		for (int i = 0; i < n; i++) deg[i] = g[i].size();
		for (int i = 0; i < n; i++) {
			q.insert({deg[i], i});
			u[i] = false;
		}
		vector <int> ord;
		while (!q.empty()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			u[v] = true;
			ord.push_back(v);
			for (int to : g[v]) {
				if (!u[to]) {
					q.erase({deg[to], to});
					deg[to]--;
					q.insert({deg[to], to});
				}
			}
		}
		reverse(ord.begin(), ord.end());
		vector <int> ans(n, -1);
		for (int v : ord) {
			set <int> q;
			for (int to : g[v]) {
				q.insert(ans[to]);
			}
			int me = 0;
			while (q.count(me)) me++;
			ans[v] = me;
			assert(ans[v] <= 2);
		}
		cout << 3 << endl;
		for (int i = 0; i < n; i++) {
			cout << ans[i] + 1 << ' ';
		}
		cout << endl;
	}
}
