#include "Sgame.h"
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 1010;
int n, cnt[mx][mx];
string s;
map<string, int> mp;

void start(char *w) {
	while (w[n] != 0) {
		s.push_back(w[n++]);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= n - i; ++j) {
			mp[s.substr(i, j)]++;
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= n - i; ++j) {
			cnt[i][j] = mp[s.substr(i, j)];
		}
	}
}

int round(int m, int k) {
	assert(1 <= m && m <= k && k <= n);
	k++;
	int best = 0;
	for (int len = m; len < k; ++len) {
		for (int i = 0; i <= n - len; ++i) {
			int cur = cnt[i][len];
			if (i <= n - k && cnt[i][k] == cnt[i][len]) {
				continue;
			}
			if (i >= k - len && cnt[i - (k - len)][k] == cnt[i][len]) {
				continue;
			}
			chkmax(best, cur);
		}
	}
	return best;
}
