#include "Sgame.h"
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n;
string s;

int occur_cnt(string pattern) {
	int len = pattern.size(), res = 0;
	for (int i = 0; i <= n - len; ++i) {
		if (pattern == s.substr(i, len)) {
			res++;
		}
	}
	return res;
}

void start(char *w) {
	while (w[n] != 0) {
		s.push_back(w[n++]);
	}
}

int round(int m, int k) {
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int len = m; len <= min(k, n - i); ++len) {
			string sub = s.substr(i, len);
			int cur = occur_cnt(sub);
			int bad = 0;
			for (int l = 0; l < n; ++l) {
				for (int len2 = 1; len2 <= n - l; ++len2) {
					if (len + len2 >= k) {
						string t = s.substr(l, len2);
						string t1 = t + sub;
						string t2 = sub + t;
						if (occur_cnt(t1) >= cur || occur_cnt(t2) >= cur) {
							bad = 1;
							break;
						}
					}
				}
			}
			if (!bad) {
				chkmax(ans, cur);
			}
		}
	}
	return ans;
}
