#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b; 
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
int n, m, clr[mx];
vector<vector<int> > g;

void read_graph() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
}

int dfs(int v, int new_clr) {
	clr[v] = new_clr;
	for (auto v1 : g[v]) {
		if (clr[v1] != -1 && clr[v1] == new_clr) {
			return 1;
		}
		if (clr[v1] == -1 && dfs(v1, new_clr ^ 1)) {
			return 1;
		}
	}
	return 0;
}

void print() {
	cout << (*max_element(clr, clr + n)) + 1 << endl;
	for (int i = 0; i < n; ++i) {
		cout << clr[i] + 1 << " ";
	}
	cout << endl;
}

void check2() {
	fill(clr, clr + n, -1);
	for (int i = 0; i < n; ++i) {
		if (clr[i] == -1 && dfs(i, 0)) {
			return;
		}
	}
	print();
	exit(0);
}

void make3() {
	fill(clr, clr + n, -1);
	for (int i = 0; i < n; ++i) {
		vector<int> used(3);
		for (auto v : g[i]) {
			if (clr[v] != -1) {
				used[clr[v]] = 1;
			}
		}
		for (int j = 0; j < 3; ++j) {
			if (used[j] == 0) {
				clr[i] = j;
				break;
			}
		}
		assert(clr[i] != -1);
	}
	print();
}

int main() {
	fast_io();
	read_graph();
	check2();
	make3();
}
