#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T> void uax(T &a, T b) { if (b > a) a = b; }
template<typename T> void uin(T &a, T b) { if (b < a) a = b; }

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define x first
#define y second
#define right right228
#define left left228
#define prev pref228

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18;// mod = 1000'000'007;

mt19937 rnd(time(NULL));

const int N = 500001;
vector<int> g[N], c;
int n;
bool check() {
	vector<int> q(n);
	int qs = 0, qt = 1;
	bool ok = 1;
	forn(i, n) {
		if (c[i] >= 0) continue;
		c[i] = 0;
		q[qt++] = i;
		while(qs < qt) {
			int v = q[qs++];
			for (auto to : g[v]) {
				if (c[to] == -1) q[qt++] = to, c[to] = 1 - c[v];
				else if (c[v] == c[to]) {
					ok = 0;
					break;
				}
			}
		}
		if (!ok) break;
	}
	return ok;
}
// void dfs(int l, int r) {
// 	if (l + 1 >= r) return;
// 	// cout << l << ' ' << r << endl;
// 	// if (l == r) {
// 	// 	// if (c[l] == -1) c[l] = 0;
// 	// 	return;
// 	// }
// 	// if (c[l] == -1) {
// 	// 	c[l] = 0;
// 	// 	if (c[r] == 0) c[l] = 1;
// 	// }
// 	// if (c[r] == -1) {
// 	// 	c[r] = 0;
// 	// 	if (c[l] == 0) c[r] = 1;
// 	// }
// 	int cnt = 3 - c[l] - c[r];
// 	// if (c[v] == 0) cnt = 1;
// 	vector<int> ord;
// 	for (int i = (int)g[l].size() - 1; i >= 0; i--) {
// 		int to = g[l][i];
// 		if (to >= r) continue;
// 		if (to <= l) break;
// 		c[to] = cnt;
// 		cnt = 3 - c[l] - c[to];
// 		ord.push_back(to);
// 	}
// 	reverse(all(ord));
// 	cnt = c[l];
// 	forn(i, g[r].size()) {
// 		int to = g[r][i];
// 		if (to <= l) continue;
// 		if (to >= r) break;
// 		if (!ord.empty() && ord.back() == to) cnt = 3 - c[l] - c[r];
// 		c[to] = cnt;
// 		cnt = 3 - c[r] - c[to];
// 		ord.push_back(to);
// 	}
// 	firn(i, ord.size()) {
// 		dfs(ord[i - 1], ord[i]);
// 	}
// 	// if (ord.empty()) dfs(l + 1, r - 1);
// 	// else dfs(ord.back(), r - 1);
// }
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	int m;
	cin >> n >> m;
	forn(i, m) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	c.assign(n, -1);
	if (check()) {
		cout << 2 << el;
		forn(i, n) cout << c[i] + 1 << ' ';
		cout << el;
		return 0;
	}
	forn(i, n) {
		int v = i, u = i + 1;
		if (u == n) u = 0;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	forn(i, n) {
		sort(all(g[i]));
		g[i].resize(distance(g[i].begin(), unique(all(g[i]))));
	}
	vector<pair<int, int>> och;
	c.assign(n, -1);
	c[0] = 0;
	forn(i, g[0].size()) {
		c[g[0][i]] = ((i & 1) ? 2 : 1);
	}
	firn(i, g[0].size()) {
		och.emplace_back(g[0][i - 1], g[0][i]);
	}
	vector<int> ord;
	ord.reserve(n);
	for (int i = 0; i < (int)och.size(); i++) {
		int l = och[i].x, r = och[i].y;
		if (l + 1 >= r) continue;
		int cnt = 3 - c[l] - c[r];
		ord.clear();
		for (int i = (int)g[l].size() - 1; i >= 0; i--) {
			int to = g[l][i];
			if (to >= r) continue;
			if (to <= l) break;
			c[to] = cnt;
			cnt = 3 - c[l] - c[to];
			ord.push_back(to);
		}
		reverse(all(ord));
		cnt = c[l];
		forn(i, g[r].size()) {
			int to = g[r][i];
			if (to <= l) continue;
			if (to >= r) break;
			if (!ord.empty() && ord.back() == to) cnt = 3 - c[l] - c[r];
			c[to] = cnt;
			cnt = 3 - c[r] - c[to];
			ord.push_back(to);
		}
		firn(i, ord.size()) {
			och.emplace_back(ord[i - 1], ord[i]);
		}
	}
	// dfs(g[0].back(), n - 1);
	cout << 3 << el;
	forn(i, n) cout << c[i] + 1 << ' ';
	cout << el;
	return 0;
}

