#include <bits/stdc++.h>


using namespace std;
template<class T1, class T2> inline void chkmax(T1 &a, const T2 &b) {a = (a > b ? a: b);}
template<class T1, class T2> inline void chkmin(T1 &a, const T2 &b) {a = (a < b ? a: b);}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define rank rank228
#define left left228
#define right right228
using ll = long long;
using ld = long double;
const int MAXN = 300228;




char readChar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int readInt() {
	char c = readChar();
	int res = 0;
	while (true) {
		res *= 10;
		res += c - '0';
		c =getchar_unlocked();
		if (c < '0' || c > '9') {
			break;
		}
	}
	return res;
}

int n, q;
vector<int> g[MAXN];
int dep[MAXN];
int pr[MAXN];

void dfsb(int u) {
	dep[u] = 1;
	for (auto h: g[u]) {
		pr[h] = u;
		dfsb(h);
		chkmax(dep[u], dep[h] + 1);
	}
	if (g[u].empty()) {
		return;
	}
	for (int i = 0; i < sz(g[u]); i++) {
		if (dep[g[u][i]] == dep[u] - 1) {
			swap(g[u][i], g[u][0]);
			break;
		}
	}
}

int l[MAXN], r[MAXN];
int uk = -1;
int top[MAXN];
int f[MAXN];
set<pair<int, int> > curbad[MAXN];
set<int> sons[MAXN], sonsg[MAXN];
bool bad[MAXN];
int height[MAXN];


void dfsb1(int u, int c) {
	uk++;
 	l[u] = uk;
 	top[u] = c;
 	for (auto h: g[u]) {
 		sonsg[u].insert(h);
 		height[h] = height[u] + 1;
 		if (h == g[u][0]) {
 			dfsb1(h, c);
 		} else {
 			dfsb1(h, h);
 		}
 	}
 	r[u] = uk;
}


void inc(int i, int val) {
	for (; i < n; i |= (i + 1)) {
		f[i] += val;
	}
}


int get(int l) {
	int res = 0;
	for (; l >= 0; l = (l & (l + 1)) - 1) {
		res += f[l];
	}
	return res;
}


int get(int l, int r) {
	return get(r) - get(l - 1);
}


void add(int u) {
	assert(!bad[u]);
	bad[u] = true;
	if (u != pr[u]) {
		sons[pr[u]].insert(u);
	}
	curbad[top[u]].insert({height[u], u});
	inc(l[u], 1);
}


void del(int u) {
	assert(bad[u]);
	bad[u] = false;
	if (u != pr[u]) {
		sons[pr[u]].erase(u);
	}
	curbad[top[u]].erase({height[u], u});
	inc(l[u], -1);
}


bool ispr(int a, int b) {
	return l[a] <= l[b] && r[b] <= r[a];
}



int mod[MAXN];
int timer[MAXN];
int cnt[MAXN];
int mod1[MAXN];
int timer1[MAXN];
int d[MAXN * 4];
int ss = 1;

void change(int i, int x) {
	i += ss;
	d[i] = x;
	while (i >> 1) {
		i >>= 1;
		d[i] = max(d[i * 2], d[i * 2 + 1]);
	}
}


int getmax(int l, int r) {
	l += ss;
	r += ss;
	int res = -1;
	while (l <= r) {
		if (l & 1) {
			chkmax(res, d[l]);
			l++;
		}
		if (!(r & 1)) {
			chkmax(res, d[r]);
			r--;
		}
		l >>= 1;
		r >>= 1;
	}
	return res;
}

bool getbad(int u) {
	if (bad[u]) {
		return false;
	}
	int k = getmax(l[u], r[u]);
	if (u && max(k, timer1[u]) < timer[pr[u]]) {
		if (timer[pr[u]] != -1) {
			if (mod[pr[u]] == -1) {
				return true;
			}
		}
	} else {
		if (k < timer1[u] && mod1[u] == -1) {
			return true;
		}
	}
	return false;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	n = readInt();
	for (int i = 1; i < n; i++) {
		int p = readInt();
		p--;
		g[p].pb(i);
	}
	for (int i = 0; i < n; i++) {
		timer[i] = -1;
		timer1[i] = -1;
	}
	dfsb(0);
	dfsb1(0, 0);
	while (ss < n) {
		ss <<= 1;
	}
	for (int i = 0; i < 2 * ss; i++) {
		d[i] = -1;
	}
	q = readInt();
	for (int it = 0; it < q; it++) {
		int t = readInt();
		if (t == 1) {
			int u;
			u = readInt();
			u--;
			if (bad[u]) {

			} else {
				if (!getbad(u)) {
					mod1[u] = -1;
					timer1[u] = it;
					add(u);
				}
			}
		} else if (t == 2) {
			int u;
			u = readInt();
			u--;
			vector<int> delg;
			vector<int> addg;
			int fu = u;
			while (true) {
				int gg = top[u];
				auto its = curbad[gg].begin();
				vector<int> fk;
				while (its != curbad[gg].end()) {
					if (its->first <= height[u]) {
						fk.pb(its->second);
					} else {
						break;
					}
					its++;
				}
				for (auto x: fk) {
					delg.pb(x);
					mod1[x] = 1;
					timer1[x] = it;
					mod[x] = -1;
					timer[x] = it;
					inc(l[x], -cnt[x]);
					for (auto y: sons[x]) {
						delg.pb(y);
					}
					sons[x].clear();
					cnt[x] = sz(g[x]) - 1;
					inc(l[x], cnt[x]);
				}
				if (gg == 0) {
					break;
				}
				u = pr[gg];
			}
			change(u, it);
			for (auto x: delg) {
				if (bad[x]) {
					del(x);
					mod1[x] = 1;
					timer1[x] = it;
				}
			}
		} else if (t == 3) {
			int u;
			u = readInt();
			u--;
			mod[u] = 1;
			timer[u] = it;
			if (getbad(u)) {
				inc(l[u], -1);
			}
 			inc(l[u], -cnt[u]);
 			mod1[u] = 1;
			timer1[u] = it;
			cnt[u] = 0;
			if (bad[u]) {
				del(u);
			}
			for (auto y: sons[u]) {
				del(y);
			}
			sons[u].clear();
		} else {
			int u;
			u = readInt();
			u--;
			int f = get(l[u], r[u]);
			if (!bad[u]) {
				if (getbad(u)) {
					f++;
				//	cout << "opa" << endl;
				}
			}
			cout << f << '\n';
		}
	}
}