
#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 100, LG = 5;
int pred[N], used[N], tin[N], tout[N], timer = 0, LCA[N][LG];
std::vector<int> g[N];
struct fenw
{
	ll f[N];
	fenw() {
		memset(f, 0, sizeof(f));
	}
	void upd(int i, int x) {
		for (; i < N; i = (i | (i + 1))) {
			f[i] += x;
		}
	}
	void upd(int l, int r, int x) {
		upd(l, x);
		upd(r + 1, -x);
	}
	ll get(int r) {
		ll s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			s += f[r];
		}
		return s;
	}
	ll get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
fenw tree1, tree2;
int n;
void dfs(int v) {
	tin[v] = timer++;
	for (auto e : g[v]) {
		dfs(e);
	}
	tout[v] = timer - 1;
}
std::set<int> good[N], bad[N];
void updVertex(int x, int delta) {
	// debug(x << ' ' << delta)
	if (pred[x] != -1) {
		if (delta == 1) {
			good[pred[x]].erase(x);
			bad[pred[x]].insert(x);
		}
		if (delta == -1) {
			good[pred[x]].insert(x);
			bad[pred[x]].erase(x);
		}
	}
	tree1.upd(tin[x], delta);
	tree2.upd(tin[x], tout[x], delta);
	// tree1.upd(1, 0, n - 1, tin[x], tin[x], delta);
	// tree2.upd(1, 0, n - 1, tin[x], tout[x], delta);
}
int getSubtree(int x) {
	return tree1.get(tin[x], tout[x]);
}
int getVertex(int x) {
	return tree1.get(tin[x], tin[x]);
}
int getPath(int x) {
	return tree2.get(tin[x]);
}
void clearVertex(int x) {
	if (getVertex(x)) {
		updVertex(x, -1);
	}
	for (auto e : bad[x]) {
		updVertex(e, -1);
		// good[x].insert(e);
	}
	// bad[x].clear();
}
inline bool isPred(int &a, int &b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
void propVertex(int x, int from) {
	updVertex(x, -1);
	for (auto e : good[x]) {
		if (!isPred(e, from)) {
			updVertex(e, 1);
			// bad[x].insert(e);
			// nowGood.pb(e);
		}
	}
	// for (auto e : nowGood) {
	// 	good[x].erase(e);
	// }
}
// int find(int x) {
// 	for (int i = LG - 1; i >= 0; --i) {
// 		int to = LCA[x][i];
// 		if (getPath(to) == getPath(x)) {
// 			x = to;
// 		}
// 	}
// 	return x;
// }
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n;
	pred[0] = -1;
	FOR(i, n - 1) {
		int p;
		std::cin >> p;
		--p;
		g[p].pb(i + 1);
		pred[i + 1] = p;
	}
	FOR(i, n) {
		for (auto e : g[i]) {
			good[i].insert(e);
		}
	}
	dfs(0);
	int q;
	std::cin >> q;
	FOR(QUERY, q) {
		int t, x;
		std::cin >> t >> x;
		if (t == 1) {
			--x;
			int delta = 1 - getVertex(x);
			updVertex(x, delta);
		}
		if (t == 2) {
			--x;
			int last = x;
			while (x != -1) {
				// debug(x)
				if (getVertex(x)) {
					// debug(x << ' ' << last)
					propVertex(x, last);
				}
				last = x;
				x = pred[x];
			}
		}
		if (t == 3) {
			--x;
			clearVertex(x);
		}
		if (t == 4) {
			--x;
			std::cout << getSubtree(x) << '\n';
		}
	}
}