#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 100;
int pred[N], used[N];
std::vector<int> g[N];
int dfs(int v) {
	int s = 0;
	for (auto e : g[v]) {
		s += dfs(e);
	}
	return s + used[v];
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n;
	std::cin >> n;
	pred[0] = -1;
	FOR(i, n - 1) {
		int p;
		std::cin >> p;
		--p;
		g[p].pb(i + 1);
		pred[i + 1] = p;
	}
	int q;
	std::cin >> q;
	FOR(QUERY, q) {
		int t, x;
		std::cin >> t >> x;
		if (t == 1) {
			--x;
			used[x] = 1;
		}
		if (t == 2) {
			--x;
			int last = x;
			while (x != -1) {
				if (used[x]) {
					for (auto e : g[x]) {
						if (e != last) {
							used[e] = 1;
							// debug(x << ' ' << e)
						}
					}
				}
				used[x] = 0;
				last = x;
				x = pred[x];
				// debug(x);
			}
		}
		if (t == 3) {
			--x;
			used[x] = 0;
			for (auto e : g[x]) {
				used[e] = 0;
			}
		}
		if (t == 4) {
			--x;
			std::cout << dfs(x) << '\n';
		}
	}
}