#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 100;
int pred[N], used[N], tin[N], tout[N], timer = 0;
std::vector<int> g[N];
struct seg_tree
{
	int tree[4 * N], push[4 * N];
	void doPush(int v, int tl, int tr) {
		tree[v] += push[v] * (tr - tl + 1);
		if (2 * v < 4 * N) {
			push[2 * v] += push[v];
			push[2 * v + 1] += push[v];
		}
		push[v] = 0;
	}
	void upd(int v, int tl, int tr, int l, int r, int x) {
		doPush(v, tl, tr);
		if (l > r) return;
		if (tl == l && tr == r) {
			push[v] += x;
			doPush(v, tl, tr);
			return;
		}
		int tm = (tl + tr) / 2;
		upd(v * 2, tl, tm, l, std::min(r, tm), x);
		upd(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r, x);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
	int get(int v, int tl, int tr, int l, int r) {
		if (l > r) return 0;
		doPush(v, tl, tr);
		if (tl == l && tr == r) {
			return tree[v];
		}
		int tm = (tl + tr) / 2;
		return get(v * 2, tl, tm, l, std::min(r, tm)) + get(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r);
	}
};
seg_tree tree;
int n;
void dfs(int v) {
	tin[v] = timer++;
	for (auto e : g[v]) {
		dfs(e);
	}
	tout[v] = timer;
}
int getSubtree(int x) {
	return tree.get(1, 0, n, tin[x], tout[x]);
}
int getVertex(int x) {
	return tree.get(1, 0, n, tin[x], tin[x]);
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n;
	pred[0] = -1;
	FOR(i, n - 1) {
		int p;
		std::cin >> p;
		--p;
		g[p].pb(i + 1);
		pred[i + 1] = p;
	}
	dfs(0);
	// FOR(i, n) {
	// 	debug(tin[i] << ' ' << tout[i])
	// }
	int q;
	std::cin >> q;
	FOR(QUERY, q) {
		int t, x;
		std::cin >> t >> x;
		if (t == 1) {
			--x;
			int delta = 1 - getVertex(x);
			tree.upd(1, 0, n - 1, tin[x], tin[x], delta);
		}
		// if (t == 2) {
		// 	--x;
		// 	int last = x;
		// 	while (x != -1) {
		// 		if (used[x]) {
		// 			for (auto e : g[x]) {
		// 				if (e != last) {
		// 					used[e] = 1;
		// 					// debug(x << ' ' << e)
		// 				}
		// 			}
		// 		}
		// 		used[x] = 0;
		// 		last = x;
		// 		x = pred[x];
		// 		// debug(x);
		// 	}
		// }
		// if (t == 3) {
		// 	--x;
		// 	used[x] = 0;
		// 	for (auto e : g[x]) {
		// 		used[e] = 0;
		// 	}
		// }
		if (t == 4) {
			--x;
			std::cout << getSubtree(x) << '\n';
		}
	}
}