#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double float80;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAX_N = 5e5 + 10;

vector<int> edges[MAX_N];
int seenBefore[MAX_N];

int answer[MAX_N], glans;

int n;
int perm[4];

pair<int, int> ce[MAX_N];
int cei;
int cv[MAX_N], cvi;

void buildAns(int l, int r) {
	// cout << l << " " << r << endl;
	cei = 0;
	cvi = 0;
	bool isConnected = true;
	bool hasEdge = false;
	int curr = l;
	if (seenBefore[l] != 0 && edges[l][seenBefore[l] - 1] == r) {
		--seenBefore[l];
		hasEdge = true;
	}
	int iterations = 0;
	while (curr != r) {
		// cout << curr << endl;
		cv[cvi++] = curr;
		if (seenBefore[curr] == 0) {
			isConnected = false;
			// ce.push_back({curr, -1});
			++curr;
		} else {
			int next = edges[curr][seenBefore[curr] - 1];
			ce[cei++] = {curr, next};
			curr = next;
		}
		++iterations;
	}
	cv[cvi++] = r;
	int oldl = answer[l], oldr = answer[r];
	int color = 1;
	for (int i = 0; i < cvi; ++i) {
		int u = cv[i];
		answer[u] = color;
		color = 3 - color;
	}
	// for (int i = 0; i < n; ++i)
	// 	cout << answer[i] << " ";
	// cout << "\n";
	if (hasEdge) {
		if (answer[r] == answer[l]) {
			if (isConnected) {
				answer[r] = 3;
			} else {
				int prev = r;
				if (cei) {
					int currit = cei - 1;
					while (currit >= 0 && ce[currit].y == prev) {
						answer[prev] = 3 - answer[prev];
						prev = ce[currit].x;
						--currit;
					}
				}
				answer[prev] = 3 - answer[prev];
			}
		}
	}
	if (oldl) {
		perm[answer[l]] = oldl;
		perm[answer[r]] = oldr;
		perm[6 - answer[l] - answer[r]] = 6 - oldl - oldr;
		for (int i = 0; i < cvi; ++i) {
			int v = cv[i];
			answer[v] = perm[answer[v]];
		}
	}
	curr = l;
	while (curr != r) {
		if (seenBefore[curr] == 0) {
			++curr;
		} else {
			int next = edges[curr][seenBefore[curr] - 1];
			buildAns(curr, next);
			curr = next;
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		--a, --b;
		edges[a].push_back(b);
	}
	for (int i = 0; i < n; ++i) {
		sort(all(edges[i]));
		seenBefore[i] = edges[i].size();
	}
	buildAns(0, n - 1);
	cout << *max_element(answer, answer + n) << "\n";
	for (int i = 0; i < n; ++i)
		cout << answer[i] << " ";
	cout << "\n";
	return 0;
}