#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double float80;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAX_N = 5e5 + 10;

vector<int> edges[MAX_N];

int answer[MAX_N];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		--a, --b;
		edges[b].push_back(a);
		// cout << b << " -> " << a << "\n";
	}
	for (int i = 0; i < n; ++i) {
		vector<int> used;
		for (int v : edges[i])
			used.push_back(answer[v]);
		for (int j = 0; j < n;  ++j) {
			if (find(all(used), j) == end(used)) {
				answer[i] = j;
				break;
			}
		}
	}
	cout << *max_element(answer, answer + n) + 1 << "\n";
	for (int i = 0; i < n; ++i)
		cout << answer[i] + 1 << " ";
	cout << "\n";
	return 0;
}