#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 3e5 + 10;

int cnt_paths = 1, timer, type[N], pos[N], pr[N], path_begin[N], cp[N], n;
vector<int> pth[N];

vector<int> g[N];
vector<int> order;
int sz[N], vl[N], t[N];

void upd(int v, int delta) {
	for (; v <= n; v += v & -v) {
		t[v] += delta;
	}
}

int get(int v) {
	int res = 0;
	for (; v > 0; v -= v & (-v)) {
		res += t[v];
	}
	return res;
}

int get_sum(int l, int r) {
	return get(r) - get(l - 1);
}

void precalc(int v) {
	order.pb(v);
	pos[v] = SZ(order);
	sz[v] = 1;
	for (auto u : g[v]) {
		precalc(u);
		sz[v] += sz[u];
	}
}

void query1(int v) {
	if (!vl[v]) {
		vl[pos[v]] = 1;
		upd(pos[v], 1);
	}
}

void query2(int v) {
	int prv = -1;
	while (v != 0) {
		if (vl[pos[v]] == 1) {
			vl[pos[v]] = 0;
			upd(pos[v], -1);
			for (auto u : g[v]) {
				if (prv != u && vl[pos[u]] == 0) {
					vl[pos[u]] = 1;
					upd(pos[u], 1);
				}
			}
		}
		prv = v;
		v = pr[v]; 
	}
}

void query3(int v) {
	if (vl[pos[v]] == 1) {
		vl[pos[v]] = 0;
		upd(pos[v], -1);
	}
	for (auto u : g[v]) {
		if (vl[pos[u]] == 1) {
			vl[pos[u]] = 0;
			upd(pos[u], -1);
		}
	}
}

int query4(int v) {
	return get_sum(pos[v], pos[v] + sz[v] - 1);
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 2; i <= n; i++) {
		cin >> pr[i];
		g[pr[i]].pb(i);
	}
	int q;
	cin >> q;
	precalc(1);
	for (int i = 0; i < q; i++) {
		int tp, v;
		cin >> tp >> v;
		if (tp == 1) {
			query1(v);
		}
		if (tp == 2) {
			query2(v);
		}
		if (tp == 3) {
			query3(v);
		}
		if (tp == 4) {
			cout << query4(v) << '\n';
		}
	}
}