#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 3e5 + 10;

int cnt_paths = 1, timer, type[N], pos[N], pr[N], path_begin[N], cp[N], n;
vector<int> pth[N];

vector<int> g[N];
vector<int> order;
int sz[N], vl[N]	;

int t[4 * N], f[4 * N];

void push(int v, int l, int r) {
	if (f[v] != -1) {
		int mid = (l + r) /2 ;
		f[2 * v] = f[v];
		f[2 * v + 1] = f[v];
		t[2 * v] = f[v] * (mid - l + 1);
		t[2 * v + 1] = f[v] * (r - mid);
		f[v] = -1;	
	}
}

void build(int v, int l, int r) {
	t[v] = 0;
	f[v] = -1;
	if (l == r) {
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
}

void update(int v, int l, int r, int a, int b, int val) {
	if (l > b || r < a) {
		return;
	}
	if (l>= a && r <= b) {
		t[v] = val * (r - l + 1);
		f[v] = val;
		return;
	}
	push(v, l, r);
	int mid = (l + r) / 2;
	update(2 * v, l, mid, a, b, val);
	update(2 * v + 1, mid + 1, r,a , b, val);
	t[v] = t[2 * v] + t[2 * v + 1];
	//cout << v << ' ' << l << ' ' << r  << ' ' << t[v] << '\n';
}

int get_sum(int v, int l, int r, int a, int b) {
	if (l > b || r < a) {
		return 0;
	}
	if (l >= a && r <= b) {
		return t[v];
	}
	push(v, l, r);
	int mid = (l + r) / 2;
	return get_sum(2 * v, l, mid, a, b) + get_sum(2 * v + 1, mid + 1, r, a, b);
}

void precalc(int v) {
	for (auto u : g[v]) {
		order.pb(u);
		pos[u] = SZ(order);
	}
	sz[v] = 1;
	for (auto u : g[v]) {
		precalc(u);
		sz[v] += sz[u];
	}
}

void query1(int v) {
	//cout << pos[v] << '\n';
	update(1, 1, n, pos[v], pos[v], 1);
}

void query2(int v) {
	int prv = -1;
	while (v != 0) {
		if (get_sum(1, 1, n, pos[v], pos[v]) == 1) {
			update(1, 1, n, pos[v], pos[v], 0);
		for (auto u : g[v]) {
			if (u != prv) update(1, 1, n, pos[u], pos[u], 1);
		}
		}
		prv = v;
		v = pr[v]; 
	}
}

void query3(int v) {
	update(1, 1, n, pos[v], pos[v] + SZ(g[v]), 0);
}

int query4(int v) {
	return get_sum(1, 1, n, pos[v], pos[v] + sz[v] - 1);
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	order.pb(1);
	pos[1] = 1;
	cin >> n;
	for (int i = 2; i <= n; i++) {
		cin >> pr[i];
		g[pr[i]].pb(i);
	}
	int q;
	cin >> q;
	precalc(1);
	build(1, 1, n);
	for (int i = 0; i < q; i++) {
		int tp, v;
		cin >> tp >> v;
		if (tp == 1) {
			query1(v);
		}
		if (tp == 2) {
			query2(v);
		}
		if (tp == 3) {
			query3(v);
		}
		if (tp == 4) {
			cout << query4(v) << '\n';
		}
	}
}