#include <bits/stdc++.h>
using namespace std;

vector <int> graf[300005];
int parent[300005];
int val[300005];

int seg[2000005];

int vr, n;

int in[300005];
int out[300005];
int iz[300005];

void dfs(int v){
	in[v] = ++vr;
	iz[in[v]] = v;
	for(auto c : graf[v]){
		dfs(c);
	}
	out[v] = vr;
}

void upd(int node, int l, int r, int x){
	if(l == r){
		seg[node] = val[iz[x]];
		return;
	}
	int mid = (l+r)/2;
	if(x <= mid) upd(node*2, l, mid, x);
	else upd(node*2+1, mid+1, r, x);
	seg[node] = seg[node*2] + seg[node*2+1];
}

int query(int node, int l, int r, int tl, int tr){
	if(l > tr || tl > r) return 0;
	if(tl <= l && r <= tr) return seg[node];
	int mid = (l+r)/2;
	return query(node*2, l, mid, tl, tr) + query(node*2+1, mid+1, r, tl, tr);
}

void query2(int v){
	int org = v;
	while(v){
		for(auto c : graf[v]){
			if(!val[c]){
				val[c] |= val[v];
				upd(1, 1, n, in[c]);
			}
		}
		v = parent[v];
	}
	v = org;
	while(v){
		val[v] = 0;
		upd(1, 1, n, in[v]);
		v = parent[v];
	}
}

void query3(int v){
	if(val[v]){
		val[v] = 0;
		upd(1, 1, n, in[v]);
	}
	for(auto c : graf[v]){
		if(val[c]){
			val[c] = 0;
			upd(1, 1, n, in[c]);
		}
	}
}

int query4(int v){
	return query(1, 1, n, in[v], out[v]);
}

int main(int argc, char **argv){
	
	cin >> n;
	for(int i=2; i<=n; i++){
		cin >> parent[i];
		graf[parent[i]].push_back(i);
	}
	dfs(1);
	int q;
	cin >> q;
	while(q--){
		int t;
		cin >> t;
		if(t == 1){
			int v;
			cin >> v;
			val[v] = 1;
			upd(1, 1, n, in[v]);
		}
		if(t == 2){
			int v;
			cin >> v;
			query2(v);
		}
		if(t == 3){
			int v;
			cin >> v;
			query3(v);
		}
		if(t == 4){
			int v;
			cin >> v;
			cout << query4(v) << "\n";
		}
		//for(int i=1; i<=n; i++) cout << val[i] << " ";
		//cout << endl;
	}
	return 0;
}

