#include <bits/stdc++.h>
using namespace std;

int par[300005];
int val[300005];
vector <int> graf[300005];
int seg[2000005];

int vr;

int in[300005];
int out[300005];

void dfs(int v){
	in[v] = ++vr;
	for(auto c : graf[v]){
		dfs(c);
	}
	out[v] = ++vr;
}

void upd(int node, int l, int r, int x){
	if(l == r){
		seg[node] = 1;
		return;
	}
	int mid = (l+r)/2;
	if(x <= mid) upd(node*2, l, mid, x);
	else upd(node*2+1, mid+1, r, x);
	seg[node] = seg[node*2] + seg[node*2+1];
}

int query(int node, int l, int r, int tl, int tr){
	if(l > tr || tl > r) return 0;
	if(tl <= l && r <= tr) return seg[node];
	int mid = (l+r)/2;
	return query(node*2, l, mid, tl, tr) + query(node*2+1, mid+1, r, tl, tr);
}

int main(){
	ios_base::sync_with_stdio(false);
	
	int n;
	cin >> n;
	for(int i=2; i<=n; i++){
		cin >> par[i];
		graf[par[i]].push_back(i);
	}
	dfs(1);
	int q;
	cin >> q;
	while(q--){
		int t;
		cin >> t;
		if(t == 1){
			int v;
			cin >> v;
			upd(1, 1, 2*n, in[v]);
		}
		if(t == 2){
		}
		if(t == 3){
		}
		if(t == 4){
			int v;
			cin >> v;
			cout << query(1, 1, 2*n, in[v], out[v]) << "\n";
		}
	}
	return 0;
}

