#include <bits/stdc++.h>
#define SEG (1<<18)
using namespace std;

struct segtr
{
    int l[2*SEG],r[2*SEG],val[2*SEG];

    void init()
    {
        for(int i=SEG;i<2*SEG;i++)
        {
            l[i]=i-SEG,r[i]=i-SEG;
            val[i]=0;
        }
        for(int i=SEG-1;i>0;i--)
        {
            l[i]=l[2*i];
            r[i]=r[2*i+1];
            val[i]=0;
        }
    }

    void update(int idx,int x)
    {
        val[SEG+idx]=x;
        for(int i=(SEG+idx)/2;i>0;i/=2)
        {
            val[i]=val[2*i]+val[2*i+1];
        }
    }

    int calc(int i,int lt,int rt)
    {
        if(l[i]>=lt && r[i]<=rt)
        {
            return val[i];
        }
        if(r[i]<lt || l[i]>rt)
        {
            return 0;
        }
        else
        {
            return calc(2*i,lt,rt)+calc(2*i+1,lt,rt);
        }
    }
} str;

int n,q,in1,in2,otac[300005],idx[300005],rng[300005];
vector<int> sinovi[300005];
bool infested[300005];

int glb=0;
void dfs_init(int cur)
{
    idx[cur]=glb;
    glb++;
    for(auto i:sinovi[cur])
    {
        dfs_init(i);
    }
    rng[cur]=glb-1;
}

int dfs(int cur,bool dest)
{
    if(dest)
    {
        infested[cur]=0;
        str.update(idx[cur],0);
    }
    int ret=0;
    for(auto i:sinovi[cur])
    {
        ret+=dfs(i,dest);
    }
    return ret+infested[cur];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=1;i<n;i++)
    {
        cin>>in1;
        otac[i+1]=in1;
        sinovi[in1].push_back(i+1);
    }
    str.init();
    dfs_init(1);
    cin>>q;
    while(q--)
    {
        cin>>in1>>in2;
        if(in1==1)
        {
            infested[in2]=1;
            str.update(idx[in2],1);
        }
        else if(in1==2)
        {
            int tmp=in2,lst=0;
            while(tmp!=0)
            {
                for(auto i:sinovi[tmp])
                {
                    if(!infested[tmp])
                    {
                        break;
                    }
                    if(i!=lst)
                    {
                        infested[i]=1;
                        str.update(idx[i],1);
                    }
                }
                infested[tmp]=0,str.update(idx[tmp],0),lst=tmp,tmp=otac[tmp];
            }
        }
        else if(in1==3)
        {
            infested[in2]=0;
            str.update(idx[in2],0);
            for(auto i:sinovi[in2])
            {
                infested[i]=0;
                str.update(idx[i],0);
            }
        }
        else
        {
            cout<<str.calc(1,idx[in2],rng[in2])<<"\n";
        }
    }
}
