#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define lld long long
#define mid (l+r)/2
#define endl '\n'
#define pii pair<int,int>
#define pli pair<lld,int>
#define pil pair<int,lld>
#define pll pair<lld,lld>
#define fi first
#define se second
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 500010
int N, M, col[MAXN], pos[MAXN];
vector<int> adj[MAXN];
vector<pii> e;
bool bipartite;
void dfs(int node, int boj) {
    col[node] = boj;
    for(auto x : adj[node]) {
        if(col[x] == -1) dfs(x, 3^boj);
    }
}
int main() {
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
    cin >> N >> M;
    if(M == 0) {
        cout << 1 << endl;
        for(int i = 1; i <= N; i++) cout << 1 << ' ';
        cout << endl;
        return 0;
    }
    for(int i = 1; i <= M; i++) {
        int x,y; cin >> x >> y;
        e.pb({x, y});
        adj[x].pb(y);
        adj[y].pb(x);
    }
    for(int mask = 0; mask < (1<<N); mask++) {
        for(int i = 1; i <= N; i++) col[i] = -1;
        for(int i = 0; i < N; i++) {
            if((1<<i)&mask) col[i+1] = 3;
        }
        for(int i = 1; i <= N; i++) {
            if(col[i] == -1) dfs(i, 1);
        }
        bool valid = 1;
        for(auto x : e) {
            if(col[x.fi] == col[x.se]) valid = 0;
        }
        if(valid) {
            cout << (mask == 0 ? 2:3) << endl;
            for(int i = 1; i <= N; i++) cout << col[i] << ' ';
            return 0;
        }
    }
    return 0;
}
