#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define mid (l+r)/2
#define endl '\n'
#define lld long long
#define pii pair<int,int>
#define pli pair<lld,int>
#define pil pair<int,lld>
#define pll pair<lld,lld>
#define fi first
#define se second
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 500010
int N, M, col[MAXN], pos[MAXN];
vector<int> adj[MAXN], adj1[MAXN];
vector<pii> e;
bool bipartite;
int dfs(int node, int boj, int boj1, int boj2, vector<int> adj[]) {
    col[node] = boj; pos[node] = 1;
    for(auto x : adj[node]) {
        if(!pos[x]) {
            if(boj == boj1) dfs(x, boj2, boj1, boj2, adj);
            if(boj == boj2) dfs(x, boj1, boj1, boj2, adj);
        }
    }
}
int main() {
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
    cin >> N >> M;
    if(M == 0) {
        cout << 1 << endl;
        for(int i = 1; i <= N; i++) cout << 1 << ' ';
        return 0;
    }
    for(int i = 1; i <= M; i++) {
        int x,y; cin >> x >> y;
        e.pb({x, y});
        adj[x].pb(y);
        adj[y].pb(x);
    }
    for(int i = 1; i <= N; i++) col[i] = -1;
    bipartite = 1;
    for(int i = 1; i <= N; i++) {
        if(!pos[i]) dfs(i, 1, 1, 2, adj);
    }
    for(auto x : e) {
        if(col[x.fi] == col[x.se]) {
            bipartite = 0;
            adj1[x.fi].pb(x.se);
            adj1[x.se].pb(x.fi);
        }
    }
    if(bipartite) {
        cout << 2 << endl;
        for(int i = 1; i <= N; i++) cout << col[i] << ' ';
        return 0;
    }
    for(int i = 1; i <= N; i++) pos[i] = 0;
    for(int i = 1; i <= N; i++) {
        if(col[i] == 1 && !pos[i]) dfs(i, 1, 1, 3, adj1);
    }
    for(int i = 1; i <= N; i++) {
        if(col[i] == 2 && !pos[i]) {
            bool susedTri = 0;
            for(auto x : adj[i]) if(col[x] == 3) susedTri = 1;
            if(susedTri) dfs(i, 2, 2, 3, adj1);
            else dfs(i, 3, 2, 3, adj1);
        }
    }
    cout << 3 << endl;
    for(int i = 1; i <= N; i++) cout << col[i] << ' ';
    return 0;
}
