#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
#define pb push_back
const int N=500050;
const int H=1005;
int U[N*2],V[N*2],ans[N],tmp[N],n,m;
vector<int> E[N];
void Solve(int L, int R, int l, int r)
{
	if(l>r) return;
	int i_l=lower_bound(E[L].begin(),E[L].end(),l)-E[L].begin();
	int i_r=lower_bound(E[R].begin(),E[R].end(),l)-E[R].begin();
	int last=L,st=l;
	vector<int> ls,rs,all;
	bool ok=0;
	while(1)
	{
		int u=i_l<E[L].size()?E[L][i_l]:r+1;
		int v=i_r<E[R].size()?E[R][i_r]:r+1;
		//printf("%i %i\n",u,v);
		if(u>r && v>r) break;
		if(u==v)
		{
			ans[u]=ans[L]^ans[R];
			i_l++;
			i_r++;
			ok=1;
			all.pb(u);
		}
		else if(u<v)
		{
			ans[u]=ans[R];
			i_l++;
			ls.pb(u);
			all.pb(u);
		}
		else
		{
			ans[v]=ans[L];
			i_r++;
			rs.pb(v);
			all.pb(v);
		}
	}

	if(ok || ls.size() && rs.size())
	{
		reverse(ls.begin(),ls.end());
		int col=ans[R];
		for(int i:ls) ans[i]=col,col^=ans[L];
		col=ans[L];
		for(int i:rs) ans[i]=col,col^=ans[R];
	}
	else
	{
		reverse(ls.begin(),ls.end());
		int col=ans[R]^ans[L];
		for(int i:ls) ans[i]=col,col^=ans[L];
		col=ans[L]^ans[R];
		for(int i:rs) ans[i]=col,col^=ans[R];
	}

	for(int i:all)
	{
		Solve(last,i,st,i-1);
		assert(ans[i]!=ans[last]);
		st=i+1;
		last=i;
	}

	if(L!=last) Solve(last,R,st,r);
}
bool was[N],ok=1;
void DFS(int u)
{
	was[u]=1;
	for(int v:E[u])
	{
		if(!was[v])
		{
			ans[v]=3-ans[u];
			DFS(v);
		}
		else if(ans[u]==ans[v]) ok=0;
	}
}
bool Check2()
{
	for(int i=1;i<=n;i++) if(!was[i])
	{
		ans[i]=1;
		DFS(i);
	}
	if(!ok) for(int i=1;i<=n;i++) ans[i]=0;
	return ok;
}
int id[N*2];
void Solve()
{
	sort(id,id+m*2,[&](int i, int j){ return V[i]<V[j];});
    for(int i=0;i<m*2;++i)
	{
		E[U[id[i]]].pb(V[id[i]]);
	}
	if(Check2()) return;
	//for(int i=1;i<=n;i++) sort(E[i].begin(),E[i].end());
	for(int i=1;i<=n;++i) if(!ans[i])
	{
		if(E[i].empty()){ ans[i]=1;continue;}
		int L=i,R=E[i][0];
		ans[L]=1;ans[R]=2;
		Solve(L,R,L+1,R-1);
		Solve(R,L,R+1,n);
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    //scanf("%i %i",&n,&m);
    cin>>n>>m;
    //for(int i=0;i<m;i++) scanf("%i %i",&U[i<<1],&V[i<<1]),U[i<<1|1]=V[i<<1],V[i<<1|1]=U[i<<1];
    for(int i=0;i<m;++i) cin>>U[i<<1]>>V[i<<1],U[i<<1|1]=V[i<<1],V[i<<1|1]=U[i<<1];
    for(int i=0;i<m*2;++i) id[i]=i;
	Solve();
	int mx=0;
	for(int i=1;i<=n;++i) mx=max(mx,ans[i]);
	printf("%i\n",mx);
	for(int i=1;i<=n;++i) printf("%i ",ans[i]);
    printf("\n");
    return 0;
}
